﻿<%@ Page Language="C#" AutoEventWireup="true"
    MasterPageFile="~/MasterFile/TimeCheck.master"
    CodeFile="EmployeePanel.aspx.cs" Inherits="EmployeePanel" %>

<%@ Register TagPrefix="dxGridview" Namespace="DevExpress.Web" Assembly="DevExpress.Web.v14.2" %>
<asp:Content ID="Content1" ContentPlaceHolderID="BodyContentPH" runat="Server">
    <meta content="width=device-width, initial-scale=1, maximum-scale=1, user-scalable=no" name="viewport">
    <link rel="stylesheet" href="plugins/fullcalendar/fullcalendar.min.css">
    <link rel="stylesheet" href="plugins/fullcalendar/fullcalendar.print.css" media="print">

    <script src="bootstrap/js/bootstrap.min.js" type="text/javascript"></script>
    <link href="dist/css/bootstrap-responsive-tabs.css" rel="stylesheet" type="text/css">
    <script src="dist/js/jquery.bootstrap-responsive-tabs.min.js"></script>

    <script src="plugins/moment.min.js" type="text/javascript"></script>
    <script src="plugins/fullcalendar/fullcalendar.min.js"></script>
    <script src="js/GetNotification.js"></script>
    <script src="js/GetMycalendardata.js"></script>

    <script>
        function clickUserMycalendar(id) {
            if (id == 1) {
                $('#tablist a[href="#ctl00_BodyContentPH_tab1"]').tab('show');
                $('html, body').animate({ scrollTop: 0 }, 'slow');
            }
            else if (id == 3) {
                $('#tablist a[href="#ctl00_BodyContentPH_tab3"]').tab('show');
                $('html, body').animate({ scrollTop: 0 }, 'slow');
            }
            else if (id == 4) {
                $('#tablist a[href="#ctl00_BodyContentPH_tab4"]').tab('show');
                $('html, body').animate({ scrollTop: 0 }, 'slow');
            }
            else if (id == 5) {
                $('#tablist a[href="#ctl00_BodyContentPH_tab5"]').tab('show');
                $('html, body').animate({ scrollTop: 0 }, 'slow');
            }
            else if (id == 6) {
                $('#tablist a[href="#ctl00_BodyContentPH_tab6"]').tab('show');
                $('html, body').animate({ scrollTop: 0 }, 'slow');
            }
        }
        function clickTeamcalendar() {
            $('#tablist a[href="#ctl00_BodyContentPH_tab2"]').tab('show');
            $('html, body').animate({ scrollTop: 0 }, 'slow');
        }

        function clickIndividualUser() {
            GetIndividualCalendar();
        }
        function clickTeam() {
            GetTeamCalendar(<%= Session["EmpAutoID"].ToString() %>);
        }

        document.onreadystatechange = function () {
            if (document.readyState === 'complete') {
                debugger;
                clickTeam();
                clickIndividualUser();
            }
        }
    </script>
    <section class="content-header">
        <h1 style="padding-right: 0px">
            <img src="dist/img/MyCalendar.png" style="padding-right: 10px; vertical-align: middle; padding-bottom: 2px" />
            <asp:Label ID="lbl_Header" runat="server" Text="User Profile"></asp:Label>
        </h1>
        <asp:SiteMapPath ID="site" runat="server" CssClass="breadcrumb">
            <NodeStyle CssClass="active" />
        </asp:SiteMapPath>
    </section>
    <section class="content">
        <div class="row">
            <div class="col-md-3">
                <div class="box box-primary">
                    <div class="box-body box-profile">
                        <img class="profile-user-img img-responsive img-circle" src="LoginImage/emp-photo.png" alt="User profile picture">
                        <h3 class="profile-username text-center">Manikandan.R</h3>
                        <p class="text-muted text-center">Product Leader</p>
                        <ul class="list-group list-group-unbordered">
                            <li class="list-group-item">
                                <b>Reporting To</b> <a class="pull-right">1,322</a>
                            </li>
                            <li class="list-group-item">
                                <b>Sanction To</b> <a class="pull-right">543</a>
                            </li>
                        </ul>
                        <a href="#" class="btn btn-primary btn-block"><b>Edit Profile</b></a>
                    </div>
                </div>
                <div class="box box-primary">
                    <div class="box-header with-border">
                        <h3 class="box-title">My Team</h3>
                    </div>
                    <div class="box-body">
                    </div>
                </div>
                <div class="box box-primary">
                    <div class="box-header with-border">
                        <h3 class="box-title">Absent Team Member</h3>
                    </div>
                    <div class="box-body">
                    </div>
                </div>
            </div>
            <div class="col-md-9">
                <div class="respos-tab1">
                    <div class="responsive-tabs tab-header">
                        <ul class="nav nav-tabs responsive-tabs tab-header" id="tablist">
                            <li id="liTeamcalendar" visible="false" runat="server" class="pull-left" style="border-left: thick; border-color: #C1E8FC">
                                <a href="#ctl00_BodyContentPH_tab2" class="fa fa-users" onclick="return clickTeamcalendar();" style="color: green; font-size: larger">
                                    <asp:Label ID="lblTeam" runat="server" Text="Team" Style="font-family: robotoregular; font-size: 13px; color: black"></asp:Label><asp:Label ID="lbl_TotEmployee" runat="server" Text=""></asp:Label>
                                </a>
                            </li>
                            <li id="liUserMycalendar" runat="server" class="pull-left" style="border-left: thick; border-left-width: initial; border-color: #C1E8FC">
                                <a href="#ctl00_BodyContentPH_tab1" class="fa fa-user" onclick="return clickUserMycalendar(1);" style="color: red; font-size: larger">
                                    <asp:Label ID="lblIndividual" runat="server" Text="Individual" Style="font-family: robotoregular; font-size: 13px; color: black"></asp:Label>
                                </a>
                            </li>
                            <li id="li1" runat="server" class="pull-left" style="border-left: thick; border-left-width: initial; border-color: #C1E8FC">
                                <a href="#ctl00_BodyContentPH_tab3" onclick="return clickUserMycalendar(3);" style="color: red; font-size: larger">
                                    <asp:Label ID="Label1" runat="server" Text="My Recent Swipes" Style="font-family: robotoregular; font-size: 13px; color: black"></asp:Label>
                                </a>
                            </li>
                            <li id="li2" runat="server" class="pull-left" style="border-left: thick; border-left-width: initial; border-color: #C1E8FC">
                                <a href="#ctl00_BodyContentPH_tab4" onclick="return clickUserMycalendar(4);" style="color: red; font-size: larger">
                                    <asp:Label ID="Label2" runat="server" Text="My Approvals" Style="font-family: robotoregular; font-size: 13px; color: black"></asp:Label>
                                </a>
                            </li>
                            <li id="li3" runat="server" class="pull-left" style="border-left: thick; border-left-width: initial; border-color: #C1E8FC">
                                <a href="#ctl00_BodyContentPH_tab5" onclick="return clickUserMycalendar(5);" style="color: red; font-size: larger">
                                    <asp:Label ID="Label3" runat="server" Text="Holiday List" Style="font-family: robotoregular; font-size: 13px; color: black"></asp:Label>
                                </a>
                            </li>
                            <li id="li4" runat="server" class="pull-left" style="border-left: thick; border-left-width: initial; border-color: #C1E8FC">
                                <a href="#ctl00_BodyContentPH_tab6" onclick="return clickUserMycalendar(6);" style="color: red; font-size: larger">
                                    <asp:Label ID="Label4" runat="server" Text="Balance Leaves" Style="font-family: robotoregular; font-size: 13px; color: black"></asp:Label>
                                </a>
                            </li>
                        </ul>
                    </div>
                    <div class="tab-content">
                        <!--TAB 1-->
                        <div class="tab-pane active" id="tab1" runat="server">
                            <div class="form-horizontal">
                                <div class="row">
                                    <div class="col-md-12">
                                        <div class="col-md-12">
                                            <div class="col-md-12">
                                                <i class="fa fa-square" style="color: #008247; font-size: 16px"></i>&nbsp;&nbsp;<asp:Label ID="lblPresent" runat="server" />&nbsp;&nbsp;
                                                <i class="fa fa-square" style="color: #FF5151; font-size: 16px"></i>&nbsp;&nbsp;<asp:Label ID="lblAbsent" runat="server" />&nbsp;&nbsp;
                                                <i class="fa fa-square" style="color: #D0457B; font-size: 16px"></i>&nbsp;&nbsp;<asp:Label ID="lblLeave" runat="server" />&nbsp;&nbsp;
                                                <i class="fa fa-square" style="color: #FF7F00; font-size: 16px"></i>&nbsp;&nbsp;<asp:Label ID="lblHoliday" runat="server" />&nbsp;&nbsp;
                                                <i class="fa fa-square" style="color: #02749E; font-size: 16px"></i>&nbsp;&nbsp;<asp:Label ID="lblWeeklyOff" runat="server" />&nbsp;&nbsp;
                                                <i class="fa fa-square" style="color: #A9A9A9; font-size: 16px"></i>&nbsp;&nbsp;<asp:Label ID="lblcombination" runat="server" Text="Combined Attendance" />
                                            </div>
                                        </div>
                                        <div class="col-md-12">
                                            <div class="col-md-12">
                                                <div class="box box-primary">
                                                    <div class="box-body no-padding">
                                                        <div id="calendar"></div>
                                                    </div>
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="tab-pane" id="tab2" runat="server">
                            <div class="form-horizontal">
                                <div class="row">
                                    <div class="col-md-12">
                                        <div class="col-md-12">
                                            <div class="box box-primary">
                                                <div id="Teamcalendar"></div>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="tab-pane" id="tab3" runat="server">
                            <div class="form-horizontal">                                
                                <div class="row">
                                    <div class="col-md-12">
                                        <div class="col-md-12">
                                            <h4 class="box-title">Recent Punches of last 2 days</h4>
                                        </div>
                                    </div>
                                    <div class="col-md-12">
                                        <div class="col-md-12">
                                            <div class="box box-primary">
                                                <div id="My Recent Swipes">
                                                    <dxGridview:ASPxGridView ID="grvAttendancelast7Days" EnableCallBacks="false" runat="server"
                                                        ClientInstanceName="grvAttendancelast7Days" AutoGenerateColumns="false" KeyFieldName="Employee_Id">
                                                        <Columns>
                                                            <dxGridview:GridViewDataTextColumn Caption="Punch Date" FieldName="PunchDate"
                                                                VisibleIndex="0" Width="80px">
                                                                <Settings AllowDragDrop="false" AllowHeaderFilter="False" />
                                                                <DataItemTemplate>
                                                                    <asp:Label ID="lblDate" Text='<%# Eval("PunchDate") %>' runat="server"></asp:Label>
                                                                </DataItemTemplate>
                                                                <HeaderStyle HorizontalAlign="center" Wrap="true" />
                                                            </dxGridview:GridViewDataTextColumn>
                                                            <dxGridview:GridViewDataTextColumn FieldName="Punch Time" VisibleIndex="1"
                                                                Width="80px">
                                                                <Settings AllowDragDrop="false" AllowHeaderFilter="False" />
                                                                <DataItemTemplate>
                                                                    <asp:Label ID="lblIntime" Text='<%# Eval("PunchTime") %>' runat="server"></asp:Label>
                                                                </DataItemTemplate>
                                                                <HeaderStyle HorizontalAlign="center" Wrap="true" />
                                                            </dxGridview:GridViewDataTextColumn>
                                                            <dxGridview:GridViewDataTextColumn FieldName="Punch Type" VisibleIndex="2"
                                                                Width="80px">
                                                                <Settings AllowDragDrop="false" AllowHeaderFilter="False" />
                                                                <DataItemTemplate>
                                                                    <asp:Label ID="lblOutTime" Text='<%# Eval("PunchType") %>' runat="server"></asp:Label>
                                                                </DataItemTemplate>
                                                                <HeaderStyle HorizontalAlign="center" Wrap="true" />
                                                            </dxGridview:GridViewDataTextColumn>
                                                            <dxGridview:GridViewDataTextColumn FieldName="Terminal Name" VisibleIndex="3"
                                                                Width="80px">
                                                                <Settings AllowDragDrop="false" AllowHeaderFilter="False" />
                                                                <DataItemTemplate>
                                                                    <asp:Label ID="lblHrswork" Text='<%# Eval("Terminal_Name") %>' runat="server"></asp:Label>
                                                                </DataItemTemplate>
                                                                <HeaderStyle HorizontalAlign="center" Wrap="true" />
                                                            </dxGridview:GridViewDataTextColumn>                                                           
                                                        </Columns>
                                                        <SettingsText EmptyDataRow="No Records Found" />
                                                        <SettingsPager PageSize="100">
                                                        </SettingsPager>
                                                        <Settings GridLines="Both" />
                                                        <Settings ShowFilterRow="false" />
                                                        <SettingsBehavior AllowSort="false" AllowDragDrop="false" />
                                                        <Styles AlternatingRow-CssClass="table-bg">
                                                        </Styles>
                                                    </dxGridview:ASPxGridView>
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="tab-pane" id="tab4" runat="server">
                            <div class="form-horizontal">
                                <div class="row">
                                    <div class="col-md-12">
                                        <div class="col-md-12">
                                            <div class="box box-primary">
                                                <div id="My Approvals" style="padding-top: 20px;">
                                                    <table class="table das-table1" rules="all" id="ctl00_BodyContentPH_dgrdException" style="border-collapse: collapse;" cellspacing="0" border="1">
                                                        <tbody>
                                                            <tr>
                                                                <th class="head1 to-emp1 pad-lft HeaderWidth" scope="col">
                                                                    <span id="ctl00_BodyContentPH_dgrdException_ctl01_lblHeaderName">Total Employees : 0</span>
                                                                </th>
                                                                <th class="head1 count1" scope="col">
                                                                    <span id="ctl00_BodyContentPH_dgrdException_ctl01_lblHeadCount">Count</span>
                                                                </th>
                                                                <th class="head1 pre1" scope="col">%</th>
                                                                <th class="head1 excel1" scope="col">&nbsp;</th>
                                                                <th class="head1 pdf1" scope="col">&nbsp;</th>
                                                            </tr>
                                                            <tr>
                                                                <td valign="top">
                                                                    <input type="image" name="ctl00$BodyContentPH$dgrdException$ctl02$imgtips" id="ctl00_BodyContentPH_dgrdException_ctl02_imgtips" disabled="disabled" src="dist/img/icon1.jpg" style="border-width: 0px; vertical-align: middle; padding-right: 10px">

                                                                    <span id="ctl00_BodyContentPH_dgrdException_ctl02_lbltopic">Present</span>
                                                                </td>
                                                                <td class="pre1" align="center">
                                                                    <a onclick="return DateEntryValidation();" id="ctl00_BodyContentPH_dgrdException_ctl02_lblCount" href="javascript:__doPostBack('ctl00$BodyContentPH$dgrdException$ctl02$lblCount','')" style="color: Black;">0</a>

                                                                    <input type="hidden" name="ctl00$BodyContentPH$dgrdException$ctl02$hdfReportname" id="ctl00_BodyContentPH_dgrdException_ctl02_hdfReportname" value="MonthlyAttendance">
                                                                    <input type="hidden" name="ctl00$BodyContentPH$dgrdException$ctl02$hdfCount" id="ctl00_BodyContentPH_dgrdException_ctl02_hdfCount" value="0">
                                                                </td>
                                                                <td class="pre1" align="center">

                                                                    <span id="ctl00_BodyContentPH_dgrdException_ctl02_lnkpercent" style="color: Black;">0 %</span>
                                                                </td>
                                                                <td class="excel1" align="center">
                                                                    <input type="image" name="ctl00$BodyContentPH$dgrdException$ctl02$btnImagExcel" id="ctl00_BodyContentPH_dgrdException_ctl02_btnImagExcel" title="Export to Excel" data-toggle="tooltip" data-placement="top" src="dist/img/excel-icon.jpg" onclick="return DateEntryValidation();" style="border-width: 0px;">
                                                                </td>
                                                                <td class="pdf1" align="center">
                                                                    <input type="image" name="ctl00$BodyContentPH$dgrdException$ctl02$btnimgPDF" id="ctl00_BodyContentPH_dgrdException_ctl02_btnimgPDF" title="Export to PDF" data-toggle="tooltip" data-placement="top" src="dist/img/pdf-icon.jpg" onclick="return DateEntryValidation();" style="border-width: 0px;">
                                                                </td>
                                                            </tr>
                                                            <tr>
                                                                <td valign="top">
                                                                    <input type="image" name="ctl00$BodyContentPH$dgrdException$ctl03$imgtips" id="ctl00_BodyContentPH_dgrdException_ctl03_imgtips" disabled="disabled" src="dist/img/icon2.jpg" style="border-width: 0px; vertical-align: middle; padding-right: 10px">

                                                                    <span id="ctl00_BodyContentPH_dgrdException_ctl03_lbltopic">Absent</span>
                                                                </td>
                                                                <td class="pre1" align="center">
                                                                    <a onclick="return DateEntryValidation();" id="ctl00_BodyContentPH_dgrdException_ctl03_lblCount" href="javascript:__doPostBack('ctl00$BodyContentPH$dgrdException$ctl03$lblCount','')" style="color: Black;">0</a>

                                                                    <input type="hidden" name="ctl00$BodyContentPH$dgrdException$ctl03$hdfReportname" id="ctl00_BodyContentPH_dgrdException_ctl03_hdfReportname" value="Absentees">
                                                                    <input type="hidden" name="ctl00$BodyContentPH$dgrdException$ctl03$hdfCount" id="ctl00_BodyContentPH_dgrdException_ctl03_hdfCount" value="0">
                                                                </td>
                                                                <td class="pre1" align="center">

                                                                    <span id="ctl00_BodyContentPH_dgrdException_ctl03_lnkpercent" style="color: Black;">0 %</span>
                                                                </td>
                                                                <td class="excel1" align="center">
                                                                    <input type="image" name="ctl00$BodyContentPH$dgrdException$ctl03$btnImagExcel" id="ctl00_BodyContentPH_dgrdException_ctl03_btnImagExcel" title="Export to Excel" data-toggle="tooltip" data-placement="top" src="dist/img/excel-icon.jpg" onclick="return DateEntryValidation();" style="border-width: 0px;">
                                                                </td>
                                                                <td class="pdf1" align="center">
                                                                    <input type="image" name="ctl00$BodyContentPH$dgrdException$ctl03$btnimgPDF" id="ctl00_BodyContentPH_dgrdException_ctl03_btnimgPDF" title="Export to PDF" data-toggle="tooltip" data-placement="top" src="dist/img/pdf-icon.jpg" onclick="return DateEntryValidation();" style="border-width: 0px;">
                                                                </td>
                                                            </tr>
                                                            <tr>
                                                                <td valign="top">
                                                                    <input type="image" name="ctl00$BodyContentPH$dgrdException$ctl04$imgtips" id="ctl00_BodyContentPH_dgrdException_ctl04_imgtips" disabled="disabled" src="dist/img/icon3.jpg" style="border-width: 0px; vertical-align: middle; padding-right: 10px">

                                                                    <span id="ctl00_BodyContentPH_dgrdException_ctl04_lbltopic">Approved Leave</span>
                                                                </td>
                                                                <td class="pre1" align="center">
                                                                    <a onclick="return DateEntryValidation();" id="ctl00_BodyContentPH_dgrdException_ctl04_lblCount" href="javascript:__doPostBack('ctl00$BodyContentPH$dgrdException$ctl04$lblCount','')" style="color: Black;">0</a>

                                                                    <input type="hidden" name="ctl00$BodyContentPH$dgrdException$ctl04$hdfReportname" id="ctl00_BodyContentPH_dgrdException_ctl04_hdfReportname" value="Leave_Angler">
                                                                    <input type="hidden" name="ctl00$BodyContentPH$dgrdException$ctl04$hdfCount" id="ctl00_BodyContentPH_dgrdException_ctl04_hdfCount" value="0">
                                                                </td>
                                                                <td class="pre1" align="center">

                                                                    <span id="ctl00_BodyContentPH_dgrdException_ctl04_lnkpercent" style="color: Black;">0 %</span>
                                                                </td>
                                                                <td class="excel1" align="center">
                                                                    <input type="image" name="ctl00$BodyContentPH$dgrdException$ctl04$btnImagExcel" id="ctl00_BodyContentPH_dgrdException_ctl04_btnImagExcel" title="Export to Excel" data-toggle="tooltip" data-placement="top" src="dist/img/excel-icon.jpg" onclick="return DateEntryValidation();" style="border-width: 0px;">
                                                                </td>
                                                                <td class="pdf1" align="center">
                                                                    <input type="image" name="ctl00$BodyContentPH$dgrdException$ctl04$btnimgPDF" id="ctl00_BodyContentPH_dgrdException_ctl04_btnimgPDF" title="Export to PDF" data-toggle="tooltip" data-placement="top" src="dist/img/pdf-icon.jpg" onclick="return DateEntryValidation();" style="border-width: 0px;">
                                                                </td>
                                                            </tr>
                                                            <tr>
                                                                <td valign="top">
                                                                    <input type="image" name="ctl00$BodyContentPH$dgrdException$ctl05$imgtips" id="ctl00_BodyContentPH_dgrdException_ctl05_imgtips" disabled="disabled" src="dist/img/icon4.jpg" style="border-width: 0px; vertical-align: middle; padding-right: 10px">

                                                                    <span id="ctl00_BodyContentPH_dgrdException_ctl05_lbltopic">Approved OnDuty</span>
                                                                </td>
                                                                <td class="pre1" align="center">
                                                                    <a onclick="return DateEntryValidation();" id="ctl00_BodyContentPH_dgrdException_ctl05_lblCount" href="javascript:__doPostBack('ctl00$BodyContentPH$dgrdException$ctl05$lblCount','')" style="color: Black;">0</a>

                                                                    <input type="hidden" name="ctl00$BodyContentPH$dgrdException$ctl05$hdfReportname" id="ctl00_BodyContentPH_dgrdException_ctl05_hdfReportname" value="OnDuty">
                                                                    <input type="hidden" name="ctl00$BodyContentPH$dgrdException$ctl05$hdfCount" id="ctl00_BodyContentPH_dgrdException_ctl05_hdfCount" value="0">
                                                                </td>
                                                                <td class="pre1" align="center">

                                                                    <span id="ctl00_BodyContentPH_dgrdException_ctl05_lnkpercent" style="color: Black;">0 %</span>
                                                                </td>
                                                                <td class="excel1" align="center">
                                                                    <input type="image" name="ctl00$BodyContentPH$dgrdException$ctl05$btnImagExcel" id="ctl00_BodyContentPH_dgrdException_ctl05_btnImagExcel" title="Export to Excel" data-toggle="tooltip" data-placement="top" src="dist/img/excel-icon.jpg" onclick="return DateEntryValidation();" style="border-width: 0px;">
                                                                </td>
                                                                <td class="pdf1" align="center">
                                                                    <input type="image" name="ctl00$BodyContentPH$dgrdException$ctl05$btnimgPDF" id="ctl00_BodyContentPH_dgrdException_ctl05_btnimgPDF" title="Export to PDF" data-toggle="tooltip" data-placement="top" src="dist/img/pdf-icon.jpg" onclick="return DateEntryValidation();" style="border-width: 0px;">
                                                                </td>
                                                            </tr>
                                                            <tr>
                                                                <td valign="top">
                                                                    <input type="image" name="ctl00$BodyContentPH$dgrdException$ctl06$imgtips" id="ctl00_BodyContentPH_dgrdException_ctl06_imgtips" disabled="disabled" src="dist/img/icon5.jpg" style="border-width: 0px; vertical-align: middle; padding-right: 10px">

                                                                    <span id="ctl00_BodyContentPH_dgrdException_ctl06_lbltopic">Punctuality</span>
                                                                </td>
                                                                <td class="pre1" align="center">
                                                                    <a onclick="return DateEntryValidation();" id="ctl00_BodyContentPH_dgrdException_ctl06_lblCount" href="javascript:__doPostBack('ctl00$BodyContentPH$dgrdException$ctl06$lblCount','')" style="color: Black;">0</a>

                                                                    <input type="hidden" name="ctl00$BodyContentPH$dgrdException$ctl06$hdfReportname" id="ctl00_BodyContentPH_dgrdException_ctl06_hdfReportname" value="Punctuality">
                                                                    <input type="hidden" name="ctl00$BodyContentPH$dgrdException$ctl06$hdfCount" id="ctl00_BodyContentPH_dgrdException_ctl06_hdfCount" value="0">
                                                                </td>
                                                                <td class="pre1" align="center">

                                                                    <span id="ctl00_BodyContentPH_dgrdException_ctl06_lnkpercent" style="color: Black;">0 %</span>
                                                                </td>
                                                                <td class="excel1" align="center">
                                                                    <input type="image" name="ctl00$BodyContentPH$dgrdException$ctl06$btnImagExcel" id="ctl00_BodyContentPH_dgrdException_ctl06_btnImagExcel" title="Export to Excel" data-toggle="tooltip" data-placement="top" src="dist/img/excel-icon.jpg" onclick="return DateEntryValidation();" style="border-width: 0px;">
                                                                </td>
                                                                <td class="pdf1" align="center">
                                                                    <input type="image" name="ctl00$BodyContentPH$dgrdException$ctl06$btnimgPDF" id="ctl00_BodyContentPH_dgrdException_ctl06_btnimgPDF" title="Export to PDF" data-toggle="tooltip" data-placement="top" src="dist/img/pdf-icon.jpg" onclick="return DateEntryValidation();" style="border-width: 0px;">
                                                                </td>
                                                            </tr>
                                                            <tr>
                                                                <td valign="top">
                                                                    <input type="image" name="ctl00$BodyContentPH$dgrdException$ctl07$imgtips" id="ctl00_BodyContentPH_dgrdException_ctl07_imgtips" disabled="disabled" src="dist/img/icon6.jpg" style="border-width: 0px; vertical-align: middle; padding-right: 10px">

                                                                    <span id="ctl00_BodyContentPH_dgrdException_ctl07_lbltopic">AttendanceSummary</span>
                                                                </td>
                                                                <td class="pre1" align="center">
                                                                    <a onclick="return DateEntryValidation();" id="ctl00_BodyContentPH_dgrdException_ctl07_lblCount" href="javascript:__doPostBack('ctl00$BodyContentPH$dgrdException$ctl07$lblCount','')" style="color: Black;">0</a>

                                                                    <input type="hidden" name="ctl00$BodyContentPH$dgrdException$ctl07$hdfReportname" id="ctl00_BodyContentPH_dgrdException_ctl07_hdfReportname" value="AttendanceSummary">
                                                                    <input type="hidden" name="ctl00$BodyContentPH$dgrdException$ctl07$hdfCount" id="ctl00_BodyContentPH_dgrdException_ctl07_hdfCount" value="0">
                                                                </td>
                                                                <td class="pre1" align="center">

                                                                    <span id="ctl00_BodyContentPH_dgrdException_ctl07_lnkpercent" style="color: Black;">0 %</span>
                                                                </td>
                                                                <td class="excel1" align="center">
                                                                    <input type="image" name="ctl00$BodyContentPH$dgrdException$ctl07$btnImagExcel" id="ctl00_BodyContentPH_dgrdException_ctl07_btnImagExcel" title="Export to Excel" data-toggle="tooltip" data-placement="top" src="dist/img/excel-icon.jpg" onclick="return DateEntryValidation();" style="border-width: 0px;">
                                                                </td>
                                                                <td class="pdf1" align="center">
                                                                    <input type="image" name="ctl00$BodyContentPH$dgrdException$ctl07$btnimgPDF" id="ctl00_BodyContentPH_dgrdException_ctl07_btnimgPDF" title="Export to PDF" data-toggle="tooltip" data-placement="top" src="dist/img/pdf-icon.jpg" onclick="return DateEntryValidation();" style="border-width: 0px;">
                                                                </td>
                                                            </tr>
                                                        </tbody>
                                                    </table>
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="tab-pane" id="tab5" runat="server">
                            <div class="form-horizontal">
                                <div class="row">
                                    <div class="col-md-12">
                                        <div class="col-md-12">
                                            <div class="box box-primary">
                                                <div id="Holiday List" style="padding-top: 20px;">
                                                    <table class="table das-table1" rules="all" id="ctl00_BodyContentPH_dgrdException" style="border-collapse: collapse; padding-top: 20px;" cellspacing="0" border="1">
                                                        <tbody>
                                                            <tr>
                                                                <th class="head1 to-emp1 pad-lft HeaderWidth" scope="col">
                                                                    <span id="ctl00_BodyContentPH_dgrdException_ctl01_lblHeaderName">Total Employees : 0</span>
                                                                </th>
                                                                <th class="head1 count1" scope="col">
                                                                    <span id="ctl00_BodyContentPH_dgrdException_ctl01_lblHeadCount">Count</span>
                                                                </th>
                                                                <th class="head1 pre1" scope="col">%</th>
                                                                <th class="head1 excel1" scope="col">&nbsp;</th>
                                                                <th class="head1 pdf1" scope="col">&nbsp;</th>
                                                            </tr>
                                                            <tr>
                                                                <td valign="top">
                                                                    <input type="image" name="ctl00$BodyContentPH$dgrdException$ctl02$imgtips" id="ctl00_BodyContentPH_dgrdException_ctl02_imgtips" disabled="disabled" src="dist/img/icon1.jpg" style="border-width: 0px; vertical-align: middle; padding-right: 10px">

                                                                    <span id="ctl00_BodyContentPH_dgrdException_ctl02_lbltopic">Present</span>
                                                                </td>
                                                                <td class="pre1" align="center">
                                                                    <a onclick="return DateEntryValidation();" id="ctl00_BodyContentPH_dgrdException_ctl02_lblCount" href="javascript:__doPostBack('ctl00$BodyContentPH$dgrdException$ctl02$lblCount','')" style="color: Black;">0</a>

                                                                    <input type="hidden" name="ctl00$BodyContentPH$dgrdException$ctl02$hdfReportname" id="ctl00_BodyContentPH_dgrdException_ctl02_hdfReportname" value="MonthlyAttendance">
                                                                    <input type="hidden" name="ctl00$BodyContentPH$dgrdException$ctl02$hdfCount" id="ctl00_BodyContentPH_dgrdException_ctl02_hdfCount" value="0">
                                                                </td>
                                                                <td class="pre1" align="center">

                                                                    <span id="ctl00_BodyContentPH_dgrdException_ctl02_lnkpercent" style="color: Black;">0 %</span>
                                                                </td>
                                                                <td class="excel1" align="center">
                                                                    <input type="image" name="ctl00$BodyContentPH$dgrdException$ctl02$btnImagExcel" id="ctl00_BodyContentPH_dgrdException_ctl02_btnImagExcel" title="Export to Excel" data-toggle="tooltip" data-placement="top" src="dist/img/excel-icon.jpg" onclick="return DateEntryValidation();" style="border-width: 0px;">
                                                                </td>
                                                                <td class="pdf1" align="center">
                                                                    <input type="image" name="ctl00$BodyContentPH$dgrdException$ctl02$btnimgPDF" id="ctl00_BodyContentPH_dgrdException_ctl02_btnimgPDF" title="Export to PDF" data-toggle="tooltip" data-placement="top" src="dist/img/pdf-icon.jpg" onclick="return DateEntryValidation();" style="border-width: 0px;">
                                                                </td>
                                                            </tr>
                                                            <tr>
                                                                <td valign="top">
                                                                    <input type="image" name="ctl00$BodyContentPH$dgrdException$ctl03$imgtips" id="ctl00_BodyContentPH_dgrdException_ctl03_imgtips" disabled="disabled" src="dist/img/icon2.jpg" style="border-width: 0px; vertical-align: middle; padding-right: 10px">

                                                                    <span id="ctl00_BodyContentPH_dgrdException_ctl03_lbltopic">Absent</span>
                                                                </td>
                                                                <td class="pre1" align="center">
                                                                    <a onclick="return DateEntryValidation();" id="ctl00_BodyContentPH_dgrdException_ctl03_lblCount" href="javascript:__doPostBack('ctl00$BodyContentPH$dgrdException$ctl03$lblCount','')" style="color: Black;">0</a>

                                                                    <input type="hidden" name="ctl00$BodyContentPH$dgrdException$ctl03$hdfReportname" id="ctl00_BodyContentPH_dgrdException_ctl03_hdfReportname" value="Absentees">
                                                                    <input type="hidden" name="ctl00$BodyContentPH$dgrdException$ctl03$hdfCount" id="ctl00_BodyContentPH_dgrdException_ctl03_hdfCount" value="0">
                                                                </td>
                                                                <td class="pre1" align="center">

                                                                    <span id="ctl00_BodyContentPH_dgrdException_ctl03_lnkpercent" style="color: Black;">0 %</span>
                                                                </td>
                                                                <td class="excel1" align="center">
                                                                    <input type="image" name="ctl00$BodyContentPH$dgrdException$ctl03$btnImagExcel" id="ctl00_BodyContentPH_dgrdException_ctl03_btnImagExcel" title="Export to Excel" data-toggle="tooltip" data-placement="top" src="dist/img/excel-icon.jpg" onclick="return DateEntryValidation();" style="border-width: 0px;">
                                                                </td>
                                                                <td class="pdf1" align="center">
                                                                    <input type="image" name="ctl00$BodyContentPH$dgrdException$ctl03$btnimgPDF" id="ctl00_BodyContentPH_dgrdException_ctl03_btnimgPDF" title="Export to PDF" data-toggle="tooltip" data-placement="top" src="dist/img/pdf-icon.jpg" onclick="return DateEntryValidation();" style="border-width: 0px;">
                                                                </td>
                                                            </tr>
                                                            <tr>
                                                                <td valign="top">
                                                                    <input type="image" name="ctl00$BodyContentPH$dgrdException$ctl04$imgtips" id="ctl00_BodyContentPH_dgrdException_ctl04_imgtips" disabled="disabled" src="dist/img/icon3.jpg" style="border-width: 0px; vertical-align: middle; padding-right: 10px">

                                                                    <span id="ctl00_BodyContentPH_dgrdException_ctl04_lbltopic">Approved Leave</span>
                                                                </td>
                                                                <td class="pre1" align="center">
                                                                    <a onclick="return DateEntryValidation();" id="ctl00_BodyContentPH_dgrdException_ctl04_lblCount" href="javascript:__doPostBack('ctl00$BodyContentPH$dgrdException$ctl04$lblCount','')" style="color: Black;">0</a>

                                                                    <input type="hidden" name="ctl00$BodyContentPH$dgrdException$ctl04$hdfReportname" id="ctl00_BodyContentPH_dgrdException_ctl04_hdfReportname" value="Leave_Angler">
                                                                    <input type="hidden" name="ctl00$BodyContentPH$dgrdException$ctl04$hdfCount" id="ctl00_BodyContentPH_dgrdException_ctl04_hdfCount" value="0">
                                                                </td>
                                                                <td class="pre1" align="center">

                                                                    <span id="ctl00_BodyContentPH_dgrdException_ctl04_lnkpercent" style="color: Black;">0 %</span>
                                                                </td>
                                                                <td class="excel1" align="center">
                                                                    <input type="image" name="ctl00$BodyContentPH$dgrdException$ctl04$btnImagExcel" id="ctl00_BodyContentPH_dgrdException_ctl04_btnImagExcel" title="Export to Excel" data-toggle="tooltip" data-placement="top" src="dist/img/excel-icon.jpg" onclick="return DateEntryValidation();" style="border-width: 0px;">
                                                                </td>
                                                                <td class="pdf1" align="center">
                                                                    <input type="image" name="ctl00$BodyContentPH$dgrdException$ctl04$btnimgPDF" id="ctl00_BodyContentPH_dgrdException_ctl04_btnimgPDF" title="Export to PDF" data-toggle="tooltip" data-placement="top" src="dist/img/pdf-icon.jpg" onclick="return DateEntryValidation();" style="border-width: 0px;">
                                                                </td>
                                                            </tr>
                                                            <tr>
                                                                <td valign="top">
                                                                    <input type="image" name="ctl00$BodyContentPH$dgrdException$ctl05$imgtips" id="ctl00_BodyContentPH_dgrdException_ctl05_imgtips" disabled="disabled" src="dist/img/icon4.jpg" style="border-width: 0px; vertical-align: middle; padding-right: 10px">

                                                                    <span id="ctl00_BodyContentPH_dgrdException_ctl05_lbltopic">Approved OnDuty</span>
                                                                </td>
                                                                <td class="pre1" align="center">
                                                                    <a onclick="return DateEntryValidation();" id="ctl00_BodyContentPH_dgrdException_ctl05_lblCount" href="javascript:__doPostBack('ctl00$BodyContentPH$dgrdException$ctl05$lblCount','')" style="color: Black;">0</a>

                                                                    <input type="hidden" name="ctl00$BodyContentPH$dgrdException$ctl05$hdfReportname" id="ctl00_BodyContentPH_dgrdException_ctl05_hdfReportname" value="OnDuty">
                                                                    <input type="hidden" name="ctl00$BodyContentPH$dgrdException$ctl05$hdfCount" id="ctl00_BodyContentPH_dgrdException_ctl05_hdfCount" value="0">
                                                                </td>
                                                                <td class="pre1" align="center">

                                                                    <span id="ctl00_BodyContentPH_dgrdException_ctl05_lnkpercent" style="color: Black;">0 %</span>
                                                                </td>
                                                                <td class="excel1" align="center">
                                                                    <input type="image" name="ctl00$BodyContentPH$dgrdException$ctl05$btnImagExcel" id="ctl00_BodyContentPH_dgrdException_ctl05_btnImagExcel" title="Export to Excel" data-toggle="tooltip" data-placement="top" src="dist/img/excel-icon.jpg" onclick="return DateEntryValidation();" style="border-width: 0px;">
                                                                </td>
                                                                <td class="pdf1" align="center">
                                                                    <input type="image" name="ctl00$BodyContentPH$dgrdException$ctl05$btnimgPDF" id="ctl00_BodyContentPH_dgrdException_ctl05_btnimgPDF" title="Export to PDF" data-toggle="tooltip" data-placement="top" src="dist/img/pdf-icon.jpg" onclick="return DateEntryValidation();" style="border-width: 0px;">
                                                                </td>
                                                            </tr>
                                                            <tr>
                                                                <td valign="top">
                                                                    <input type="image" name="ctl00$BodyContentPH$dgrdException$ctl06$imgtips" id="ctl00_BodyContentPH_dgrdException_ctl06_imgtips" disabled="disabled" src="dist/img/icon5.jpg" style="border-width: 0px; vertical-align: middle; padding-right: 10px">

                                                                    <span id="ctl00_BodyContentPH_dgrdException_ctl06_lbltopic">Punctuality</span>
                                                                </td>
                                                                <td class="pre1" align="center">
                                                                    <a onclick="return DateEntryValidation();" id="ctl00_BodyContentPH_dgrdException_ctl06_lblCount" href="javascript:__doPostBack('ctl00$BodyContentPH$dgrdException$ctl06$lblCount','')" style="color: Black;">0</a>

                                                                    <input type="hidden" name="ctl00$BodyContentPH$dgrdException$ctl06$hdfReportname" id="ctl00_BodyContentPH_dgrdException_ctl06_hdfReportname" value="Punctuality">
                                                                    <input type="hidden" name="ctl00$BodyContentPH$dgrdException$ctl06$hdfCount" id="ctl00_BodyContentPH_dgrdException_ctl06_hdfCount" value="0">
                                                                </td>
                                                                <td class="pre1" align="center">

                                                                    <span id="ctl00_BodyContentPH_dgrdException_ctl06_lnkpercent" style="color: Black;">0 %</span>
                                                                </td>
                                                                <td class="excel1" align="center">
                                                                    <input type="image" name="ctl00$BodyContentPH$dgrdException$ctl06$btnImagExcel" id="ctl00_BodyContentPH_dgrdException_ctl06_btnImagExcel" title="Export to Excel" data-toggle="tooltip" data-placement="top" src="dist/img/excel-icon.jpg" onclick="return DateEntryValidation();" style="border-width: 0px;">
                                                                </td>
                                                                <td class="pdf1" align="center">
                                                                    <input type="image" name="ctl00$BodyContentPH$dgrdException$ctl06$btnimgPDF" id="ctl00_BodyContentPH_dgrdException_ctl06_btnimgPDF" title="Export to PDF" data-toggle="tooltip" data-placement="top" src="dist/img/pdf-icon.jpg" onclick="return DateEntryValidation();" style="border-width: 0px;">
                                                                </td>
                                                            </tr>
                                                            <tr>
                                                                <td valign="top">
                                                                    <input type="image" name="ctl00$BodyContentPH$dgrdException$ctl07$imgtips" id="ctl00_BodyContentPH_dgrdException_ctl07_imgtips" disabled="disabled" src="dist/img/icon6.jpg" style="border-width: 0px; vertical-align: middle; padding-right: 10px">

                                                                    <span id="ctl00_BodyContentPH_dgrdException_ctl07_lbltopic">AttendanceSummary</span>
                                                                </td>
                                                                <td class="pre1" align="center">
                                                                    <a onclick="return DateEntryValidation();" id="ctl00_BodyContentPH_dgrdException_ctl07_lblCount" href="javascript:__doPostBack('ctl00$BodyContentPH$dgrdException$ctl07$lblCount','')" style="color: Black;">0</a>

                                                                    <input type="hidden" name="ctl00$BodyContentPH$dgrdException$ctl07$hdfReportname" id="ctl00_BodyContentPH_dgrdException_ctl07_hdfReportname" value="AttendanceSummary">
                                                                    <input type="hidden" name="ctl00$BodyContentPH$dgrdException$ctl07$hdfCount" id="ctl00_BodyContentPH_dgrdException_ctl07_hdfCount" value="0">
                                                                </td>
                                                                <td class="pre1" align="center">

                                                                    <span id="ctl00_BodyContentPH_dgrdException_ctl07_lnkpercent" style="color: Black;">0 %</span>
                                                                </td>
                                                                <td class="excel1" align="center">
                                                                    <input type="image" name="ctl00$BodyContentPH$dgrdException$ctl07$btnImagExcel" id="ctl00_BodyContentPH_dgrdException_ctl07_btnImagExcel" title="Export to Excel" data-toggle="tooltip" data-placement="top" src="dist/img/excel-icon.jpg" onclick="return DateEntryValidation();" style="border-width: 0px;">
                                                                </td>
                                                                <td class="pdf1" align="center">
                                                                    <input type="image" name="ctl00$BodyContentPH$dgrdException$ctl07$btnimgPDF" id="ctl00_BodyContentPH_dgrdException_ctl07_btnimgPDF" title="Export to PDF" data-toggle="tooltip" data-placement="top" src="dist/img/pdf-icon.jpg" onclick="return DateEntryValidation();" style="border-width: 0px;">
                                                                </td>
                                                            </tr>
                                                        </tbody>
                                                    </table>
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="tab-pane" id="tab6" runat="server">
                            <div class="form-horizontal">
                                <div class="row">
                                    <div class="col-md-12">
                                        <div class="col-md-12">
                                            <div class="box box-primary">
                                                <div id="Balance Leaves" style="padding-top: 20px;">
                                                    <table class="table das-table1" rules="all" id="ctl00_BodyContentPH_dgrdException" style="border-collapse: collapse;" cellspacing="0" border="1">
                                                        <tbody>
                                                            <tr>
                                                                <th class="head1 to-emp1 pad-lft HeaderWidth" scope="col">
                                                                    <span id="ctl00_BodyContentPH_dgrdException_ctl01_lblHeaderName">Total Employees : 0</span>
                                                                </th>
                                                                <th class="head1 count1" scope="col">
                                                                    <span id="ctl00_BodyContentPH_dgrdException_ctl01_lblHeadCount">Count</span>
                                                                </th>
                                                                <th class="head1 pre1" scope="col">%</th>
                                                                <th class="head1 excel1" scope="col">&nbsp;</th>
                                                                <th class="head1 pdf1" scope="col">&nbsp;</th>
                                                            </tr>
                                                            <tr>
                                                                <td valign="top">
                                                                    <input type="image" name="ctl00$BodyContentPH$dgrdException$ctl02$imgtips" id="ctl00_BodyContentPH_dgrdException_ctl02_imgtips" disabled="disabled" src="dist/img/icon1.jpg" style="border-width: 0px; vertical-align: middle; padding-right: 10px">

                                                                    <span id="ctl00_BodyContentPH_dgrdException_ctl02_lbltopic">Present</span>
                                                                </td>
                                                                <td class="pre1" align="center">
                                                                    <a onclick="return DateEntryValidation();" id="ctl00_BodyContentPH_dgrdException_ctl02_lblCount" href="javascript:__doPostBack('ctl00$BodyContentPH$dgrdException$ctl02$lblCount','')" style="color: Black;">0</a>

                                                                    <input type="hidden" name="ctl00$BodyContentPH$dgrdException$ctl02$hdfReportname" id="ctl00_BodyContentPH_dgrdException_ctl02_hdfReportname" value="MonthlyAttendance">
                                                                    <input type="hidden" name="ctl00$BodyContentPH$dgrdException$ctl02$hdfCount" id="ctl00_BodyContentPH_dgrdException_ctl02_hdfCount" value="0">
                                                                </td>
                                                                <td class="pre1" align="center">

                                                                    <span id="ctl00_BodyContentPH_dgrdException_ctl02_lnkpercent" style="color: Black;">0 %</span>
                                                                </td>
                                                                <td class="excel1" align="center">
                                                                    <input type="image" name="ctl00$BodyContentPH$dgrdException$ctl02$btnImagExcel" id="ctl00_BodyContentPH_dgrdException_ctl02_btnImagExcel" title="Export to Excel" data-toggle="tooltip" data-placement="top" src="dist/img/excel-icon.jpg" onclick="return DateEntryValidation();" style="border-width: 0px;">
                                                                </td>
                                                                <td class="pdf1" align="center">
                                                                    <input type="image" name="ctl00$BodyContentPH$dgrdException$ctl02$btnimgPDF" id="ctl00_BodyContentPH_dgrdException_ctl02_btnimgPDF" title="Export to PDF" data-toggle="tooltip" data-placement="top" src="dist/img/pdf-icon.jpg" onclick="return DateEntryValidation();" style="border-width: 0px;">
                                                                </td>
                                                            </tr>
                                                            <tr>
                                                                <td valign="top">
                                                                    <input type="image" name="ctl00$BodyContentPH$dgrdException$ctl03$imgtips" id="ctl00_BodyContentPH_dgrdException_ctl03_imgtips" disabled="disabled" src="dist/img/icon2.jpg" style="border-width: 0px; vertical-align: middle; padding-right: 10px">

                                                                    <span id="ctl00_BodyContentPH_dgrdException_ctl03_lbltopic">Absent</span>
                                                                </td>
                                                                <td class="pre1" align="center">
                                                                    <a onclick="return DateEntryValidation();" id="ctl00_BodyContentPH_dgrdException_ctl03_lblCount" href="javascript:__doPostBack('ctl00$BodyContentPH$dgrdException$ctl03$lblCount','')" style="color: Black;">0</a>

                                                                    <input type="hidden" name="ctl00$BodyContentPH$dgrdException$ctl03$hdfReportname" id="ctl00_BodyContentPH_dgrdException_ctl03_hdfReportname" value="Absentees">
                                                                    <input type="hidden" name="ctl00$BodyContentPH$dgrdException$ctl03$hdfCount" id="ctl00_BodyContentPH_dgrdException_ctl03_hdfCount" value="0">
                                                                </td>
                                                                <td class="pre1" align="center">

                                                                    <span id="ctl00_BodyContentPH_dgrdException_ctl03_lnkpercent" style="color: Black;">0 %</span>
                                                                </td>
                                                                <td class="excel1" align="center">
                                                                    <input type="image" name="ctl00$BodyContentPH$dgrdException$ctl03$btnImagExcel" id="ctl00_BodyContentPH_dgrdException_ctl03_btnImagExcel" title="Export to Excel" data-toggle="tooltip" data-placement="top" src="dist/img/excel-icon.jpg" onclick="return DateEntryValidation();" style="border-width: 0px;">
                                                                </td>
                                                                <td class="pdf1" align="center">
                                                                    <input type="image" name="ctl00$BodyContentPH$dgrdException$ctl03$btnimgPDF" id="ctl00_BodyContentPH_dgrdException_ctl03_btnimgPDF" title="Export to PDF" data-toggle="tooltip" data-placement="top" src="dist/img/pdf-icon.jpg" onclick="return DateEntryValidation();" style="border-width: 0px;">
                                                                </td>
                                                            </tr>
                                                            <tr>
                                                                <td valign="top">
                                                                    <input type="image" name="ctl00$BodyContentPH$dgrdException$ctl04$imgtips" id="ctl00_BodyContentPH_dgrdException_ctl04_imgtips" disabled="disabled" src="dist/img/icon3.jpg" style="border-width: 0px; vertical-align: middle; padding-right: 10px">

                                                                    <span id="ctl00_BodyContentPH_dgrdException_ctl04_lbltopic">Approved Leave</span>
                                                                </td>
                                                                <td class="pre1" align="center">
                                                                    <a onclick="return DateEntryValidation();" id="ctl00_BodyContentPH_dgrdException_ctl04_lblCount" href="javascript:__doPostBack('ctl00$BodyContentPH$dgrdException$ctl04$lblCount','')" style="color: Black;">0</a>

                                                                    <input type="hidden" name="ctl00$BodyContentPH$dgrdException$ctl04$hdfReportname" id="ctl00_BodyContentPH_dgrdException_ctl04_hdfReportname" value="Leave_Angler">
                                                                    <input type="hidden" name="ctl00$BodyContentPH$dgrdException$ctl04$hdfCount" id="ctl00_BodyContentPH_dgrdException_ctl04_hdfCount" value="0">
                                                                </td>
                                                                <td class="pre1" align="center">

                                                                    <span id="ctl00_BodyContentPH_dgrdException_ctl04_lnkpercent" style="color: Black;">0 %</span>
                                                                </td>
                                                                <td class="excel1" align="center">
                                                                    <input type="image" name="ctl00$BodyContentPH$dgrdException$ctl04$btnImagExcel" id="ctl00_BodyContentPH_dgrdException_ctl04_btnImagExcel" title="Export to Excel" data-toggle="tooltip" data-placement="top" src="dist/img/excel-icon.jpg" onclick="return DateEntryValidation();" style="border-width: 0px;">
                                                                </td>
                                                                <td class="pdf1" align="center">
                                                                    <input type="image" name="ctl00$BodyContentPH$dgrdException$ctl04$btnimgPDF" id="ctl00_BodyContentPH_dgrdException_ctl04_btnimgPDF" title="Export to PDF" data-toggle="tooltip" data-placement="top" src="dist/img/pdf-icon.jpg" onclick="return DateEntryValidation();" style="border-width: 0px;">
                                                                </td>
                                                            </tr>
                                                            <tr>
                                                                <td valign="top">
                                                                    <input type="image" name="ctl00$BodyContentPH$dgrdException$ctl05$imgtips" id="ctl00_BodyContentPH_dgrdException_ctl05_imgtips" disabled="disabled" src="dist/img/icon4.jpg" style="border-width: 0px; vertical-align: middle; padding-right: 10px">

                                                                    <span id="ctl00_BodyContentPH_dgrdException_ctl05_lbltopic">Approved OnDuty</span>
                                                                </td>
                                                                <td class="pre1" align="center">
                                                                    <a onclick="return DateEntryValidation();" id="ctl00_BodyContentPH_dgrdException_ctl05_lblCount" href="javascript:__doPostBack('ctl00$BodyContentPH$dgrdException$ctl05$lblCount','')" style="color: Black;">0</a>

                                                                    <input type="hidden" name="ctl00$BodyContentPH$dgrdException$ctl05$hdfReportname" id="ctl00_BodyContentPH_dgrdException_ctl05_hdfReportname" value="OnDuty">
                                                                    <input type="hidden" name="ctl00$BodyContentPH$dgrdException$ctl05$hdfCount" id="ctl00_BodyContentPH_dgrdException_ctl05_hdfCount" value="0">
                                                                </td>
                                                                <td class="pre1" align="center">

                                                                    <span id="ctl00_BodyContentPH_dgrdException_ctl05_lnkpercent" style="color: Black;">0 %</span>
                                                                </td>
                                                                <td class="excel1" align="center">
                                                                    <input type="image" name="ctl00$BodyContentPH$dgrdException$ctl05$btnImagExcel" id="ctl00_BodyContentPH_dgrdException_ctl05_btnImagExcel" title="Export to Excel" data-toggle="tooltip" data-placement="top" src="dist/img/excel-icon.jpg" onclick="return DateEntryValidation();" style="border-width: 0px;">
                                                                </td>
                                                                <td class="pdf1" align="center">
                                                                    <input type="image" name="ctl00$BodyContentPH$dgrdException$ctl05$btnimgPDF" id="ctl00_BodyContentPH_dgrdException_ctl05_btnimgPDF" title="Export to PDF" data-toggle="tooltip" data-placement="top" src="dist/img/pdf-icon.jpg" onclick="return DateEntryValidation();" style="border-width: 0px;">
                                                                </td>
                                                            </tr>
                                                            <tr>
                                                                <td valign="top">
                                                                    <input type="image" name="ctl00$BodyContentPH$dgrdException$ctl06$imgtips" id="ctl00_BodyContentPH_dgrdException_ctl06_imgtips" disabled="disabled" src="dist/img/icon5.jpg" style="border-width: 0px; vertical-align: middle; padding-right: 10px">

                                                                    <span id="ctl00_BodyContentPH_dgrdException_ctl06_lbltopic">Punctuality</span>
                                                                </td>
                                                                <td class="pre1" align="center">
                                                                    <a onclick="return DateEntryValidation();" id="ctl00_BodyContentPH_dgrdException_ctl06_lblCount" href="javascript:__doPostBack('ctl00$BodyContentPH$dgrdException$ctl06$lblCount','')" style="color: Black;">0</a>

                                                                    <input type="hidden" name="ctl00$BodyContentPH$dgrdException$ctl06$hdfReportname" id="ctl00_BodyContentPH_dgrdException_ctl06_hdfReportname" value="Punctuality">
                                                                    <input type="hidden" name="ctl00$BodyContentPH$dgrdException$ctl06$hdfCount" id="ctl00_BodyContentPH_dgrdException_ctl06_hdfCount" value="0">
                                                                </td>
                                                                <td class="pre1" align="center">

                                                                    <span id="ctl00_BodyContentPH_dgrdException_ctl06_lnkpercent" style="color: Black;">0 %</span>
                                                                </td>
                                                                <td class="excel1" align="center">
                                                                    <input type="image" name="ctl00$BodyContentPH$dgrdException$ctl06$btnImagExcel" id="ctl00_BodyContentPH_dgrdException_ctl06_btnImagExcel" title="Export to Excel" data-toggle="tooltip" data-placement="top" src="dist/img/excel-icon.jpg" onclick="return DateEntryValidation();" style="border-width: 0px;">
                                                                </td>
                                                                <td class="pdf1" align="center">
                                                                    <input type="image" name="ctl00$BodyContentPH$dgrdException$ctl06$btnimgPDF" id="ctl00_BodyContentPH_dgrdException_ctl06_btnimgPDF" title="Export to PDF" data-toggle="tooltip" data-placement="top" src="dist/img/pdf-icon.jpg" onclick="return DateEntryValidation();" style="border-width: 0px;">
                                                                </td>
                                                            </tr>
                                                            <tr>
                                                                <td valign="top">
                                                                    <input type="image" name="ctl00$BodyContentPH$dgrdException$ctl07$imgtips" id="ctl00_BodyContentPH_dgrdException_ctl07_imgtips" disabled="disabled" src="dist/img/icon6.jpg" style="border-width: 0px; vertical-align: middle; padding-right: 10px">

                                                                    <span id="ctl00_BodyContentPH_dgrdException_ctl07_lbltopic">AttendanceSummary</span>
                                                                </td>
                                                                <td class="pre1" align="center">
                                                                    <a onclick="return DateEntryValidation();" id="ctl00_BodyContentPH_dgrdException_ctl07_lblCount" href="javascript:__doPostBack('ctl00$BodyContentPH$dgrdException$ctl07$lblCount','')" style="color: Black;">0</a>

                                                                    <input type="hidden" name="ctl00$BodyContentPH$dgrdException$ctl07$hdfReportname" id="ctl00_BodyContentPH_dgrdException_ctl07_hdfReportname" value="AttendanceSummary">
                                                                    <input type="hidden" name="ctl00$BodyContentPH$dgrdException$ctl07$hdfCount" id="ctl00_BodyContentPH_dgrdException_ctl07_hdfCount" value="0">
                                                                </td>
                                                                <td class="pre1" align="center">

                                                                    <span id="ctl00_BodyContentPH_dgrdException_ctl07_lnkpercent" style="color: Black;">0 %</span>
                                                                </td>
                                                                <td class="excel1" align="center">
                                                                    <input type="image" name="ctl00$BodyContentPH$dgrdException$ctl07$btnImagExcel" id="ctl00_BodyContentPH_dgrdException_ctl07_btnImagExcel" title="Export to Excel" data-toggle="tooltip" data-placement="top" src="dist/img/excel-icon.jpg" onclick="return DateEntryValidation();" style="border-width: 0px;">
                                                                </td>
                                                                <td class="pdf1" align="center">
                                                                    <input type="image" name="ctl00$BodyContentPH$dgrdException$ctl07$btnimgPDF" id="ctl00_BodyContentPH_dgrdException_ctl07_btnimgPDF" title="Export to PDF" data-toggle="tooltip" data-placement="top" src="dist/img/pdf-icon.jpg" onclick="return DateEntryValidation();" style="border-width: 0px;">
                                                                </td>
                                                            </tr>
                                                        </tbody>
                                                    </table>
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </section>
    <script src="plugins/select2/select2.full.min.js"></script>
</asp:Content>
