using System;
using System.Globalization;
using System.Resources;
using System.Threading;
using System.Web.UI;
using System.Web.UI.WebControls;
public partial class Reports_TA_UI_Report_LateInGrid : Base.BasePage
{
    #region Varaiable Declaration
    GetReports rptEmp = new GetReports();
    Rpt_Common rptcommon = new Rpt_Common();
    ResourceManager rm;
    CultureInfo ci;
    string EmpID = string.Empty;
    int shiftID = 0;
    string levelID = string.Empty;
    string from = string.Empty;
    string to = string.Empty;
    string Empname = string.Empty;
    int employeeCategory = 0;
    int employeeType = 0;
    string userGroupName = string.Empty;
    string gradeLevel = string.Empty;
    string strReportType = string.Empty;
    string ParentLevelid = string.Empty;
    string strSwipeCard = string.Empty;
    string Designation = string.Empty;
    string Gender = string.Empty;
    string source_Language;
    Int64 EmpAutoID = 0;
    #endregion
    #region Page Load Events
    /// <summary>
    /// On page loading
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected override void Page_Load(object sender, EventArgs e)
    {
        // session checking
        base.Page_Load(sender, e);
        grv_LateIn.Styles.CssFilePath = Convert.ToString(Session["GridCSS"]);
        //get the culture info to set the language
        source_Language = Convert.ToString(Session["Session_ActiveLanguage"]);
        rm = new ResourceManager(source_Language, System.Reflection.Assembly.Load("App_GlobalResources"));
        ci = Thread.CurrentThread.CurrentCulture;
        site.SiteMapProvider = Convert.ToString(Session["SiteMapProvider"]);
        LoadStrings(ci);
        string EncryptKey = "TimecheckPhaseI";
        EmpID = Convert.ToString(Request.QueryString["EmpID"]);
        //EmpID = Cryptographys.Cryptography.Decrypt(Request.QueryString["EmpID"], EncryptKey);
        shiftID = Convert.ToInt32(Request.QueryString["Shift"]);
        //shiftID = Convert.ToInt32(Cryptographys.Cryptography.Decrypt(Request.QueryString["Shift"], EncryptKey));
        from = Convert.ToString(Request.QueryString["From"]);
        //from = Cryptographys.Cryptography.Decrypt(Request.QueryString["From"], EncryptKey);
        to = Convert.ToString(Request.QueryString["To"]);
        //to = Cryptographys.Cryptography.Decrypt(Request.QueryString["To"], EncryptKey);
        Empname = Convert.ToString(Request.QueryString["EmpName"]);
        //Empname = Cryptographys.Cryptography.Decrypt(Request.QueryString["EmpName"], EncryptKey);
         ParentLevelid = Convert.ToString(Request.QueryString["ParentLevelId"]);
        //ParentLevelid = Cryptographys.Cryptography.Decrypt(Request.QueryString["ParentLevelId"], EncryptKey);
        levelID = rptcommon.getNodes(Convert.ToInt16(ParentLevelid), Convert.ToString(Session["LevelRights"]));
       employeeCategory = Convert.ToInt32(Request.QueryString["employeeCategory"]);
       // employeeCategory = Convert.ToInt32(Cryptographys.Cryptography.Decrypt(Request.QueryString["employeeCategory"], EncryptKey));
        employeeType = Convert.ToInt32(Request.QueryString["employeeType"]);
        //employeeType = Convert.ToInt32(Cryptographys.Cryptography.Decrypt(Request.QueryString["employeeType"], EncryptKey));
         userGroupName = Convert.ToString(Request.QueryString["userGroupName"]);
        //userGroupName = Cryptographys.Cryptography.Decrypt(Request.QueryString["userGroupName"], EncryptKey);
        gradeLevel = Convert.ToString(Request.QueryString["gradeLevel"]);
        //gradeLevel = Cryptographys.Cryptography.Decrypt(Request.QueryString["gradeLevel"], EncryptKey);
         strReportType = Convert.ToString(Request.QueryString["ReportType"]);
        //strReportType = Cryptographys.Cryptography.Decrypt(Request.QueryString["ReportType"], EncryptKey);
        strSwipeCard = Convert.ToString(Request.QueryString["SwipeCard"]);
        //strSwipeCard = Cryptographys.Cryptography.Decrypt(Request.QueryString["SwipeCard"], EncryptKey);
         Designation = Convert.ToString(Request.QueryString["Designation"]);
        //Designation = Cryptographys.Cryptography.Decrypt(Request.QueryString["Designation"], EncryptKey);
         Gender = Convert.ToString(Request.QueryString["Gender"]);
        //Gender = Cryptographys.Cryptography.Decrypt(Request.QueryString["Gender"], EncryptKey);
         EmpAutoID = Convert.ToInt64(Request.QueryString["EmpAutoID"]);
        //EmpAutoID = Convert.ToInt64(Cryptographys.Cryptography.Decrypt(Request.QueryString["EmpAutoID"], EncryptKey));
    }
    #endregion
    #region Button Events
    /// <summary>
    /// To view the crystal report
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void btn_View_Click(object sender, EventArgs e)
    {
        try
        {
            if (Page.IsValid == true)
            {
                base.EncryptandRedirect("TA_UI_Report_ReportViewer.aspx", "LateEntry", from, to, EmpID, Convert.ToInt32(shiftID), Empname, ParentLevelid, Convert.ToInt32(employeeCategory), Convert.ToInt32(employeeType), userGroupName, gradeLevel, strSwipeCard, Convert.ToInt32(ParentLevelid), Convert.ToInt32(Designation), Gender, 0, 0, 0, strReportType, null, null, null,null,null,0, null, null, null, null, null, 0, null, 0, null, null, null, 0, 0, 0, 0, 0, 0, null, null,null,null, null, null, null, null, null, null, null, null, null);
                ////Redirect the page to the report viewer
                //string strScript = "";
                ////strScript = "TA_UI_Report_ReportViewer.aspx";
                //strScript = strScript + "<!DOCTYPE html PUBLIC '-//W3C//DTD XHTML 1.0 Transitional//EN' 'http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd'>";
                //strScript = strScript + "<meta http-equiv='X-UA-Compatible' content='IE=edge' />";
                //strScript = strScript + "<script language='javascript'>";
                //strScript = strScript + "window.open('TA_UI_Report_ReportViewer.aspx?ReportName=LateEntry&dtFrom="
                //    + from + "&dtTo=" + to + "&empid=" + EmpID + "&shft=" + shiftID + "&EmpName=" + Empname +
                //    "&Level=" + ParentLevelid + "&EmpCategory=" + employeeCategory + "&EmpType=" + employeeType +
                //    "&ParentLevelId=" + ParentLevelid + "&UserGroupName=" + userGroupName + "&GradeLevel=" + gradeLevel +
                //    "&Normal=" + strReportType + "&SwipeCard=" + strSwipeCard + "&Designation=" + Convert.ToInt32(Designation) + "&Gender=" + Gender + "','','left=10px, top=60px, width=1000px, height=600px, scrollbars=yes, status=no, resizable=yes');";
                //strScript = strScript + "</script>";
                //Response.Write(strScript);
            }
        }
        catch (Exception ex)
        {
            throw ex;
        }
    }
    #endregion
    #region User Defined Function
    /// <summary>
    /// Getting Information from resource file and display it in label
    /// </summary>
    /// <param name="ci"></param>
    private void LoadStrings(CultureInfo ci)
    {
        btn_View.Text = "&nbsp;&nbsp;" + rm.GetString("btn_View", ci);
        btnBack.Text = "&nbsp;&nbsp;" + rm.GetString("btn_Back", ci);
        lblLateEntry.Text = rm.GetString("Reports_LateEntry_Report", ci);
        grv_LateIn.Columns[0].Caption = rm.GetString("Field_EmployeeID", ci);
        grv_LateIn.Columns[1].Caption = rm.GetString("Field_EmployeeName", ci);
        grv_LateIn.Columns[2].Caption = rm.GetString("LevelDetails_LevelName", ci);
        grv_LateIn.Columns[3].Caption = rm.GetString("Master_Designation", ci);
        grv_LateIn.Columns[4].Caption = rm.GetString("EmployeeMaster_Gender", ci);
        grv_LateIn.Columns[5].Caption = rm.GetString("Reports_Date", ci);
        grv_LateIn.Columns[6].Caption = rm.GetString("ManualTimeEntry_In_Time", ci);
        grv_LateIn.Columns[7].Caption = rm.GetString("Late_Entry_LateBy", ci);        
        grv_LateIn.Columns[8].Caption = rm.GetString("Field_Reason", ci);
    }
    #endregion
    #region Grid Events    
    protected void grv_LateIn_HtmlRowCreated(object sender, DevExpress.Web.ASPxGridViewTableRowEventArgs e)
    {
    }
    #endregion
}
