using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Globalization;
using System.Threading;
using System.Reflection;
using System.Resources;
using System.Text;
using System.IO;
public partial class Transactions_PopUp_EmployeeOTSanction : Base.BasePage
{
    #region Variable Declaraion
    ResourceManager rm;
    CultureInfo ci;
    cls_Common objCommon = new cls_Common();
    EmployeeEventData objEmployee = new EmployeeEventData();
    ShiftAllocationEvendata obj = new ShiftAllocationEvendata();
    YearSettingsEventData objYearSettingsEventData = new YearSettingsEventData();
    LeaveApplicationEventData objEmployeeEventData = new LeaveApplicationEventData();
    Rpt_Common rptcommon = new Rpt_Common();
    OTEventData objOT = new OTEventData();
    DataTable dtLeaveOTDetails = new DataTable();
    DataTable dtLeaveApplicationOTHrs = new DataTable();
    string strEmpFirstName, strEmpLastName;
    DataSet dsEmployeeDetails = new DataSet();
    string strEmailIdSanctioningAuthority, strEmailIdReportingTo, strEmployeeCodeId, strEmployeeName, strlevelName, strEmailID;
    Email_Triggering ObjEmailTrigger = new Email_Triggering();
    bool blnCheckEmail = true;
    int intCount;
    DataView dv;
    int loginEmployeeId;
    DataSet ds = new DataSet();
    bool checkRecordExists;
    string OTStatus;
    bool CheckGrid = false;
    DataSet dsOtEmployee = new DataSet();
    int intOTHrs, intWOFOTHrs, intHDOTFrs;
    int intUpOTHrs, intUpWOFOTHrs, intUpHDOTFrs;
    int iEmployeeID;
    #endregion
    #region Page Load Event
    protected override void Page_Load(object sender, EventArgs e)
    {
        // session checking and reset date format
        base.Page_Load(sender, e);
        //if Standar Edition set the visibility to false
        int otApprovalExists = 0;
        otApprovalExists = objCommon.CheckPageExistsInLicense(97);
        //if (Session["Edition"].ToString() == "1")
        if (otApprovalExists == 0)
        {
            string strScripts = "";
            strScripts = strScripts + "<script language='javascript'>";
            strScripts = strScripts + "parent.$('#myModal').modal('hide');</script>";
            Page.RegisterStartupScript("AlertManualApproval", strScripts);
            return;
        }
        if (Session["Session_ActiveLanguage"] == null)
        {
            string str = "<script language=\"javascript\">";
            //str = str + "opener.focus();";
            //str = str + "alert(opener.location+'?fl=1&sid=';";
            str = str + "window.top.location.href = window.top.location.href + '?fl=1&sid=" + Session.SessionID + "';";
            str = str + "parent.$('#myModal').modal('hide');";
            str = str + "</script>";
            Response.Write(str);
        }
        else
        {
            string source_Language;
            loginEmployeeId = int.Parse(Session["EmpAutoID"].ToString());
            source_Language = Convert.ToString(Session["Session_ActiveLanguage"]);
            rm = new ResourceManager(source_Language, System.Reflection.Assembly.Load("App_GlobalResources"));
            ci = Thread.CurrentThread.CurrentCulture;
            aspnetForm.Attributes.CssStyle.Add("Direction", rm.GetString("Direction", ci));
            LoadStrings(ci);
            loadcss();
            string strSetAlert = "";
            strSetAlert = strSetAlert + "<script language='javascript'>";
            strSetAlert = strSetAlert + "SetAlertMessages_DeleteRestore('" + rm.GetString("Alert_ConfirmDelete") + "','" + rm.GetString("Alert_SelectItemsToDelete") + "','" + rm.GetString("Alert_ConfirmDeletePermanent") + "','" + rm.GetString("Alert_Areyousuretorestore") + "','" + rm.GetString("Alert_SelectItemsToRestore") + "','" + rm.GetString("Alert_SelectItemToForwarded") + "','" + rm.GetString("Alert_SelectItemToApproved") + "','" + rm.GetString("Alert_SelectItemToForwarded") + "','" + rm.GetString("Alert_SelectItemToApproved") + "');";
            strSetAlert = strSetAlert + "</script>";
            Page.RegisterStartupScript("SetAlertMessages", strSetAlert);
        }
        if (!IsPostBack)
        {
            //Checking Approval Settings
            int intCompanyId;
            string strStatus = string.Empty;
            string strModule = string.Empty;
            string strScript = "";
            strScript = strScript + "<script language='javascript'>";
            bool blnParentExists = true;
            strModule = "OTApproval";
            if (Session["parentLevelId"] == null)
            {
                blnParentExists = false;
            }
            else if (Convert.ToInt32(Session["parentLevelId"]) == 0)
            {
                blnParentExists = false;
            }
            if (blnParentExists == false)
            {
                //strStatus = "Select a company";
                strStatus = rm.GetString("Alert_SelectCompany", ci);
                Div1.Visible = false;
                strScript = strScript + "alert('" + strStatus + "');parent.$('#myModal').modal('hide');";
                strScript = strScript + "</script>";
                Page.RegisterStartupScript("AlertManualApproval", strScript);
                return;
            }
            intCompanyId = getParentCompany(Convert.ToInt32(Session["parentLevelId"]));
            strStatus = GetApprovalStatus(intCompanyId, strModule);
            if (strStatus == "ApprovalNotRequired")
            {
                //lblApprovalStatus.Text = "Approval Not Required for this company";
                //strStatus = "Approval Not Required for this company";
                strStatus = rm.GetString("Alert_ApprovalNotRequiredforthiscompany", ci);
                Div1.Visible = false;
                strScript = strScript + "alert('" + strStatus + "');parent.$('#myModal').modal('hide');";
                strScript = strScript + "</script>";
                Page.RegisterStartupScript("AlertManualApproval", strScript);
                return;
            }
            else if (strStatus == "ApprovalRequired")
            {
                //continue
            }
            else if (strStatus == "NotDefined")
            {
                //lblApprovalStatus.Text = "Approval Settings not defined for this company";
                //strStatus = "Approval Settings not defined for this company";
                strStatus = rm.GetString("Alert_ApprovalSettingsnotdefinedforthiscompany", ci);
                Div1.Visible = false;
                strScript = strScript + "alert('" + strStatus + "');parent.$('#myModal').modal('hide');";
                strScript = strScript + "</script>";
                Page.RegisterStartupScript("AlertManualApproval", strScript);
                return;
            }
            //Approval Settings checking ends here
            OTEmployeeDetails();
            if (OTStatus == "Pending")
            {
                btn_Pending.Visible = false;
            }
            else if (OTStatus == "Approved")
            {
                btn_Approved.Visible = false;
                btn_Forwarded.Visible = false;
            }
            else if (OTStatus == "Forwarded")
            {
                btn_Forwarded.Visible = false;
            }
            else if (OTStatus == "Rejected")
            {
                btn_Reject.Visible = false;
            }
            Session["EmployeeIds"] = "";
        }
        checkRecordExists = true;
        //intCount = grv_EmployeeOTSanction.Rows.Count;
    }
    #endregion
    #region User Defined Functions
    public int getParentCompany(int iEmployeeLevelID)
    {
        //Select Company
        org_levelsEventData getOrg = new org_levelsEventData();
        getOrg.GetOrgParentLevels_FromID(iEmployeeLevelID);
        DataSet ds_getOrg = new DataSet();
        ds_getOrg = getOrg.GetOrgParentLevels();
        int iCompanyID = 0;
        if (ds_getOrg != null)
        {
            if (ds_getOrg.Tables[0].Rows.Count > 0)
            {
                iCompanyID = Convert.ToInt32(ds_getOrg.Tables[0].Rows[0]["LevelID"].ToString());
            }
        }
        return iCompanyID;
    }
    public string GetApprovalStatus(int intCompanyId, string strModule)
    {
        int approvalSettingsPageExists = 0;
        //Checking grade module is available or not and changed the id value from 110 to 228
        approvalSettingsPageExists = objCommon.CheckPageExistsInLicense(228);
        string strStatus = string.Empty;
        if (approvalSettingsPageExists == 1)
        {
            //Get Approval Settings Based on Company Id
            DataSet dsApprovalSettings = new DataSet();
            ShiftEvenData objShift = new ShiftEvenData();
            dsApprovalSettings = objShift.SelectApprovalSettings(intCompanyId);
            if (dsApprovalSettings != null)
            {
                if (dsApprovalSettings.Tables.Count > 0)
                {
                    if (dsApprovalSettings.Tables[0].Rows.Count > 0)
                    {
                        if (Convert.ToBoolean(dsApprovalSettings.Tables[0].Rows[0][strModule]) == false)
                        {
                            strStatus = "ApprovalNotRequired";
                        }
                        else
                        {
                            strStatus = "ApprovalRequired";
                        }
                    }
                    else
                    {
                        strStatus = "NotDefined";
                    }
                }
            }
        }
        else
        {
            strStatus = "ApprovalRequired";
        }
        return strStatus;
    }
    protected void OTEmployeeDetails()
    {
        DataSet dsYearSetting = new DataSet();
        string strFromdate, strTodate;
        string EmployeeID = Request.QueryString["EmpId"].ToString();
        string EmployeeName = Request.QueryString["EmpName"].ToString();
        int EmployeeCategory = Convert.ToInt32(Request.QueryString["EmpCategory"].ToString());
        int EmployeeType = Convert.ToInt32(Request.QueryString["EmpType"].ToString());
        string gstrDateFormat = Session["MDateFormat"].ToString();
        string Fromdate = Request.QueryString["FromDate"].ToString();
        string Todate = Request.QueryString["ToDate"].ToString();
        dsYearSetting = objYearSettingsEventData.GetActiveYearSettings();
        string SanctionType = Request.QueryString["SanctionType"].ToString();
        string strSwipeCard = Convert.ToString(Request.QueryString["SwipeCard"]);
        if (dsYearSetting.Tables[0].Rows.Count <= 0)
        {
            return;
        }
        else
        {
            strFromdate = dsYearSetting.Tables[0].Rows[0]["FromDate"].ToString();
            strTodate = dsYearSetting.Tables[0].Rows[0]["ToDate"].ToString();
        }
        if (Fromdate == string.Empty)
        {
            Fromdate = strFromdate;
        }
        else
        {
            Fromdate = objCommon.DateConvertion(gstrDateFormat, Fromdate);
        }
        if (Todate == string.Empty)
        {
            Todate = strTodate;
        }
        else
        {
            Todate = objCommon.DateConvertion(gstrDateFormat, Todate);
        }
        string Level = rptcommon.getNodes(Convert.ToInt32(Session["parentLevelId"]), Convert.ToString(Session["LevelRights"]));
        OTStatus = Request.QueryString["Status"].ToString();
        dsOtEmployee = objOT.SelectOverTimeEmployee(Convert.ToInt32(Session["EmpAutoID"]),Fromdate, Todate, EmployeeID, EmployeeName, Level, EmployeeCategory, EmployeeType, Convert.ToString(Session["UserGroupName"]), Session["GradeLevel"].ToString(), OTStatus, strSwipeCard, Convert.ToInt32(Session["parentLevelId"]), SanctionType);
        Session["OTEmployee"] = dsOtEmployee;
        Session["TotalEmployees"] = dsOtEmployee.Tables[0].Rows.Count;
        int isRequestCompOff = 0;
        
        if (dsOtEmployee.Tables.Count > 0)
        {
            if (dsOtEmployee.Tables[0].Rows.Count > 0)
            {
                Session["isRequestCompOff"] = Convert.ToString(dsOtEmployee.Tables[0].Rows[0]["isRequestCompOff"]);
                if (Convert.ToInt32(Session["isRequestCompOff"]) == 1)
                {
                    grv_EmployeeOTSanction.Columns[7].Visible = false;
                    grv_EmployeeOTSanction.Columns[8].Visible = false;
                    grv_EmployeeOTSanction.Columns[9].Visible = false;
                    grv_EmployeeOTSanction.Columns[10].Visible = false;
                    grv_EmployeeOTSanction.Columns[11].Visible = false;
                    grv_EmployeeOTSanction.Columns[14].Visible = false;
                    lblle1.Visible = false;
                }
                grv_EmployeeOTSanction.DataSource = dsOtEmployee;
                //Check OT Mins for Comp Off Application Mapping 
                //Session["dtLeaveDetails"]= checkOTMins(dsOtEmployee);
                grv_EmployeeOTSanction.DataBind();
            }
            else
            {
                grv_EmployeeOTSanction.DataSource = dsOtEmployee;
                grv_EmployeeOTSanction.DataBind();
                btn_Approved.Visible = false;
                btn_Forwarded.Visible = false;
                btn_Pending.Visible = false;
                btn_Reject.Visible = false;
                checkRecordExists = false;
            }
        }
        else
        {
            checkRecordExists = false;
        }
        if (checkRecordExists == true)
        {
            CheckBox chkSelect = new CheckBox();
            chkSelect = (CheckBox)grv_EmployeeOTSanction.HeaderRow.Cells[0].FindControl("checkall");
            chkSelect.Checked = Convert.ToBoolean(Session["SelectAllStatus"]);
        }
    }
    public void OTEmployeeSorting_bind()
    {
        DataSet dsSort = new DataSet();
        dsSort = (DataSet)Session["OTEmployee"];
        if (ViewState["sort"] != null)
        {
            dv = new DataView(dsSort.Tables[0]);
            dv.Sort = ViewState["sort"].ToString() + " " + ViewState["sort_direction"].ToString();
        }
        else
        {
            dv = dsSort.Tables[0].DefaultView;
        }
        grv_EmployeeOTSanction.DataSource = dv; ;
        grv_EmployeeOTSanction.DataBind();
    }
    private void LoadStrings(CultureInfo ci)
    {
        btn_Pending.Text = "&nbsp;&nbsp;" + rm.GetString("btn_Pending", ci);
        btn_Approved.Text = "&nbsp;&nbsp;" + rm.GetString("btn_Approved", ci);
        btn_Forwarded.Text = "&nbsp;&nbsp;" + rm.GetString("btn_Forwarded", ci);
        btn_Reject.Text = "&nbsp;&nbsp;" + rm.GetString("btn_Reject", ci);
        grv_EmployeeOTSanction.Columns[2].HeaderText = rm.GetString("Reports_Date", ci);
        grv_EmployeeOTSanction.Columns[3].HeaderText = rm.GetString("Field_EmployeeID", ci);
        grv_EmployeeOTSanction.Columns[4].HeaderText = rm.GetString("Field_EmployeeName", ci);
        grv_EmployeeOTSanction.Columns[5].HeaderText = rm.GetString("LevelDetails_LevelName", ci);
        grv_EmployeeOTSanction.Columns[6].HeaderText = rm.GetString("OTSanction_HoursOt", ci);
        grv_EmployeeOTSanction.Columns[7].HeaderText = rm.GetString("Approved_OTSanction", ci);
        grv_EmployeeOTSanction.Columns[8].HeaderText = rm.GetString("OTSanction_WeeklyoffOt", ci);
        grv_EmployeeOTSanction.Columns[9].HeaderText = rm.GetString("Approved_WeeklyOffOT", ci);
        grv_EmployeeOTSanction.Columns[10].HeaderText = rm.GetString("OTSanction_HolidayOt", ci);
        grv_EmployeeOTSanction.Columns[11].HeaderText = rm.GetString("Approved_HolidayOT", ci);
        grv_EmployeeOTSanction.Columns[12].HeaderText = rm.GetString("Field_Status", ci);
        lblle1.Text = rm.GetString("OT_Hours_Got_Modified", ci);
        lblheader.Text = Convert.ToString(Request.QueryString["SanctionType"]).Contains("OverTime") ? rm.GetString("lblOVerTimeApproval", ci) : rm.GetString("lblCompOffApproval", ci);
        if (lblheader.Text == "Comp Off Approval")
        {
            grv_EmployeeOTSanction.Columns[6].HeaderText = rm.GetString("lbl_ExtraWorkedHrs", ci);
            grv_EmployeeOTSanction.Columns[7].HeaderText = rm.GetString("lbl_ApprovedExtraWorkingHrs", ci);
            grv_EmployeeOTSanction.Columns[8].HeaderText = rm.GetString("lbl_WeeklyOffWorkedHrs", ci);
            grv_EmployeeOTSanction.Columns[9].HeaderText = rm.GetString("lbl_ApprovedWeeklyOffWorkedHrs", ci);
            grv_EmployeeOTSanction.Columns[10].HeaderText = rm.GetString("lbl_HolidayWorkedHrs", ci);
            grv_EmployeeOTSanction.Columns[11].HeaderText = rm.GetString("lbl_ApprovedWorkedHrs", ci);
        }
    }
    protected void UpdatedEmployeeOTStatus(string Status)
    {
        int intEmployeeId = 0;
        int intLoopCounter = 0;
        string strEmployeeCode = string.Empty;
        string strEmployeeName = string.Empty;
        DataSet ds = new DataSet();
        ds = (DataSet)Session["OTEmployee"];
        ds.Tables[0].Columns.Remove("Employee_Code_Id");
        ds.Tables[0].Columns.Remove("date");
        ds.Tables[0].Columns.Remove("shift_id");
        ds.Tables[0].Columns.Remove("HrsWork");
        ds.Tables[0].Columns.Remove("HrsOT");
        ds.Tables[0].Columns.Remove("OffOT");
        ds.Tables[0].Columns.Remove("HolOT");
        ds.Tables[0].Columns.Remove("Employee_FirstName");
        
        ds.Tables[0].Columns.Remove("Level Name");
        ds.Tables[0].Columns.Remove("OTMins");
        if (Status == "Forwarded")
        {
            ds.Tables[0].DefaultView.RowFilter = "OverTimeStatus='Pending' and OverTimeStatus<>'Rejected' and SelectedRecords=1";
        }
        if (Status == "Approved")
        {
            ds.Tables[0].DefaultView.RowFilter = "(OverTimeStatus='Forwarded' or OverTimeStatus='Pending') and OverTimeStatus<>'Rejected' and SelectedRecords=1";
        }
        if (Status == "Rejected")
        {
            ds.Tables[0].DefaultView.RowFilter = "OverTimeStatus<>'Approved'  and SelectedRecords=1";
        }

        ds.Tables[0].Columns.Remove("OverTimeStatus");
        DataTable dtOTStatus = ds.Tables[0].DefaultView.ToTable();
        dtOTStatus.Columns.Remove("SelectedRecords");
        dtOTStatus.Columns.Remove("isRequestCompOff");
        if (Convert.ToInt32(Session["isRequestCompOff"]) == 0)
        {
            dtOTStatus.Columns.Remove("ExtraTime_Id");
            ds.Tables[0].Columns.Remove("Employee_Id");
        }

        StringWriter strWriteXML = new StringWriter();
        string OtDate = "1/1/2011";
        dtOTStatus.TableName = "Table";
        dtOTStatus.WriteXml(strWriteXML);
        objOT.UpdateEmployeeOTStatus(strEmployeeCode, Status, OtDate, strWriteXML.ToString(), Convert.ToInt32(Session["isRequestCompOff"]));
        if (Convert.ToInt32(Session["isRequestCompOff"]) == 1)
        {
            foreach (DataRow DR in dtOTStatus.Rows)
            {
                SendMail(Convert.ToInt32(DR["ExtraTime_Id"]), Status);
            }

        }
        //ExtraTime_Id
        //string strEmployeeIds = Session["EmployeeIds"].ToString();
        //char[] Delimit ={ ',' };
        //string[] EmployeeIds = strEmployeeIds.Split(Delimit);
        //CheckBox chkSelect = new CheckBox();
        //CheckBox chkSelectAll = new CheckBox();
        //intCount = ds.Tables[0].Rows.Count;
        //chkSelectAll = (CheckBox)grv_EmployeeOTSanction.HeaderRow.Cells[0].FindControl("checkall");
        //if (chkSelectAll.Checked)
        //{
        //    foreach (DataRow dr in ds.Tables[0].Rows)
        //    {
        //        //intEmployeeId = ((Label)gr.FindControl("lblEmployeeCodeId")).Text.ToString();
        //        //string OtDate = ((Label)gr.FindControl("lblOTDate")).Text.ToString();//.FindControl("lblOTDate")).Text.ToString();
        //        //strEmployeeCode = ((Label)gr.FindControl("lblEmployeeCodeId")).Text.ToString();
        //        strEmployeeCode = dr["Employee_Code_Id"].ToString();
        //        string OtDate = dr["Date"].ToString();
        //        objOT.UpdateEmployeeOTStatus(strEmployeeCode, Status,OtDate);
        //        CheckGrid = true;
        //    }
        //}
        //else
        //{
        //    foreach (GridViewRow gr in grv_EmployeeOTSanction.Rows)
        //    {
        //        chkSelect = (CheckBox)gr.Cells[0].FindControl("deletethis");
        //        if (chkSelect.Checked)
        //        {
        //            string strEmpCodeId = ((Label)gr.FindControl("lblProc_RecordId")).Text.ToString();
        //            string OtDate = ((Label)gr.FindControl("lblOTDate")).Text.ToString();
        //            for (intLoopCounter = 0; intLoopCounter < intCount; intLoopCounter++)
        //            {
        //                if (ds.Tables[0].Rows[intLoopCounter]["Process_Rec_Id"].ToString() == strEmpCodeId)
        //                {
        //                    //intEmployeeId = Convert.ToInt32(dsOtEmployee.Tables[0].Rows[intLoopCounter]["Employee_Id"].ToString());
        //                    strEmployeeCode = ds.Tables[0].Rows[intLoopCounter]["Employee_Code_Id"].ToString();
        //                    OtDate = ds.Tables[0].Rows[intLoopCounter]["date"].ToString();
        //                    objOT.UpdateEmployeeOTStatus(strEmployeeCode, Status, OtDate);
        //                    CheckGrid = true;
        //                    //objOT.UpdateEmployeeOTStatus(strEmpCodeId, Status,OtDate);
        //                }
        //            }
        //        }
        //    }
        //    foreach (string EmpCId in EmployeeIds)
        //    {
        //        for (intLoopCounter = 0; intLoopCounter < intCount; intLoopCounter++)
        //        {
        //            if (ds.Tables[0].Rows[intLoopCounter]["Process_Rec_Id"].ToString() == EmpCId)
        //            {
        //                ///intEmployeeId = Convert.ToInt32(ds.Tables[0].Rows[intLoopCounter]["Employee_Id"].ToString());
        //                strEmployeeCode = ds.Tables[0].Rows[intLoopCounter]["Employee_Code_Id"].ToString();
        //                string OtDate = ds.Tables[0].Rows[intLoopCounter]["date"].ToString();
        //                objOT.UpdateEmployeeOTStatus(strEmployeeCode, Status,OtDate);
        //            }
        //        }
        //    }
        //}
    }
    public void SendMail(int CompOffID, string status)
    {
        try
        {
            ViewDetails(CompOffID);
            dsEmployeeDetails = objEmployeeEventData.GetEmployeeDetails(Convert.ToInt32(ViewState["iEmployeeID"]));
            if (dsEmployeeDetails.Tables.Count > 0)
            {
                if (dsEmployeeDetails.Tables[0].Rows.Count > 0)
                {
                    if (dsEmployeeDetails.Tables[0].Rows[0]["ReportingToEmailID"] != DBNull.Value)
                    {
                        strEmailIdReportingTo = Convert.ToString(dsEmployeeDetails.Tables[0].Rows[0]["ReportingToEmailID"]);
                    }
                    if (dsEmployeeDetails.Tables[0].Rows[0]["ApprovalAuthorityEmailID"] != DBNull.Value)
                    {
                        strEmailIdSanctioningAuthority = Convert.ToString(dsEmployeeDetails.Tables[0].Rows[0]["ApprovalAuthorityEmailID"]);
                    }
                    strEmpFirstName = Convert.ToString(dsEmployeeDetails.Tables[0].Rows[0]["Employee_FirstName"]);
                    strEmpLastName = Convert.ToString(dsEmployeeDetails.Tables[0].Rows[0]["Employee_LastName"]);
                    strEmployeeCodeId = Convert.ToString(dsEmployeeDetails.Tables[0].Rows[0]["Employee_Code_Id"]);
                    strEmployeeName = strEmpFirstName + " " + strEmpLastName;
                    strlevelName = Convert.ToString(dsEmployeeDetails.Tables[0].Rows[0]["levelName"]);
                    strEmailID = Convert.ToString(dsEmployeeDetails.Tables[0].Rows[0]["EmailId"]);
                    blnCheckEmail = ObjEmailTrigger.SendMailCompOff(strEmailID, strEmailIdReportingTo, strEmailIdSanctioningAuthority, strEmployeeCodeId, strEmployeeName, Convert.ToString(ViewState["strAppDate"]), Convert.ToString(ViewState["strComDate"]), Convert.ToString(ViewState["CompIntime"]), Convert.ToString(ViewState["CompOuttime"]), Convert.ToString(ViewState["CompType"]), Convert.ToString(ViewState["CompWorkedHrs"]), Convert.ToString(ViewState["CompReason"]), status, strlevelName, "Sanction");
                }
            }
        }
        catch(Exception ex)
        {

        }
    }
    public void ViewDetails(int CompoffID)
    {
        DataSet dsCompensation = new DataSet();
        dsCompensation = objEmployeeEventData.SelectCompensationDatabyid(CompoffID);
        iEmployeeID = Convert.ToInt32(dsCompensation.Tables[0].Rows[0]["E_Employee_Id"]);
        ViewState["iEmployeeID"] = iEmployeeID.ToString();
        ViewState["StatusOfApplication"] = dsCompensation.Tables[0].Rows[0]["Comp_Status"].ToString();
        ViewState["Emp_Code_ID"] = dsCompensation.Tables[0].Rows[0]["Employee_Id"].ToString();
        ViewState["strComDate"] = dsCompensation.Tables[0].Rows[0]["FromDate"].ToString();
        ViewState["strAppDate"] = dsCompensation.Tables[0].Rows[0]["ApplicationDate"].ToString();
        //ViewState["strComDate"] = objClassCommon.DateConvertion(gstrDateFormat, Convert.ToString(ViewState["strComDate"]));
        ViewState["CompType"] = dsCompensation.Tables[0].Rows[0]["DayWorked"].ToString();
        ViewState["CompIntime"] = dsCompensation.Tables[0].Rows[0]["InTime"].ToString();
        ViewState["CompOuttime"] = dsCompensation.Tables[0].Rows[0]["OutTime"].ToString();
        ViewState["CompWorkedHrs"] = dsCompensation.Tables[0].Rows[0]["WorkedHours"].ToString();
        ViewState["CompStatus"] = dsCompensation.Tables[0].Rows[0]["Comp_Status"].ToString();
        ViewState["CompReason"] = dsCompensation.Tables[0].Rows[0]["Reason"].ToString();
    }

    public void GetEmptyText(object sender, EventArgs e)
    {
        Label lblNoRecords = (Label)sender;
        lblNoRecords.Text = rm.GetString("Alert_Norecordsfound", ci);
    }
    #endregion
    #region Grid View Events
    protected void grv_CheckAll_CheckedChanged(object sender, EventArgs e)
    {
        grv_EmployeeOTSanction.EnableViewState = true;
        DataSet dsOTSanction = new DataSet();
        dsOTSanction = (DataSet)Session["OTEmployee"];
        //dsOTSanction.BeginInit();
        //dsOTSanction.Tables[0].Columns.Remove(dsOTSanction.Tables[0].Columns["SelectedRecords"]);
        foreach (DataRow dRowOTSanction in dsOTSanction.Tables[0].Rows)
        {
            if (((CheckBox)(sender)).Checked == true)
            {
                dRowOTSanction["SelectedRecords"] = "1";
                //dsOTSanction.Tables[0].Columns.Add("SelectedRecords", Type.GetType("System.String"), "'0'");
            }
            else
            {
                dRowOTSanction["SelectedRecords"] = "0";
                //dsOTSanction.Tables[0].Columns.Add("SelectedRecords", Type.GetType("System.String"), "'1'");
            }
        }
        //dsOTSanction.EndInit();
        Session["OTEmployee"] = dsOTSanction;
        grv_EmployeeOTSanction.DataSource = dsOTSanction;
        grv_EmployeeOTSanction.DataBind();
        CheckBox chkSelect = new CheckBox();
        chkSelect = (CheckBox)grv_EmployeeOTSanction.HeaderRow.Cells[0].FindControl("checkall");
        if (((CheckBox)(sender)).Checked)
        {
            chkSelect.Checked = true;
        }
        else
        {
            chkSelect.Checked = false;
        }
        Session["SelectAllStatus"] = chkSelect.Checked;
        //string ChkBoxIDs = string.Empty;
        //if (chkSelect.Checked)
        //{
        //    ChkBoxIDs = GetEmployeeIdsInOtherPagesOfGrid();
        //    if (Session["EmployeeIds"].ToString() == "")
        //    {
        //        Session["EmployeeIds"] = ChkBoxIDs;
        //    }
        //    else
        //    {
        //        if (ChkBoxIDs != "")
        //        {
        //            Session["EmployeeIds"] = Session["EmployeeIds"] + "," + ChkBoxIDs;
        //        }
        //    }
        //}
        //else
        //{
        //    Session["EmployeeIds"] = string.Empty;
        //}
        //foreach (GridViewRow gr in grv_EmployeeOTSanction.Rows)
        //{
        //    chkSelect = (CheckBox)gr.Cells[0].FindControl("deletethis");
        //    if (chkSelect.Enabled == true)
        //    {
        //        chkSelect.Checked = ((CheckBox)sender).Checked;
        //    }
        //}
    }
    protected void grv_OTSanction_PageIndexChanging(object sender, GridViewPageEventArgs e)
    {
        grv_EmployeeOTSanction.EnableViewState = true;
        //Session["EmployeeIds"] = "";
        //comment by prabakaran on 06-may-11
        ////grv_EmployeeOTSanction.EnableViewState = true;
        ////string ChkBoxIDs = "";
        //////bool BxsChkd = false;
        ////CheckBox deleteChkBxItem = new CheckBox();
        ////// Add EmployeeId in Session Variable.
        ////foreach (GridViewRow i in grv_EmployeeOTSanction.Rows)
        ////{
        ////    //HtmlInputCheckBox deleteChkBxItem = (HtmlInputCheckBox)i.FindControl("deletethis");
        ////    deleteChkBxItem = (CheckBox)i.Cells[0].FindControl("deletethis");
        ////    if (deleteChkBxItem.Checked)
        ////    {
        ////        //BxsChkd = true;
        ////        if (ChkBoxIDs == "")
        ////        {
        ////            ChkBoxIDs = ((Label)i.FindControl("lblProc_RecordId")).Text.ToString();
        ////        }
        ////        else
        ////        {
        ////            // Concatenate DataGrid item with comma for SQL Delete
        ////            ChkBoxIDs = ChkBoxIDs + "," + ((Label)i.FindControl("lblProc_RecordId")).Text.ToString();
        ////        }
        ////    }
        ////}
        ////if (Session["EmployeeIds"].ToString() == "")
        ////{
        ////    Session["EmployeeIds"] = ChkBoxIDs;
        ////}
        ////else
        ////{
        ////    if (ChkBoxIDs != "")
        ////    {
        ////        Session["EmployeeIds"] = Session["EmployeeIds"] + "," + ChkBoxIDs;
        ////    }
        ////}
        grv_EmployeeOTSanction.PageIndex = e.NewPageIndex;
        //comment by prabakaran on 03-may-11
        ////OTEmployeeDetails();
        grv_EmployeeOTSanction.DataSource = (DataSet)Session["OTEmployee"];
        grv_EmployeeOTSanction.DataBind();
        CheckBox chkSelect = new CheckBox();
        chkSelect = (CheckBox)grv_EmployeeOTSanction.HeaderRow.Cells[0].FindControl("checkall");
        chkSelect.Checked = Convert.ToBoolean(Session["SelectAllStatus"]);
        //CheckEmployeeId_CheckBox();
    }
    protected void grv_Check_CheckedChanged(object sender, EventArgs e)
    {
        Label lblProcessRecId = new Label();
        lblProcessRecId.Text = ((Label)((CheckBox)(sender)).FindControl("lblProc_RecordId")).Text.ToString();
        DataSet dsOTSanction = new DataSet();
        dsOTSanction = (DataSet)Session["OTEmployee"];
        DataRow[] OTSanctionRow = dsOTSanction.Tables[0].Select("Process_Rec_ID = " + lblProcessRecId.Text);
        if (OTSanctionRow.Length > 0)
        {
            if (((CheckBox)(sender)).Checked == true)
            {
                OTSanctionRow[0]["SelectedRecords"] = "1";
            }
            else
            {
                OTSanctionRow[0]["SelectedRecords"] = "0";
            }
        }
        dsOTSanction.Tables[0].DefaultView.RowFilter = "SelectedRecords=0";
        int intSelectAllCount = dsOTSanction.Tables[0].DefaultView.ToTable().Rows.Count;
        CheckBox chkSelectAll = new CheckBox();
        chkSelectAll = (CheckBox)grv_EmployeeOTSanction.HeaderRow.Cells[0].FindControl("checkall");
        if (intSelectAllCount == 0)
        {
            chkSelectAll.Checked = true;
        }
        else
        {
            chkSelectAll.Checked = false;
        }
        Session["SelectAllStatus"] = chkSelectAll.Checked;
        Session["OTEmployee"] = dsOTSanction;
        //string ChkBoxIDs = string.Empty;
        //int intCount = 0;
        //int intGridPageSize = grv_EmployeeOTSanction.PageSize;
        //int intGridTotalPages = grv_EmployeeOTSanction.PageCount;
        //bool boolAllChecked = false;
        //CheckBox chkSelect = new CheckBox();
        //CheckBox chkSelectAll = new CheckBox();
        //chkSelectAll = (CheckBox)grv_EmployeeOTSanction.HeaderRow.Cells[0].FindControl("checkall");
        //if (((CheckBox)sender).Checked == false)
        //{
        //    chkSelectAll.Checked = false;
        //}
        //else
        //{
        //    foreach (GridViewRow gr in grv_EmployeeOTSanction.Rows)
        //    {
        //        //intCount Keeps track of the number of checkbox checked in the current page.
        //        chkSelect = (CheckBox)gr.Cells[0].FindControl("deletethis");
        //        if (chkSelect.Checked)
        //            intCount = intCount + 1;
        //    }
        //    if (Convert.ToInt32(Session["TotalEmployees"].ToString()) == intCount)
        //    {
        //        //no paging and all chekbox is in checked state
        //        chkSelectAll.Checked = true;
        //    }
        //    else if (intCount > 0 && Convert.ToInt32(Session["TotalEmployees"].ToString()) > intCount && Convert.ToInt32(Session["TotalEmployees"].ToString()) > intGridPageSize)
        //    {
        //        //Paging is present.
        //        if (intCount == intGridPageSize)
        //        {   //All checkbox are checked in the current page
        //            if (Session["EmployeeIds"] != null || Session["EmployeeIds"].ToString() != string.Empty)
        //            {   //some checkbox in other pages is also checked
        //                ChkBoxIDs = GetEmployeeIdsInOtherPagesOfGrid();
        //                char[] Delimit ={ ',' };
        //                string[] SessionEmployeeIds = Session["EmployeeIds"].ToString().Split(Delimit);
        //                string[] ChedkedEmployeeIds = ChkBoxIDs.Split(Delimit);
        //                Array.Sort(SessionEmployeeIds);
        //                Array.Sort(ChedkedEmployeeIds);
        //                if (SessionEmployeeIds.Length == ChedkedEmployeeIds.Length)
        //                {
        //                    for (int iLoop = 0; iLoop < ChedkedEmployeeIds.Length; iLoop++)
        //                    {
        //                        if (SessionEmployeeIds[iLoop] != ChedkedEmployeeIds[iLoop])
        //                        {
        //                            boolAllChecked = false;
        //                            break;
        //                        }
        //                    }
        //                    boolAllChecked = true;
        //                }
        //                if (boolAllChecked == true)
        //                {   //All checkBox Checked
        //                    chkSelectAll.Checked = true;
        //                }
        //            }
        //        }
        //        else if (grv_EmployeeOTSanction.PageIndex == intGridTotalPages - 1)
        //        {   //Last Page
        //            int intLastPageCount = Convert.ToInt32(Session["TotalEmployees"].ToString()) - (intGridPageSize * (intGridTotalPages - 1));
        //            if (intCount == intLastPageCount)
        //            {
        //                if (Session["EmployeeIds"] != null || Session["EmployeeIds"].ToString() != string.Empty)
        //                {   //some checkbox in other pages is also checked
        //                    ChkBoxIDs = GetEmployeeIdsInOtherPagesOfGrid();
        //                    char[] Delimit ={ ',' };
        //                    string[] SessionEmployeeIds = Session["EmployeeIds"].ToString().Split(Delimit);
        //                    string[] ChedkedEmployeeIds = ChkBoxIDs.Split(Delimit);
        //                    Array.Sort(SessionEmployeeIds);
        //                    Array.Sort(ChedkedEmployeeIds);
        //                    if (SessionEmployeeIds.Length == ChedkedEmployeeIds.Length)
        //                    {
        //                        for (int iLoop = 0; iLoop < ChedkedEmployeeIds.Length; iLoop++)
        //                        {
        //                            if (SessionEmployeeIds[iLoop] != ChedkedEmployeeIds[iLoop])
        //                            {
        //                                boolAllChecked = false;
        //                                break;
        //                            }
        //                        }
        //                        boolAllChecked = true;
        //                    }
        //                    if (boolAllChecked == true)
        //                    {   //All checkBox Checked
        //                        chkSelectAll.Checked = true;
        //                    }
        //                }
        //            }
        //        }
        //    }
        //}
    }
    protected void grv_EmployeeOTSanction_RowDataBound(object sender, GridViewRowEventArgs e)
    {
        if (e.Row.RowType == DataControlRowType.DataRow)
        {
            Label lblStatus = (Label)e.Row.FindControl("lblOTStatus");
            Label lblHoursOT = (Label)e.Row.FindControl("lblHoursOT");
            Label lblWeekOffOT = (Label)e.Row.FindControl("lblWeeklyoffOT");
            Label lblHolidayOT = (Label)e.Row.FindControl("lblHolidayOT");
            Label lblHoursOT1 = (Label)e.Row.FindControl("lblHoursOT1");
            Label lblWeekOffOT1 = (Label)e.Row.FindControl("lblWeeklyoffOT1");
            Label lblHolidayOT1 = (Label)e.Row.FindControl("lblHoliday1");

            if (lblHoursOT1 != null)
            {
                if (lblHoursOT.Text == lblHoursOT1.Text)
                {
                    lblHoursOT1.Style.Add("color", "#333");
                }
                else
                {
                    lblHoursOT1.Style.Add("color", "#F00");
                }
            }
            if (lblWeekOffOT1 != null)
            {
                if (lblWeekOffOT.Text == lblWeekOffOT1.Text)
                {
                    lblWeekOffOT1.Style.Add("color", "#333");
                }
                else
                {
                    lblWeekOffOT1.Style.Add("color", "#F00");
                }
            }
            if (lblHolidayOT1 != null)
            {
                if (lblHolidayOT.Text == lblHolidayOT1.Text)
                {
                    lblHolidayOT1.Style.Add("color", "#333");
                }
                else
                {
                    lblHolidayOT1.Style.Add("color", "#F00");
                }
            }


            if (lblStatus.Text == "Approved")
            {
                lblStatus.Text = rm.GetString("btn_Approved", ci);
            }
            else if (lblStatus.Text == "Forwarded")
            {
                lblStatus.Text = rm.GetString("btn_Forwarded", ci);
            }
            else if (lblStatus.Text == "Pending")
            {
                lblStatus.Text = rm.GetString("btn_Pending", ci);
            }
            else if (lblStatus.Text == "Rejected")
            {
                lblStatus.Text = rm.GetString("btn_Reject", ci);
            }
            Label lbl = (Label)e.Row.Cells[2].FindControl("lblOTDate");
            if (lbl.Text != "")
            {
                lbl.Text = (Convert.ToDateTime(lbl.Text.ToString())).ToString(Session["MDateFormat"].ToString());
                //e.Row.Cells[2].Controls.Add(lbl);
            }
        }

        ////int gintOTMinsLeaveApplication = 0;
        ////TimeSpan tsOtMinsHrs = new TimeSpan();
        ////if (Session["dtLeaveDetails"] != null)
        ////{
        ////    dtLeaveOTDetails = (DataTable)Session["dtLeaveDetails"];
        ////}
        ////     CheckBox ChkDeleted = (CheckBox)e.Row.Cells[0].FindControl("deletethis");
        ////     Label lblOTMins = (Label)e.Row.Cells[0].FindControl("lblOTMins");
        ////     Label lblEmployeeCodeId = (Label)e.Row.Cells[0].FindControl("lblEmployeeCodeId");
        ////     int OTMinsProcessedData = Convert.ToInt32(lblOTMins.Text);
        ////     if (gintOTMinsLeaveApplication == 0)
        ////     {
        ////         dtLeaveOTDetails.DefaultView.RowFilter = "EmployeeCodeId = '" + lblEmployeeCodeId.Text + "'";
        ////         if (dtLeaveOTDetails.DefaultView.Count > 0)
        ////         {
        ////             gintOTMinsLeaveApplication = Convert.ToInt32(dtLeaveOTDetails.DefaultView[0]["OTMinsLeaveApplication"]);
        ////         }
        ////         //if (gintOTMinsLeaveApplication > OTMinsProcessedData)
        ////         //{
        ////         //    ChkDeleted.Enabled = false;
        ////         //    gintOTMinsLeaveApplication = gintOTMinsLeaveApplication - OTMinsProcessedData;
        ////             foreach (DataRow dRow in dtLeaveOTDetails.Rows)
        ////             {
        ////                 if (dRow["EmployeeCodeId"] == lblEmployeeCodeId.Text)
        ////                 {
        ////                     if (dRow["OtHours"].ToString() != string.Empty && Convert.ToInt32(dRow["OtMinsLeaveApplication"])>0)
        ////                     {
        ////                         tsOtMinsHrs = DateTime.Parse(dRow["OtHours"].ToString()).TimeOfDay;
        ////                         if (OTMinsProcessedData > tsOtMinsHrs.TotalMinutes)
        ////                         {
        ////                             dRow["OTMinsLeaveApplication"] = gintOTMinsLeaveApplication - tsOtMinsHrs.TotalMinutes;
        ////                             ChkDeleted.Enabled = false;
        ////                         }
        ////                     }
        ////                 }
        ////             }
        ////         //}
        ////     }
        //// }
    }

    //protected void grv_EmployeeOTSanction_RowEditing(object sender, GridViewEditEventArgs e)
    //{
    //    grv_EmployeeOTSanction.EditIndex = e.NewEditIndex;
    //    grv_EmployeeOTSanction.DataSource = (DataSet)Session["OTEmployee"];
    //    grv_EmployeeOTSanction.DataBind();
    //}
    //protected void grv_EmployeeOTSanction_RowCancelingEdit(object sender, GridViewEditEventArgs e)
    //{
    //    grv_EmployeeOTSanction.EditIndex = e.NewEditIndex;
    //    grv_EmployeeOTSanction.DataSource = (DataSet)Session["OTEmployee"];
    //    grv_EmployeeOTSanction.DataBind();
    //}

    public void grv_OTSanctionSorting(object sender, GridViewSortEventArgs e)
    {
        ViewState["sort"] = e.SortExpression;
        ViewState["sort"] = e.SortExpression;
        if (ViewState["sort_direction"] == null)
        {
            ViewState["sort_direction"] = "Asc";
        }
        else if (ViewState["sort_direction"].ToString() == "Asc")
        {
            ViewState["sort_direction"] = "Desc";
        }
        else
        {
            ViewState["sort_direction"] = "Asc";
        }
        OTEmployeeSorting_bind();
    }
    #endregion
    #region Button Events
    protected void btn_Approved_Click(object sender, EventArgs e)
    {
        if (Convert.ToString(ViewState["EditMode"]) == "True")
        {
            string str = "<script language=\"javascript\">";
            //str = str + "alert('Select Any Record');";
            str = str + "alert('" + rm.GetString("Alert_UpdatetheOThoursandthenproceedwithapprovals", ci) + "');";
            str = str + "</script>";
            Page.RegisterStartupScript("alert", str);
            return;
        }
        DataSet dsOTSanction = new DataSet();
        dsOTSanction = (DataSet)Session["OTEmployee"];
        dsOTSanction.Tables[0].DefaultView.RowFilter = "SelectedRecords=1";
        int intSelectAllCount = dsOTSanction.Tables[0].DefaultView.ToTable().Rows.Count;
        if (intSelectAllCount == 0)
        {
            string str = "<script language=\"javascript\">";
            //str = str + "alert('Select Any Record');";
            str = str + "alert('" + rm.GetString("Alert_SelectAnyRecord", ci) + "');";
            str = str + "</script>";
            Page.RegisterStartupScript("alert", str);
        }
        else
        {
            dsOTSanction.Tables[0].DefaultView.RowFilter = "(OverTimeStatus='Approved' or OverTimeStatus='Rejected') and SelectedRecords=1";
            int intSelectAllCount1 = dsOTSanction.Tables[0].DefaultView.ToTable().Rows.Count;
            if (intSelectAllCount1 != 0)
            {
                string str = "<script language=\"javascript\">";
                //str = str + "alert('Select Any Record');";
                str = str + "alert('" + rm.GetString("Aleart_OTApprovedStatus", ci) + "');";
                str = str + "</script>";
                Page.RegisterStartupScript("alert", str);
                return;
            }
            UpdatedEmployeeOTStatus("Approved");
            string str1 = "<script language=\"javascript\">";
            //str = str + "alert('Saved Successfully');";
            str1 = str1 + "alert('" + rm.GetString("Alert_SavedSuccessfully", ci) + "');";
            //str1 = str1 + "opener.focus();";
            //str = str + "alert(opener.location+'?fl=1&sid=';";
            str1 = str1 + "window.top.location.href = window.top.location.href + '?fl=1&sid=" + Session.SessionID + "';";
            str1 = str1 + "parent.$('#myModal').modal('hide');";
            str1 = str1 + "</script>";
            Page.RegisterStartupScript("alert", str1);
        }
    }
    protected void btn_Pending_Click(object sender, EventArgs e)
    {
        if (Convert.ToString(ViewState["EditMode"]) == "True")
        {
            string str = "<script language=\"javascript\">";
            //str = str + "alert('Select Any Record');";
            str = str + "alert('" + rm.GetString("Alert_UpdatetheOThoursandthenproceedwithapprovals", ci) + "');";
            str = str + "</script>";
            Page.RegisterStartupScript("alert", str);
            return;
        }
        DataSet dsOTSanction = new DataSet();
        dsOTSanction = (DataSet)Session["OTEmployee"];
        dsOTSanction.Tables[0].DefaultView.RowFilter = "SelectedRecords=1";
        int intSelectAllCount = dsOTSanction.Tables[0].DefaultView.ToTable().Rows.Count;
        if (intSelectAllCount == 0)
        {
            string str = "<script language=\"javascript\">";
            //str = str + "alert('Select Any Record');";
            str = str + "alert('" + rm.GetString("Alert_SelectAnyRecord", ci) + "');";
            str = str + "</script>";
            Page.RegisterStartupScript("alert", str);
        }
        else
        {
            UpdatedEmployeeOTStatus("Pending");
            string str = "<script language=\"javascript\">";
            //str = str + "alert('Saved Successfully');";
            str = str + "alert('" + rm.GetString("Alert_SavedSuccessfully", ci) + "');";
            //str = str + "opener.focus();";
            //str = str + "alert(opener.location+'?fl=1&sid=';";
            str = str + "window.top.location.href = window.top.location.href + '?fl=1&sid=" + Session.SessionID + "';";
            str = str + "parent.$('#myModal').modal('hide');";
            str = str + "</script>";
            Page.RegisterStartupScript("alert", str);
        }
    }
    protected void btn_Forwarded_Click(object sender, EventArgs e)
    {
        if (Convert.ToString(ViewState["EditMode"]) == "True")
        {
            string str = "<script language=\"javascript\">";
            //str = str + "alert('Select Any Record');";
            str = str + "alert('" + rm.GetString("Alert_UpdatetheOThoursandthenproceedwithapprovals", ci) + "');";
            str = str + "</script>";
            Page.RegisterStartupScript("alert", str);
            return;
        }
        DataSet dsOTSanction = new DataSet();
        dsOTSanction = (DataSet)Session["OTEmployee"];
        dsOTSanction.Tables[0].DefaultView.RowFilter = "SelectedRecords=1";
        int intSelectAllCount = dsOTSanction.Tables[0].DefaultView.ToTable().Rows.Count;
        if (intSelectAllCount == 0)
        {
            string str = "<script language=\"javascript\">";
            //str = str + "alert('Select Any Record');";
            str = str + "alert('" + rm.GetString("Alert_SelectAnyRecord", ci) + "');";
            str = str + "</script>";
            Page.RegisterStartupScript("alert", str);
        }
        else
            dsOTSanction.Tables[0].DefaultView.RowFilter = "(OverTimeStatus='Approved' or OverTimeStatus='Rejected') and SelectedRecords=1";
        int intSelectAllCount1 = dsOTSanction.Tables[0].DefaultView.ToTable().Rows.Count;
        if (intSelectAllCount1 != 0)
        {
            string str = "<script language=\"javascript\">";
            //str = str + "alert('Select Any Record');";
            str = str + "alert('" + rm.GetString("Aleart_OTApprovedStatus", ci) + "');";
            str = str + "</script>";
            Page.RegisterStartupScript("alert", str);
            return;
        }
        {
            UpdatedEmployeeOTStatus("Forwarded");
            string str1 = "<script language=\"javascript\">";
            //str = str + "alert('Saved Successfully');";
            str1 = str1 + "alert('" + rm.GetString("Alert_SavedSuccessfully", ci) + "');";
            //str1 = str1 + "opener.focus();";
            //str = str + "alert(opener.location+'?fl=1&sid=';";
            str1 = str1 + "window.top.location.href = window.top.location.href + '?fl=1&sid=" + Session.SessionID + "';";
            str1 = str1 + "parent.$('#myModal').modal('hide');";
            str1 = str1 + "</script>";
            Page.RegisterStartupScript("alert", str1);
        }
    }
    protected void btn_Reject_Click(object sender, EventArgs e)
    {
        if (Convert.ToString(ViewState["EditMode"]) == "True")
        {
            string str = "<script language=\"javascript\">";
            //str = str + "alert('Select Any Record');";
            str = str + "alert('" + rm.GetString("Alert_UpdatetheOThoursandthenproceedwithapprovals", ci) + "');";
            str = str + "</script>";
            Page.RegisterStartupScript("alert", str);
            return;
        }
        DataSet dsOTSanction = new DataSet();
        dsOTSanction = (DataSet)Session["OTEmployee"];
        dsOTSanction.Tables[0].DefaultView.RowFilter = "SelectedRecords=1";
        int intSelectAllCount = dsOTSanction.Tables[0].DefaultView.ToTable().Rows.Count;
        if (intSelectAllCount == 0)
        {
            string str = "<script language=\"javascript\">";
            str = str + "alert('" + rm.GetString("Alert_SelectAnyRecord", ci) + "');";
            str = str + "</script>";
            Page.RegisterStartupScript("alert", str);
        }
        else
        {
            dsOTSanction.Tables[0].DefaultView.RowFilter = "(OverTimeStatus='Approved' or OverTimeStatus='Rejected') and SelectedRecords=1";
            int intSelectAllCount1 = dsOTSanction.Tables[0].DefaultView.ToTable().Rows.Count;
            if (intSelectAllCount1 != 0)
            {
                string str = "<script language=\"javascript\">";
                //str = str + "alert('Select Any Record');";
                str = str + "alert('" + rm.GetString("Aleart_OTApprovedStatus", ci) + "');";
                str = str + "</script>";
                Page.RegisterStartupScript("alert", str);
                return;
            }
            UpdatedEmployeeOTStatus("Rejected");
            string str1 = "<script language=\"javascript\">";
            str1 = str1 + "alert('" + rm.GetString("Alert_SavedSuccessfully", ci) + "');";
            //str1 = str1 + "opener.focus();";
            //str = str + "alert(opener.location+'?fl=1&sid=';";
            str1 = str1 + "window.top.location.href = window.top.location.href + '?fl=1&sid=" + Session.SessionID + "';";
            str1 = str1 + "parent.$('#myModal').modal('hide');";
            str1 = str1 + "</script>";
            Page.RegisterStartupScript("alert", str1);
        }
    }
    #endregion
    #region Not Used
    public void CheckEmployeeId_CheckBox()
    {
        string strEmpId = "";
        strEmpId = (string)Session["EmployeeIds"];
        int intEmployeeIdsLength = strEmpId.Length;
        char[] Delimit ={ ',' };
        string[] Empid = strEmpId.Split(Delimit);
        CheckBox deleteChkBxItem = new CheckBox();
        foreach (GridViewRow gr in grv_EmployeeOTSanction.Rows)
        {
            string empId = ((Label)gr.FindControl("lblProc_RecordId")).Text.ToString();
            foreach (string str in Empid)
            {
                if (str == empId)
                {
                    //HtmlInputCheckBox deleteChkBxItem = (HtmlInputCheckBox)gr.FindControl("deletethis");
                    deleteChkBxItem = (CheckBox)gr.Cells[0].FindControl("deletethis");
                    deleteChkBxItem.Checked = true;
                    int intLength = empId.Length;
                    //int intActualIndex = 0;
                    if (intEmployeeIdsLength > intLength)
                    {
                        //More than One Id Present in the list
                        int intIndex = strEmpId.IndexOf("," + str + ",");
                        if (intIndex != -1)
                        {
                            //Exist in between
                            strEmpId = strEmpId.Remove(intIndex, (intLength + 1));
                        }
                        else
                        {
                            //Exist as the first or last
                            if (strEmpId.IndexOf(str + ",") != -1 && strEmpId.IndexOf(str + ",") == 0)
                            {
                                //Exist as a first Id
                                strEmpId = strEmpId.Remove(0, (intLength + 1));
                            }
                            else if (strEmpId.IndexOf("," + str) != -1 && (strEmpId.IndexOf("," + str) + intLength + 1) == intEmployeeIdsLength)
                            {
                                //Exist as a Last Id
                                strEmpId = strEmpId.Substring(0, (intEmployeeIdsLength - (intLength + 1)));
                            }
                        }
                    }
                    else
                    {
                        //Only one Id in the list
                        strEmpId = strEmpId.Replace(empId, "");
                    }
                    intEmployeeIdsLength = strEmpId.Length;
                    Session["EmployeeIds"] = strEmpId;
                    goto D;
                }
            }
        D: ;
        }
    }
    protected string GetEmployeeIdsInOtherPagesOfGrid()
    {
        DataSet ds = new DataSet();
        ds = (DataSet)Session["OTEmployee"];
        string strEmpId = string.Empty;
        //string ChkBoxIDs = string.Empty;
        StringBuilder ChkBoxIDs = new StringBuilder();
        foreach (DataRow dr in ds.Tables[0].Rows)
        {
            foreach (GridViewRow gr in grv_EmployeeOTSanction.Rows)
            {
                strEmpId = ((Label)gr.FindControl("lblProc_RecordId")).Text.ToString();
                //strEmpId = ((HiddenField)gr.FindControl("lblProcess_Rec_ID")).Value.ToString();
                CheckBox chkEnabled = (CheckBox)gr.FindControl("deletethis");
                if (chkEnabled.Enabled == false)
                {
                    goto A;
                }
                if (strEmpId == dr["Process_Rec_ID"].ToString())
                {
                    goto A;
                }
            }
            if (ChkBoxIDs.ToString() == "")
            {
                ChkBoxIDs.Append(dr["Process_Rec_ID"].ToString());
            }
            else
            {
                ChkBoxIDs.Append("," + dr["Process_Rec_ID"].ToString());
            }
        A: ;
        }
        return ChkBoxIDs.ToString();
    }
    private DataTable checkOTMins(DataSet dsOtMinsEmployee)
    {
        DataColumn dcEmployeeId = new DataColumn("EmployeeCodeId");
        DataColumn dcOTHours = new DataColumn("OTHours");
        DataColumn dcOTMinsLeaveApplication = new DataColumn("OTMinsLeaveApplication");
        DataRow dRowOTDetails;
        dtLeaveOTDetails.Columns.Add(dcEmployeeId);
        dtLeaveOTDetails.Columns.Add(dcOTMinsLeaveApplication);
        dtLeaveOTDetails.Columns.Add(dcOTHours);
        string strEmployeeId = string.Empty;
        //Get OT Hours Based on Comp Off Day Leave Application for Each Employee 
        //if (checkRecordExists == true)
        //{
        foreach (DataRow dRow in dsOtMinsEmployee.Tables[0].Rows)
        {
            if (dRow["Employee_Code_Id"].ToString() != strEmployeeId)
            {
                dtLeaveApplicationOTHrs = objOT.SelectOverTimeLeaveApplication(dRow["Employee_Id"].ToString());
                dRowOTDetails = dtLeaveOTDetails.NewRow();
                dRowOTDetails["EmployeeCodeId"] = dRow["Employee_Code_Id"];
                if (dtLeaveApplicationOTHrs.Rows.Count > 0)
                {
                    dRowOTDetails["OTMinsLeaveApplication"] = Convert.ToInt32(dtLeaveApplicationOTHrs.Rows[0]["OTMinsLeaveApplication"]);
                    dRowOTDetails["OTHours"] = dtLeaveApplicationOTHrs.Rows[0]["OtMinHrs"];
                }
                else
                {
                }
                dRowOTDetails.EndEdit();
                dtLeaveOTDetails.Rows.Add(dRowOTDetails);
                strEmployeeId = dRow["Employee_Code_Id"].ToString();
            }
        }
        return dtLeaveOTDetails;
        //}
    }
    #endregion
    protected void grv_EmployeeOTSanction_RowCancelingEdit(object sender, GridViewCancelEditEventArgs e)
    {
        grv_EmployeeOTSanction.EditIndex = -1;
        grv_EmployeeOTSanction.DataSource = (DataSet)Session["OTEmployee"];
        grv_EmployeeOTSanction.DataBind();
        ViewState["EditMode"] = "Fales";
    }
    protected void grv_EmployeeOTSanction_RowEditing(object sender, GridViewEditEventArgs e)
    {

        grv_EmployeeOTSanction.EditIndex = e.NewEditIndex;
        grv_EmployeeOTSanction.DataSource = (DataSet)Session["OTEmployee"];
        grv_EmployeeOTSanction.DataBind();
        TextBox txtOT = (TextBox)grv_EmployeeOTSanction.Rows[e.NewEditIndex].FindControl("txtHoursOT");
        TextBox txtWOOT = (TextBox)grv_EmployeeOTSanction.Rows[e.NewEditIndex].FindControl("txtWeeklyoffOT");
        TextBox txtHDOT = (TextBox)grv_EmployeeOTSanction.Rows[e.NewEditIndex].FindControl("txtHolidayOT");

        Label lblOT = (Label)grv_EmployeeOTSanction.Rows[e.NewEditIndex].FindControl("lblHoursOT");
        Label lblWOOT = (Label)grv_EmployeeOTSanction.Rows[e.NewEditIndex].FindControl("lblWeeklyoffOT");
        Label lblHDOT = (Label)grv_EmployeeOTSanction.Rows[e.NewEditIndex].FindControl("lblHolidayOT");
        Label lblStatus = (Label)grv_EmployeeOTSanction.Rows[e.NewEditIndex].FindControl("lblOTStatus");

        if (lblStatus.Text != "Approved")
        {

            //txtOT.Attributes.Add("onmouseover", "javascript:return DynamicDatePicker('" + Session["ITimeFormat"] + "','" + txtOT.ClientID + "')");
            //txtWOOT.Attributes.Add("onmouseover", "javascript:return DynamicDatePicker('" + Session["ITimeFormat"] + "','" + txtWOOT.ClientID + "')");
            //txtHDOT.Attributes.Add("onmouseover", "javascript:return DynamicDatePicker('" + Session["ITimeFormat"] + "','" + txtHDOT.ClientID + "')");

            if (txtOT.Text == "00:00" && lblOT.Text == "00:00")
            {
                txtOT.Enabled = false;
                txtOT.Style.Add("background-color", "#D3DBE7");
            }
            else
            {
                txtOT.Enabled = true;
                txtOT.Style.Add("background-color", "#FFF");
            }

            if (txtWOOT.Text == "00:00" && lblWOOT.Text == "00:00")
            {
                txtWOOT.Enabled = false;
                txtWOOT.Style.Add("background-color", "#D3DBE7");
            }
            else
            {
                txtWOOT.Enabled = true;
                txtWOOT.Style.Add("background-color", "#FFF");
            }

            if (txtHDOT.Text == "00:00" && lblHDOT.Text == "00:00")
            {
                txtHDOT.Enabled = false;
                txtHDOT.Style.Add("background-color", "#D3DBE7");
            }
            else
            {
                txtHDOT.Enabled = true;
                txtHDOT.Style.Add("background-color", "#FFF");
            }
        }
        else
        {
            string str = "<script language=\"javascript\">";
            //str = str + "alert('Select Any Record');";
            str = str + "alert('" + rm.GetString("OT_Approved", ci) + "');";
            str = str + "</script>";
            Page.RegisterStartupScript("alert", str);
            grv_EmployeeOTSanction.EditIndex = -1;
            grv_EmployeeOTSanction.DataSource = (DataSet)Session["OTEmployee"];
            grv_EmployeeOTSanction.DataBind();
            return;
        }
        ViewState["EditMode"] = "True";
    }
    protected void grv_EmployeeOTSanction_RowUpdating(object sender, GridViewUpdateEventArgs e)
    {
        int Pro_RecordID = Convert.ToInt32(((Label)grv_EmployeeOTSanction.Rows[e.RowIndex].FindControl("lblProc_RecordId")).Text);
        string UpOTHours = Convert.ToString(((TextBox)grv_EmployeeOTSanction.Rows[e.RowIndex].FindControl("txtHoursOT")).Text);
        string UpWOFOTHours = Convert.ToString(((TextBox)grv_EmployeeOTSanction.Rows[e.RowIndex].FindControl("txtWeeklyoffOT")).Text);
        string UpHDOTHours = Convert.ToString(((TextBox)grv_EmployeeOTSanction.Rows[e.RowIndex].FindControl("txtHolidayOT")).Text);
        string OTHours = Convert.ToString(((Label)grv_EmployeeOTSanction.Rows[e.RowIndex].FindControl("lblHoursOT")).Text);
        string WOFOTHours = Convert.ToString(((Label)grv_EmployeeOTSanction.Rows[e.RowIndex].FindControl("lblWeeklyoffOT")).Text);
        string HDOTHours = Convert.ToString(((Label)grv_EmployeeOTSanction.Rows[e.RowIndex].FindControl("lblHolidayOT")).Text);
        string[] str1;

        if (UpOTHours == "")
        {
            string str = "<script language=\"javascript\">";
            //str = str + "alert('Select Any Record');";
            str = str + "alert('" + rm.GetString("Alert_OTHoursMissed", ci) + "');";
            str = str + "</script>";
            Page.RegisterStartupScript("alert", str);
            ((TextBox)grv_EmployeeOTSanction.Rows[e.RowIndex].FindControl("txtHoursOT")).Focus();
            return;
        }

        if (UpWOFOTHours == "")
        {
            string str = "<script language=\"javascript\">";
            //str = str + "alert('Select Any Record');";
            str = str + "alert('" + rm.GetString("Alert_WOOTHoursMissed", ci) + "');";
            str = str + "</script>";
            Page.RegisterStartupScript("alert", str);
            ((TextBox)grv_EmployeeOTSanction.Rows[e.RowIndex].FindControl("txtWeeklyoffOT")).Focus();
            return;
        }

        if (UpHDOTHours == "")
        {
            string str = "<script language=\"javascript\">";
            //str = str + "alert('Select Any Record');";
            str = str + "alert('" + rm.GetString("Alert_HDOTHoursMissed", ci) + "');";
            str = str + "</script>";
            Page.RegisterStartupScript("alert", str);
            ((TextBox)grv_EmployeeOTSanction.Rows[e.RowIndex].FindControl("txtHolidayOT")).Focus();
            return;
        }

        // Get Modify OT Hours in integer format
        str1 = UpOTHours.Split(':');
        if (str1.Length == 2)
        {
            if (str1[0].Length == 2)
            {
                intUpOTHrs = Convert.ToInt32(str1[0]) * 60;
            }
            else
            {
                string str = "<script language=\"javascript\">";
                //str = str + "alert('Select Any Record');";
                str = str + "alert('" + rm.GetString("Alert_OTHoursIncorrect", ci) + "');";
                str = str + "</script>";
                Page.RegisterStartupScript("alert", str);
                ((TextBox)grv_EmployeeOTSanction.Rows[e.RowIndex].FindControl("txtHoursOT")).Focus();
                return;
            }
            if (str1[1].Length == 2)
            {
                intUpOTHrs = intUpOTHrs + Convert.ToInt32(str1[1]);
            }
            else
            {
                string str = "<script language=\"javascript\">";
                //str = str + "alert('Select Any Record');";
                str = str + "alert('" + rm.GetString("Alert_OTHoursIncorrect", ci) + "');";
                str = str + "</script>";
                Page.RegisterStartupScript("alert", str);
                ((TextBox)grv_EmployeeOTSanction.Rows[e.RowIndex].FindControl("txtHoursOT")).Focus();
                return;
            }
        }
        else
        {
            string str = "<script language=\"javascript\">";
            //str = str + "alert('Select Any Record');";
            str = str + "alert('" + rm.GetString("Alert_OTHoursIncorrect", ci) + "');";
            str = str + "</script>";
            Page.RegisterStartupScript("alert", str);
            ((TextBox)grv_EmployeeOTSanction.Rows[e.RowIndex].FindControl("txtHoursOT")).Focus();
            return;
        }

        // Get OT Hours in integer format
        str1 = OTHours.Split(':');
        if (str1.Length == 2)
        {
            intOTHrs = Convert.ToInt32(str1[0]) * 60;
            intOTHrs = intOTHrs + Convert.ToInt32(str1[1]);
        }

        // Get Modify Week Off OT Hours in integer format
        str1 = UpWOFOTHours.Split(':');
        if (str1.Length == 2)
        {
            if (str1[0].Length == 2)
            {
                intUpWOFOTHrs = Convert.ToInt32(str1[0]) * 60;
            }
            else
            {
                string str = "<script language=\"javascript\">";
                //str = str + "alert('Select Any Record');";
                str = str + "alert('" + rm.GetString("Alert_WOOTHoursIncorrect", ci) + "');";
                str = str + "</script>";
                Page.RegisterStartupScript("alert", str);
                ((TextBox)grv_EmployeeOTSanction.Rows[e.RowIndex].FindControl("txtWeeklyoffOT")).Focus();
                return;
            }
            if (str1[1].Length == 2)
            {
                intUpWOFOTHrs = intUpWOFOTHrs + Convert.ToInt32(str1[1]);
            }
            else
            {
                string str = "<script language=\"javascript\">";
                //str = str + "alert('Select Any Record');";
                str = str + "alert('" + rm.GetString("Alert_WOOTHoursIncorrect", ci) + "');";
                str = str + "</script>";
                Page.RegisterStartupScript("alert", str);
                ((TextBox)grv_EmployeeOTSanction.Rows[e.RowIndex].FindControl("txtWeeklyoffOT")).Focus();
                return;
            }
        }
        else
        {
            string str = "<script language=\"javascript\">";
            //str = str + "alert('Select Any Record');";
            str = str + "alert('" + rm.GetString("Alert_WOOTHoursIncorrect", ci) + "');";
            str = str + "</script>";
            Page.RegisterStartupScript("alert", str);
            ((TextBox)grv_EmployeeOTSanction.Rows[e.RowIndex].FindControl("txtWeeklyoffOT")).Focus();
            return;
        }

        // Get Week Off OT Hours in integer format
        str1 = WOFOTHours.Split(':');
        if (str1.Length == 2)
        {
            intWOFOTHrs = Convert.ToInt32(str1[0]) * 60;
            intWOFOTHrs = intWOFOTHrs + Convert.ToInt32(str1[1]);
        }

        // Get Modify Holiday OT Hours in integer format
        str1 = UpHDOTHours.Split(':');
        if (str1.Length == 2)
        {
            if (str1[0].Length == 2)
            {
                intUpHDOTFrs = Convert.ToInt32(str1[0]) * 60;
            }
            else
            {
                string str = "<script language=\"javascript\">";
                //str = str + "alert('Select Any Record');";
                str = str + "alert('" + rm.GetString("Alert_HDOTHoursIncorrect", ci) + "');";
                str = str + "</script>";
                Page.RegisterStartupScript("alert", str);
                ((TextBox)grv_EmployeeOTSanction.Rows[e.RowIndex].FindControl("txtHolidayOT")).Focus();
                return;
            }
            if (str1[1].Length == 2)
            {
                intUpHDOTFrs = intUpHDOTFrs + Convert.ToInt32(str1[1]);
            }
            else
            {
                string str = "<script language=\"javascript\">";
                //str = str + "alert('Select Any Record');";
                str = str + "alert('" + rm.GetString("Alert_HDOTHoursIncorrect", ci) + "');";
                str = str + "</script>";
                Page.RegisterStartupScript("alert", str);
                ((TextBox)grv_EmployeeOTSanction.Rows[e.RowIndex].FindControl("txtHolidayOT")).Focus();
                return;
            }
        }
        else
        {
            string str = "<script language=\"javascript\">";
            //str = str + "alert('Select Any Record');";
            str = str + "alert('" + rm.GetString("Alert_HDOTHoursIncorrect", ci) + "');";
            str = str + "</script>";
            Page.RegisterStartupScript("alert", str);
            ((TextBox)grv_EmployeeOTSanction.Rows[e.RowIndex].FindControl("txtHolidayOT")).Focus();
            return;
        }

        // Get Holiday OT Hours in integer format
        str1 = HDOTHours.Split(':');
        if (str1.Length == 2)
        {
            intHDOTFrs = Convert.ToInt32(str1[0]) * 60;
            intHDOTFrs = intHDOTFrs + Convert.ToInt32(str1[1]);
        }

        if (intOTHrs < intUpOTHrs)
        {
            string str = "<script language=\"javascript\">";
            //str = str + "alert('Select Any Record');";
            str = str + "alert('" + rm.GetString("Alert_OTHours", ci) + "');";
            str = str + "</script>";
            Page.RegisterStartupScript("alert", str);
            ((TextBox)grv_EmployeeOTSanction.Rows[e.RowIndex].FindControl("txtHoursOT")).Focus();
            return;
        }
        if (intWOFOTHrs < intUpWOFOTHrs)
        {
            string str = "<script language=\"javascript\">";
            //str = str + "alert('Select Any Record');";
            str = str + "alert('" + rm.GetString("Alert_WeekOffOTHours", ci) + "');";
            str = str + "</script>";
            Page.RegisterStartupScript("alert", str);
            ((TextBox)grv_EmployeeOTSanction.Rows[e.RowIndex].FindControl("txtWeeklyoffOT")).Focus();
            return;
        }
        if (intHDOTFrs < intUpHDOTFrs)
        {
            string str = "<script language=\"javascript\">";
            //str = str + "alert('Select Any Record');";
            str = str + "alert('" + rm.GetString("Alert_HolidayOTHours", ci) + "');";
            str = str + "</script>";
            Page.RegisterStartupScript("alert", str);
            ((TextBox)grv_EmployeeOTSanction.Rows[e.RowIndex].FindControl("txtHolidayOT")).Focus();
            return;
        }
        string strQuery;
        strQuery = "";
        strQuery = "Update TA_Tbl_ProcessedData set ActNormOTMins=" + intOTHrs + ",ActOffOTMins=" + intWOFOTHrs + ",ActHolOTMins=" + intHDOTFrs + ",ActOTMins=" + (intOTHrs + intWOFOTHrs + intHDOTFrs) + ",ActHrsOT='00:00',ActNormOT='" + OTHours + "',ActOffOT='" + WOFOTHours + "',ActHolOT='" + HDOTHours + "',NormOTMins=" + intUpOTHrs + ",OffOTMins=" + intUpWOFOTHrs + ",HolOTMins=" + intUpHDOTFrs + ",OTMins=" + (intUpOTHrs + intUpWOFOTHrs + intUpHDOTFrs) + ",NormOT='" + UpOTHours + "',OffOT='" + UpWOFOTHours + "',HolOT='" + UpHDOTHours + "' where Process_Rec_ID=" + Pro_RecordID;
        if (strQuery != "")
        {
            obj.UpdateShiftAllocation(strQuery);
        }
        OTEmployeeDetails();
        grv_EmployeeOTSanction.EditIndex = -1;
        grv_EmployeeOTSanction.DataSource = (DataSet)Session["OTEmployee"];
        grv_EmployeeOTSanction.DataBind();
        ViewState["EditMode"] = "Fales";
    }
    private void loadcss()
    {
        CultureInfo ci;
        string source_Language;
        source_Language = Convert.ToString(Session["Session_ActiveLanguage"]);
        rm = new ResourceManager(source_Language, System.Reflection.Assembly.Load("App_GlobalResources"));
        ci = Thread.CurrentThread.CurrentCulture;
        //if Standard Demo
        htmlOTpop.Attributes.Add("dir", rm.GetString("Direction", ci));
        if (source_Language == "Resources.Resource_AR")
        {
            stylebootstrap.Href = "../bootstrap/css/bootstrap-rtl.min.css";
            stylefontawesome.Href = "../bootstrap/font-awesome/css/font-awesome-rtl.css";
            styleAdminLTE.Href = "../dist/css/AdminLTE.min-rtl.css";
            stylecustom.Href = "../dist/css/custom-rtl.css";
            styledatepicker3.Href = "../plugins/datepicker/datepicker3-rtl.css";
            styledaterangepicker.Href = "../plugins/daterangepicker/daterangepicker-bs3-rtl.css";
        }
        else
        {
            //htmlOTpop.Attributes.Add("dir", "rtl");
            //stylebootstrap.Href = "../bootstrap/css/bootstrap-rtl.min.css";
            //stylefontawesome.Href = "../bootstrap/font-awesome/css/font-awesome-rtl.css";
            //styleAdminLTE.Href = "../dist/css/AdminLTE.min-rtl.css";
            //stylecustom.Href = "../dist/css/custom-rtl.css";
            //styledatepicker3.Href = "../plugins/datepicker/datepicker3-rtl.css";
            //styledaterangepicker.Href = "../plugins/daterangepicker/daterangepicker-bs3-rtl.css";
            stylebootstrap.Href = "../bootstrap/css/bootstrap.min.css";
            stylefontawesome.Href = "../bootstrap/font-awesome/css/font-awesome.css";
            styleAdminLTE.Href = "../dist/css/AdminLTE.min.css";
            stylecustom.Href = "../dist/css/custom.css";
            styledatepicker3.Href = "../plugins/datepicker/datepicker3.css";
            styledaterangepicker.Href = "../plugins/daterangepicker/daterangepicker-bs3.css";
        }
    }
    //protected void GridView1_HtmlRowCreated(object sender, ASPxGridViewTableRowEventArgs e)
    //{
    //    if (e.RowType == GridViewRowType.Data)
    //    {
    //        TextBox txt_Time = (TextBox)GridView1.FindRowCellTemplateControl(e.VisibleIndex, null, "txt_BonusHrs");
    //        txt_Time.Attributes.Add("onfocus", "javascript:return DynamicTimePicker('" + txt_Time.ClientID + "')");
    //    }
    //}
}
