using System;
using System.Collections;
using System.Data;
using Microsoft.Practices.EnterpriseLibrary.Data;
using DataAccessLayer;
public class Dashboard
{
    DataAccess objDataAccess = new DataAccess();
    Hashtable htable = new Hashtable();
    public DataSet GetTheDashboardInformation(string strEmployeeId, string strFromDate, string strToDate, int Session, int ShiftId, int ParentID, string UserGroupName, string GradeLevel, string EmpID)
    {
        DataSet ds = new DataSet();
        try
        {
            htable.Clear();
            htable.Add("@EmployeeCodeId", strEmployeeId);
            htable.Add("@FromDate", strFromDate);
            htable.Add("@ToDate", strToDate);
            htable.Add("@Session", Session);
            htable.Add("@ShiftId", ShiftId);
            htable.Add("@ParentID", ParentID);
            htable.Add("@UserGroupName", UserGroupName);
            htable.Add("@GradeLevel", GradeLevel);
            htable.Add("@empID", EmpID);
            ds = objDataAccess.GetStoredProcCommand("Proc_TA_GetTheDashboardInformation_Working", htable);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds;
    }
    public DataSet GetMyCalendarData(string UserGroupName, string EmpID)
    {
        DataSet ds = new DataSet();
        try
        {
            htable.Clear();
            htable.Add("@USERGROUPNAME", UserGroupName);
            htable.Add("@EmpAutoId", EmpID);       
            ds = objDataAccess.GetStoredProcCommand("Proc_TA_RptMyCalendar", htable);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds;
    }
    public DataSet GetMyCalendarDataTeam(string UserGroupName, string EmpID)
    {
        DataSet ds = new DataSet();
        try
        {
            htable.Clear();
            htable.Add("@UserGroupName", UserGroupName);
            htable.Add("@EmployeeID", EmpID);
            ds = objDataAccess.GetStoredProcCommand("Proc_TA_GetMyCalendarTeamData", htable);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds;
    }

    public DataSet GetIsSanctionUser(string EmpID)
    {
        DataSet ds = new DataSet();
        try
        {
            htable.Clear();
            htable.Add("@EmployeeID", EmpID);
            ds = objDataAccess.GetStoredProcCommand("Proc_TA_GetSanctionUser", htable);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds;
    }

    public DataSet GetMyCalendarDataforIndividual(string ShiftDate, string EmpID)
    {
        DataSet ds = new DataSet();
        try
        {
            htable.Clear();
            htable.Add("@ShiftDate", ShiftDate);
            htable.Add("@EmployeeID", EmpID);
            ds = objDataAccess.GetStoredProcCommand("Proc_TA_GetMyCalendarData", htable);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds;
    }
}
