using System;
using System.Data;
using System.Data.Common;
using System.Data.SqlClient;
using Microsoft.Practices.EnterpriseLibrary.Data;
/// <summary>
/// Summary description for ShiftPatternEventData
/// </summary>
[Serializable()]
public class ShiftPatternEventData
{
    Database db_Con = DatabaseFactory.CreateDatabase("DBConnection");
    int Count;
    SqlConnection con = new SqlConnection();
    public DataSet SelectShift(string usergroupname, string UserLevels, int ParentId)
    {
        DataSet ds_Shift = new DataSet();
        try
        {
            ds_Shift = db_Con.ExecuteDataSet("Proc_TA_SelectShift", new object[] { usergroupname, UserLevels, ParentId });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_Shift;
    }
    public void InserShiftPattern(int companyId, string patternName, int Nodays, int Day1_ShiftId, int Day2_ShiftId, int Day3_ShiftId, int Day4_ShiftId, int Day5_ShiftId, int Day6_ShiftId,
    int Day7_ShiftId, int Day8_ShiftId, int Day9_ShiftId, int Day10_ShiftId, int Day11_ShiftId, int Day12_ShiftId, int Day13_ShiftId, int Day14_ShiftId,
    int Day15_ShiftId, int Day16_ShiftId, int Day17_ShiftId, int Day18_ShiftId, int Day19_ShiftId, int Day20_ShiftId, int Day21_ShiftId, int Day22_ShiftId,
    int Day23_ShiftId, int Day24_ShiftId, int Day25_ShiftId, int Day26_ShiftId, int Day27_ShiftId, int Day28_ShiftId, int Day29_ShiftId, int Day30_ShiftId,
    int Day31_ShiftId, int EmpId)
    {
        try
        {
            DbCommand cmd_Insert = db_Con.GetStoredProcCommand("Proc_TA_InsertShiftPattern", new object[] { companyId, patternName, Nodays, Day1_ShiftId, Day2_ShiftId, Day3_ShiftId, Day4_ShiftId, Day5_ShiftId,
Day6_ShiftId,Day7_ShiftId,Day8_ShiftId,Day9_ShiftId,Day10_ShiftId,Day11_ShiftId,Day12_ShiftId,Day13_ShiftId,Day14_ShiftId,Day15_ShiftId,
Day16_ShiftId,Day17_ShiftId,Day18_ShiftId,Day19_ShiftId,Day20_ShiftId,Day21_ShiftId,Day22_ShiftId,Day23_ShiftId,Day24_ShiftId,
Day25_ShiftId,Day26_ShiftId,Day27_ShiftId,Day28_ShiftId,Day29_ShiftId,Day30_ShiftId,Day31_ShiftId,EmpId});
            cmd_Insert.CommandTimeout = 0;
            db_Con.ExecuteNonQuery(cmd_Insert);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
    public void UpdateShiftPattern(string patternName, int Nodays, int Day1_ShiftId, int Day2_ShiftId, int Day3_ShiftId, int Day4_ShiftId, int Day5_ShiftId, int Day6_ShiftId,
    int Day7_ShiftId, int Day8_ShiftId, int Day9_ShiftId, int Day10_ShiftId, int Day11_ShiftId, int Day12_ShiftId, int Day13_ShiftId, int Day14_ShiftId,
    int Day15_ShiftId, int Day16_ShiftId, int Day17_ShiftId, int Day18_ShiftId, int Day19_ShiftId, int Day20_ShiftId, int Day21_ShiftId, int Day22_ShiftId,
    int Day23_ShiftId, int Day24_ShiftId, int Day25_ShiftId, int Day26_ShiftId, int Day27_ShiftId, int Day28_ShiftId, int Day29_ShiftId, int Day30_ShiftId,
    int Day31_ShiftId, int ShiftPatternId)
    {
        try
        {
            DbCommand cmd_Update = db_Con.GetStoredProcCommand("Proc_TA_UpdareShiftPattern", new object[] { patternName, Nodays, Day1_ShiftId, Day2_ShiftId, Day3_ShiftId, Day4_ShiftId, Day5_ShiftId,
Day6_ShiftId, Day7_ShiftId, Day8_ShiftId, Day9_ShiftId, Day10_ShiftId, Day11_ShiftId, Day12_ShiftId, Day13_ShiftId, Day14_ShiftId, Day15_ShiftId,
Day16_ShiftId, Day17_ShiftId, Day18_ShiftId, Day19_ShiftId, Day20_ShiftId, Day21_ShiftId, Day22_ShiftId, Day23_ShiftId, Day24_ShiftId,
Day25_ShiftId, Day26_ShiftId, Day27_ShiftId, Day28_ShiftId, Day29_ShiftId, Day30_ShiftId, Day31_ShiftId, ShiftPatternId});
            cmd_Update.CommandTimeout = 0;
            db_Con.ExecuteNonQuery(cmd_Update);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
    /// <summary>
    /// Deletes a praticular pattern using its id : Abul
    /// </summary>
    /// <param name="PatternId"></param>
    public void DeleteShiftPattern(int PatternId)
    {
        try
        {
            DbCommand cmd_delete = db_Con.GetStoredProcCommand("Proc_TA_DeleteShiftPattern", new object[] { PatternId, 'I', '0' });
            cmd_delete.CommandTimeout = 0;
            db_Con.ExecuteNonQuery(cmd_delete);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
    // delete multiple shiftpatterns based on their ids
    public void DeleteMultipleShiftPattern(string ShiftPattern_Ids)
    {
        try
        {
            DbCommand cmd_delete = db_Con.GetStoredProcCommand("Proc_TA_DeleteShiftPattern", new object[] { 0, 'M', ShiftPattern_Ids });
            cmd_delete.CommandTimeout = 0;
            db_Con.ExecuteNonQuery(cmd_delete);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
    // Permanently delete shiftpatterns based on their ids
    public void PermanentDeleteShiftPattern(int @ShiftPattern_Id)
    {
        try
        {
            DbCommand cmd_delete = db_Con.GetStoredProcCommand("Proc_TA_DeleteShiftPattern", new object[] { @ShiftPattern_Id, 'P', 0 });
            cmd_delete.CommandTimeout = 0;
            db_Con.ExecuteNonQuery(cmd_delete);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
    public int CheckShiftPattern(int companyId, string ShiftPattern)
    {
        DataSet ds_CheckShiftPattern = new DataSet();
        try
        {
            ds_CheckShiftPattern = db_Con.ExecuteDataSet("Proc_TA_CheckShiftPattern", new object[] { companyId, ShiftPattern });
            if (ds_CheckShiftPattern.Tables[0].Rows.Count > 0)
            {
                Count = Convert.ToInt32(ds_CheckShiftPattern.Tables[0].Rows[0]["SCOUNT"]);
            }
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return Count;
    }
    public DataSet SelectShiftPattern(string usergroupname, string UserLevels, int parentLevelId)
    {
        DataSet ds_Select = new DataSet();
        try
        {
            ds_Select = db_Con.ExecuteDataSet("SelectShiftPattern", new object[] { usergroupname, UserLevels, parentLevelId });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_Select;
    }
    public DataSet SelectPatternById()
    {
        DataSet ds_PatternById = new DataSet();
        try
        {
            ds_PatternById = db_Con.ExecuteDataSet("SelectShiftPatternDeleteById");
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_PatternById;
    }
    public DataSet SelectPatternDetails(int ShiftPatternId)
    {
        DataSet ds_ShiftPatternDetails = new DataSet();
        try
        {
            ds_ShiftPatternDetails = db_Con.ExecuteDataSet("SelectShiftPatternById", new object[] { ShiftPatternId });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_ShiftPatternDetails;
    }
    public DataSet ShiftName(int ShiftId)
    {
        DataSet ds_ShiftName = new DataSet();
        try
        {
            ds_ShiftName = db_Con.ExecuteDataSet("Proc_TA_SelectShiftNameById", new object[] { ShiftId });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_ShiftName;
    }
    public ShiftPatternEventData()
    {
        string strDecryptedString = string.Empty;
        strDecryptedString = Cryptographys.Cryptography.GetDecryptedConnectionString();
        if (strDecryptedString != string.Empty)
        {
            ResetDatabaseConnection(strDecryptedString);
        }
    }
    public void ResetDatabaseConnection(string strDecryptedString)
    {
        DbProviderFactory objData = db_Con.DbProviderFactory;
        db_Con = new Microsoft.Practices.EnterpriseLibrary.Data.Sql.SqlDatabase(strDecryptedString);
    }
    public SqlConnection opebDB()
    {
        try
        {
            con.ConnectionString = Cryptographys.Cryptography.GetDecryptedConnectionString(); ;
            con.Open();
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return con;
    }
    public SqlConnection closeDB()
    {
        con.Close();
        return con;
    }
    public int CheckShiftPattern_Delete(int ShiftId)
    {
        DataSet ds_Shift = new DataSet();
        int count;
        try
        {
            ds_Shift = db_Con.ExecuteDataSet("Proc_TA_CheckShiftPatternDelete", new object[] { ShiftId });
            count = Convert.ToInt32(ds_Shift.Tables[0].Rows[0]["ShiftCount"]);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return count;
    }
    public int CheckShiftPattern_Restore(int PatternId)
    {
        DataSet ds_Shift = new DataSet();
        int count;
        try
        {
            ds_Shift = db_Con.ExecuteDataSet("Proc_TA_CheckShiftPatternRestore", new object[] { PatternId });
            count = Convert.ToInt32(ds_Shift.Tables[0].Rows[0]["ShiftPatternCount"]);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return count;
    }
    // Restore shiftpatterns based on their ids
    public void RestoreShiftPattern(string ShiftPattern_Ids)
    {
        try
        {
            DbCommand cmd_delete = db_Con.GetStoredProcCommand("Proc_TA_RestoreShiftPattern", new object[] { ShiftPattern_Ids });
            cmd_delete.CommandTimeout = 0;
            db_Con.ExecuteNonQuery(cmd_delete);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
    public DataSet CheckShiftOverLapping(int Shift1ID, int Shift2ID)
    {
        DataSet ds = new DataSet();
        try
        {
            ds = db_Con.ExecuteDataSet("Proc_TA_CheckShiftPatternOverlapping", new object[] { Shift1ID, Shift2ID });
        }
        catch (Exception ex)
        {
            throw ex;
        }
        return ds;
    }
    public DataSet SelectShiftForShiftPattern(int companyId)
    {
        DataSet ds_Shift = new DataSet();
        try
        {
            ds_Shift = db_Con.ExecuteDataSet("Proc_TA_SelectShiftForShiftPattern", new object[] { companyId });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_Shift;
    }
}
