using System;
using System.Data;
using System.Data.Common;
using System.Data.SqlClient;
using System.IO;
using System.Security.Cryptography;
using System.Text;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Microsoft.Practices.EnterpriseLibrary.Data;
using DataAccessLayer;
using System.Net.Mail;
using System.Configuration;
using System.Resources;
using System.Globalization;
using System.Threading;
using System.Collections;
/// <summary>
/// Summary description for cls_Common
/// </summary>
public class cls_Common
{
    DataAccess objDataAccess = new DataAccess();
    Database db = DatabaseFactory.CreateDatabase("DBConnection");
    DataSet ds_changePassword;
    string strFileName = "";
    byte[] image;
    public byte[] ConvertByte(FileUpload fp)
    {
        strFileName = fp.PostedFile.FileName;
        FileStream fs = new FileStream(strFileName, FileMode.Open);
        BinaryReader br_reader = new BinaryReader(fs);
        image = br_reader.ReadBytes((int)fs.Length);
        fs.Close();
        br_reader.Close();
        return image;
    }
    public void menu(string url, string requestPageTitle)
    {
        if (Convert.ToString(HttpContext.Current.Session["TopMenuPrevious"]) != string.Empty)
        {
            string menulist = Convert.ToString(HttpContext.Current.Session["TopMenuPrevious"]);
            menulist = menulist.Replace("class='active'", " ");
            if (Convert.ToString(requestPageTitle) != "")
            {
                switch (requestPageTitle)
                {
                    case "27":
                        menulist = menulist.Replace("id='27'", "id='27' class='active'");
                        break;
                    case "71":
                        menulist = menulist.Replace("id='71'", "id='71' class='active'");
                        break;
                    case "62":
                        menulist = menulist.Replace("id='62'", "id='62' class='active'");
                        break;
                    case "70":
                        menulist = menulist.Replace("id='70'", "id='70' class='active'");
                        break;
                    default:
                        menulist = menulist.Replace("id='" + requestPageTitle + "'", "id='" + requestPageTitle + "' class='active'");
                        break;
                }
            }
            if (url != "Dashboard" || url == "Masters_EmailConfiguration" || url == "Menu_help")
            {
                menulist = menulist.Replace("Masters/", "../Masters/");
                menulist = menulist.Replace("Transactions/", "../Transactions/");
                menulist = menulist.Replace("Reports/", "../Reports/");
                menulist = menulist.Replace("Organization Settings/", "../Organization Settings/");
                menulist = menulist.Replace("System Settings/", "../System Settings/");
                menulist = menulist.Replace("DashBoard.aspx", "../DashBoard.aspx");
                menulist = menulist.Replace("MyCalendar.aspx", "../MyCalendar.aspx");
                menulist = menulist.Replace("Help/", "../Help/");
                menulist = menulist.Replace("<img class='icon' src='dist/img/cogs.png'>", "<img class='icon' src='../dist/img/cogs.png'>");
                menulist = menulist.Replace("<img class='icon' src='dist/img/org-set.png'>", "<img class='icon' src='../dist/img/org-set.png'>");
                menulist = menulist.Replace("<img class='icon' src='dist/img/dev-man.png'>", "<img class='icon' src='../dist/img/dev-man.png'>");
                menulist = menulist.Replace("<img class='icon' src='dist/img/emp-man.png'>", "<img class='icon' src='../dist/img/emp-man.png'>");
                menulist = menulist.Replace("<img class='icon' src='dist/img/sit-man.png'>", "<img class='icon' src='../dist/img/sit-man.png'>");
                menulist = menulist.Replace("<img class='icon' src='dist/img/lep-man.png'>", "<img class='icon' src='../dist/img/lep-man.png'>");
                menulist = menulist.Replace("<img class='icon' src='dist/img/mte.png'>", "<img class='icon' src='../dist/img/mte.png'>");
                menulist = menulist.Replace("<img class='icon' src='dist/img/pri-man.png'>", "<img class='icon' src='../dist/img/pri-man.png'>");
                menulist = menulist.Replace("<img class='icon' src='dist/img/hol-man.png'>", "<img class='icon' src='../dist/img/hol-man.png'>");
                menulist = menulist.Replace("<img class='icon' src='dist/img/rep.png'>", "<img class='icon' src='../dist/img/rep.png'>");
                menulist = menulist.Replace("<img class='icon' src='dist/img/ouf.png'>", "<img class='icon' src='../dist/img/ouf.png'>");
                menulist = menulist.Replace("<img class='icon' src='dist/img/overtime.png'>", "<img class='icon' src='../dist/img/overtime.png'>");
                menulist = menulist.Replace("<img class='icon' src='dist/img/OnDuty.png'>", "<img class='icon' src='../dist/img/OnDuty.png'>");
                menulist = menulist.Replace("<img class='icon' src='dist/img/export.png'>", "<img class='icon' src='../dist/img/export.png'>");
                menulist = menulist.Replace("<img class='icon' src='dist/img/EMail.png'>", "<img class='icon' src='../dist/img/EMail.png'>");
                menulist = menulist.Replace("<img class='icon' src='dist/img/Dashboard.png'>", "<img class='icon' src='../dist/img/Dashboard.png'>");
                menulist = menulist.Replace("<img class='icon' src='dist/img/MyCalendar.png'>", "<img class='icon' src='../dist/img/MyCalendar.png'>");
                menulist = menulist.Replace("<img class='icon' src='dist/img/help.png'>", "<img class='icon' src='../dist/img/help.png'>");
            }
            else
            {
                menulist = menulist.Replace("../Masters/", "Masters/");
                menulist = menulist.Replace("../Transactions/", "Transactions/");
                menulist = menulist.Replace("../Reports/", "Reports/");
                menulist = menulist.Replace("../Organization Settings/", "Organization Settings/");
                menulist = menulist.Replace("../System Settings/", "System Settings/");
                menulist = menulist.Replace("../DashBoard.aspx", "DashBoard.aspx");
                menulist = menulist.Replace("../MyCalendar.aspx", "MyCalendar.aspx");
                menulist = menulist.Replace("../Help/", "Help/");
                menulist = menulist.Replace("<img class='icon' src='../dist/img/cogs.png'>", "<img class='icon' src='dist/img/cogs.png'>");
                menulist = menulist.Replace("<img class='icon' src='../dist/img/org-set.png'>", "<img class='icon' src='dist/img/org-set.png'>");
                menulist = menulist.Replace("<img class='icon' src='../dist/img/dev-man.png'>", "<img class='icon' src='dist/img/dev-man.png'>");
                menulist = menulist.Replace("<img class='icon' src='../dist/img/emp-man.png'>", "<img class='icon' src='dist/img/emp-man.png'>");
                menulist = menulist.Replace("<img class='icon' src='../dist/img/sit-man.png'>", "<img class='icon' src='dist/img/sit-man.png'>");
                menulist = menulist.Replace("<img class='icon' src='../dist/img/lep-man.png'>", "<img class='icon' src='dist/img/lep-man.png'>");
                menulist = menulist.Replace("<img class='icon' src='../dist/img/mte.png'>", "<img class='icon' src='dist/img/mte.png'>");
                menulist = menulist.Replace("<img class='icon' src='../dist/img/pri-man.png'>", "<img class='icon' src='dist/img/pri-man.png'>");
                menulist = menulist.Replace("<img class='icon' src='../dist/img/hol-man.png'>", "<img class='icon' src='dist/img/hol-man.png'>");
                menulist = menulist.Replace("<img class='icon' src='../dist/img/rep.png'>", "<img class='icon' src='dist/img/rep.png'>");
                menulist = menulist.Replace("<img class='icon' src='../dist/img/ouf.png'>", "<img class='icon' src='dist/img/ouf.png'>");
                menulist = menulist.Replace("<img class='icon' src='../dist/img/overtime.png'>", "<img class='icon' src='dist/img/overtime.png'>");
                menulist = menulist.Replace("<img class='icon' src='../dist/img/OnDuty.png'>", "<img class='icon' src='dist/img/OnDuty.png'>");
                menulist = menulist.Replace("<img class='icon' src='../dist/img/export.png'>", "<img class='icon' src='dist/img/export.png'>");
                menulist = menulist.Replace("<img class='icon' src='../dist/img/EMail.png'>", "<img class='icon' src='dist/img/EMail.png'>");
                menulist = menulist.Replace("<img class='icon' src='../dist/img/Dashboard.png'>", "<img class='icon' src='dist/img/Dashboard.png'>");
                menulist = menulist.Replace("<img class='icon' src='../dist/img/MyCalendar.png'>", "<img class='icon' src='dist/img/MyCalendar.png'>");
                menulist = menulist.Replace("<img class='icon' src='../dist/img/help.png'>", "<img class='icon' src='dist/img/help.png'>");
            }
            switch (url)
            {
                case "Configuration":
                    menulist = menulist.Replace("<li id='Menu_Configuration'>", "<li class='treeview active' id='Menu_Configuration'>");
                    break;
                case "OrgSettings":
                    menulist = menulist.Replace("<li id='Organization_Settings'>", "<li class='treeview active' id='Organization_Settings'>");
                    break;
                case "Device":
                    menulist = menulist.Replace("<li id='Device_Management'>", "<li class='treeview active' id='Device_Management'>");
                    break;
                case "EmployeeMaster":
                    menulist = menulist.Replace("<li id='Employee_Management'>", "<li class='treeview active' id='Employee_Management'>");
                    menulist = menulist.Replace("<li id='Menu_EMp_Master'>", "<li class='treeview active' id='Menu_EMp_Master'>");
                    break;
                case "EmployeeReports":
                    menulist = menulist.Replace("<li id='Employee_Management'>", "<li class='treeview active' id='Employee_Management'>");
                    menulist = menulist.Replace("<li id='Menu_EMp_Report'>", "<li class='treeview active' id='Menu_EMp_Report'>");
                    break;
                case "ShiftMaster":
                    menulist = menulist.Replace("<li id='Shift_Management'>", "<li class='treeview active' id='Shift_Management'>");
                    menulist = menulist.Replace("<li id='Menu_Shift_Master'>", "<li class='treeview active' id='Menu_Shift_Master'>");
                    break;
                case "ShiftTransaction":
                    menulist = menulist.Replace("<li id='Shift_Management'>", "<li class='treeview active' id='Shift_Management'>");
                    menulist = menulist.Replace("<li id='Menu_Shift_Transaction'>", "<li class='treeview active' id='Menu_Shift_Transaction'>");
                    break;
                case "ShiftReports":
                    menulist = menulist.Replace("<li id='Shift_Management'>", "<li class='treeview active' id='Shift_Management'>");
                    menulist = menulist.Replace("<li id='Menu_Shift_Reports'>", "<li class='treeview active' id='Menu_Shift_Reports'>");
                    break;
                case "OverTime":
                    menulist = menulist.Replace("<li id='Menu_OTCOMPOff'>", "<li class='treeview active' id='Menu_OTCOMPOff'>");
                    break;
                case "Terminal":
                    menulist = menulist.Replace("<li id='Device_Management'>", "<li class='treeview active' id='Device_Management'>");
                    menulist = menulist.Replace("<li id='Master_Terminal'>", "<li class='treeview active' id='Master_Terminal'>");
                    break;
                case "LeaveMasters":
                    menulist = menulist.Replace("<li id='Leave_Permission_Management'>", "<li class='treeview active' id='Leave_Permission_Management'>");
                    menulist = menulist.Replace("<li id='Menu_Leave_Master'>", "<li class='treeview active' id='Menu_Leave_Master'>");
                    break;
                case "LeaveReports":
                    menulist = menulist.Replace("<li id='Leave_Permission_Management'>", "<li class='treeview active' id='Leave_Permission_Management'>");
                    menulist = menulist.Replace("<li id='Menu_Leave_Reports'>", "<li class='treeview active' id='Menu_Leave_Reports'>");
                    break;
                case "LeaveTransaction":
                    menulist = menulist.Replace("<li id='Leave_Permission_Management'>", "<li class='treeview active' id='Leave_Permission_Management'>");
                    menulist = menulist.Replace("<li id='Menu_Leave_Transaction'>", "<li class='treeview active' id='Menu_Leave_Transaction'>");
                    break;
                case "LeaveSettings":
                    menulist = menulist.Replace("<li id='Leave_Permission_Management'>", "<li class='treeview active' id='Leave_Permission_Management'>");
                    menulist = menulist.Replace("<li id='Org_LeaveSettings'>", "<li class='treeview active' id='Org_LeaveSettings'>");
                    break;
                case "PermissionTransaction":
                    menulist = menulist.Replace("<li id='Leave_Permission_Management'>", "<li class='treeview active' id='Leave_Permission_Management'>");
                    menulist = menulist.Replace("<li id='Menu_Permission_Transaction'>", "<li class='treeview active' id='Menu_Permission_Transaction'>");
                    break;
                case "PermissionReports":
                    menulist = menulist.Replace("<li id='Leave_Permission_Management'>", "<li class='treeview active' id='Leave_Permission_Management'>");
                    menulist = menulist.Replace("<li id='Report_Permission'>", "<li class='treeview active' id='Report_Permission'>");
                    break;
                case "Approvals":
                    menulist = menulist.Replace("<li id='Leave_Permission_Management'>", "<li class='treeview active' id='Leave_Permission_Management'>");
                    menulist = menulist.Replace("<li id='Transaction_Approvals'>", "<li class='treeview active' id='Transaction_Approvals'>");
                    break;
                case "OnDuty":
                    menulist = menulist.Replace("<li id='Menu_OnDuty'>", "<li class='treeview active' id='Menu_OnDuty'>");
                    break;
                case "ManualTransaction":
                    menulist = menulist.Replace("<li id='ManualTimeEntry'>", "<li class='treeview active' id='ManualTimeEntry'>");
                    menulist = menulist.Replace("<li id='Menu_ME_Transaction'>", "<li class='treeview active' id='Menu_ME_Transaction'>");
                    break;
                case "ManualReports":
                    menulist = menulist.Replace("<li id='ManualTimeEntry'>", "<li class='treeview active' id='ManualTimeEntry'>");
                    menulist = menulist.Replace("<li id='Menu_ME_Reports'>", "<li class='treeview active' id='Menu_ME_Reports'>");
                    break;
                case "ExportTran":
                    menulist = menulist.Replace("<li id='Menu_ExportData'>", "<li class='treeview active' id='Menu_ExportData'>");
                    menulist = menulist.Replace("<li id='Menu_ED_Transaction'>", "<li class='treeview active' id='Menu_ED_Transaction'>");
                    break;
                case "ExportReport":
                    menulist = menulist.Replace("<li id='Menu_ExportData'>", "<li class='treeview active' id='Menu_ExportData   '>");
                    menulist = menulist.Replace("<li id='Menu_ED_Reports'>", "<li class='treeview active' id='Menu_ED_Reports'>");
                    break;
                case "Attendance Reports":
                    menulist = menulist.Replace("<li id='Menu_Reports'>", "<li class='treeview active' id='Menu_Reports'>");
                    menulist = menulist.Replace("<li id='Menu_Report_Attendace'>", "<li class='active' id='Menu_Report_Attendace'>");
                    break;
                case "Exception Reports":
                    menulist = menulist.Replace("<li id='Menu_Reports'>", "<li class='treeview active' id='Menu_Reports'>");
                    menulist = menulist.Replace("<li id='Menu_Reports_Entries'>", "<li class='active' id='Menu_Reports_Entries'>");
                    break;
                case "Shift":
                    menulist = menulist.Replace("<li id='Menu_Reports'>", "<li class='treeview active' id='Menu_Reports'>");
                    menulist = menulist.Replace("<li id='Menu_Reports_Shifts'>", "<li class='active' id='Menu_Reports_Shifts'>");
                    break;
                case "Others":
                    menulist = menulist.Replace("<li id='Other_useful_features'>", "<li class='treeview active' id='Other_useful_features'>");
                    break;
                case "LicenseManager":
                    menulist = menulist.Replace("<li id='System_LicenseManager'>", "<li class='treeview active' id='System_LicenseManager'>");
                    menulist = menulist.Replace("<li id='Other_useful_features'>", "<li class='treeview active' id='Other_useful_features'>");
                    break;
                case "Transportation":
                    menulist = menulist.Replace("<li id='Master_Transportation'>", "<li class='treeview active' id='Master_Transportation'>");
                    menulist = menulist.Replace("<li id='Other_useful_features'>", "<li class='treeview active' id='Other_useful_features'>");
                    break;
                case "Previlege":
                    menulist = menulist.Replace("<li id='Privilege_Management'>", "<li class='treeview active' id='Privilege_Management'>");
                    break;
                default:
                    break;
            }
            HttpContext.Current.Session["TopMenu"] = menulist;
        }
        switch (url)
        {
            case "Dashboard":
            case "MyCalendar":
                HttpContext.Current.Session["UserImageURL"] = "LoginImage/" + HttpContext.Current.Session["UserImage"];
                break;
            default:
                HttpContext.Current.Session["UserImageURL"] = "../LoginImage/" + HttpContext.Current.Session["UserImage"];
                break;
        }
    }
    public DataSet GetNotification(Int32 EmployeeID, string UserGroupName)
    {
        DataSet ds = new DataSet();
        try
        {
            ds = db.ExecuteDataSet("Proc_TA_GetnotificationDetails", new object[] { EmployeeID, UserGroupName });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds;
    }
    // Authenticate UserName
    public DataSet UserAuthenticate(string username, string password)
    {
        DataSet ds = new DataSet();
        try
        {
            ds = db.ExecuteDataSet("Proc_TA_UserLogin", new object[] { username, password });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds;
    }
    //Select Name of the Authenticated User
    public DataSet SelectUserName(string username, string password)
    {
        DataSet ds = new DataSet();
        try
        {
            ds = db.ExecuteDataSet("Proc_TA_SelectUserName", new object[] { username, password });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds;
    }
    public int CheckPassword(string UserName, string Password)
    {
        int Count = 0;
        try
        {
            Count = (int)db.ExecuteScalar("Proc_TA_CheckPassword", new object[] { UserName, Password });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return Count;
    }
    public void UpdatePassword(string UserName, string Password)
    {
        try
        {
            ds_changePassword = db.ExecuteDataSet("Proc_TA_UpdatePassword", new object[] { UserName, Password });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
    public void GetParentLevels_FromLevelID(int LevelID)
    {
        DbCommand cmd_ParentLevels = db.GetStoredProcCommand("Proc_editLevel", new object[] { LevelID });
        try
        {
            db.ExecuteNonQuery(cmd_ParentLevels);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
    public DataSet GetOrgLevel_FromLevelID(int LevelID)
    {
        DataSet ds_Level = new DataSet();
        try
        {
            ds_Level = db.ExecuteDataSet("Proc_TA_GetLevelName_FromLevelID", new object[] { LevelID });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_Level;
    }
    public DataSet GetParentLevels()
    {
        DataSet ds_ParentLevels = new DataSet();
        try
        {
            ds_ParentLevels = db.ExecuteDataSet("Proc_TA_ParentIDs", new object[] { });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_ParentLevels;
    }
    //select Year setting details
    public DataSet GetYearsetting()
    {
        DataSet ds_Yearsetting = new DataSet();
        try
        {
            ds_Yearsetting = db.ExecuteDataSet("Proc_TA_SelectYearSetting", new object[] { });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_Yearsetting;
    }
    public DataSet GetNextYearsetting()
    {
        DataSet dsNextYearsetting = new DataSet();
        try
        {
            dsNextYearsetting = db.ExecuteDataSet("Proc_TA_SelectNextYearSetting", new object[] { });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return dsNextYearsetting;
    }
    public DataSet GetSuccessiveYearsetting()
    {
        DataSet ds_Yearsetting = new DataSet();
        try
        {
            ds_Yearsetting = db.ExecuteDataSet("Proc_TA_SuccessiveYearSettings", new object[] { });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_Yearsetting;
    }
    public DataSet getNewsBanner(string position)
    {
        DataSet ds = new DataSet();
        try
        {
            ds = db.ExecuteDataSet("Proc_TA_getNews", new object[] { position });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds;
    }
    public DataSet getNewsByID(int NewsID)
    {
        DataSet ds = new DataSet();
        try
        {
            ds = db.ExecuteDataSet("Proc_TA_getNewsById", new object[] { NewsID });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds;
    }
    //Login for admin
    public int AdminUserAuthenticate(string username, string password)
    {
        DataSet ds = new DataSet();
        int count = 0;
        try
        {
            ds = db.ExecuteDataSet("Proc_TA_AdminLogin", new object[] { username, password });
            count = Convert.ToInt32(ds.Tables[0].Rows[0]["UID"]);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        ds.Dispose();
        return count;
    }
    public DataSet getUserMenu(int parentId, int groupId, string strType)
    {
        DataSet dsMnu = new DataSet();
        try
        {
            dsMnu = db.ExecuteDataSet("Proc_TA_GetUserMenu", new object[] { parentId, groupId, strType });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return dsMnu;
    }
    public DataSet getReportMenu(string ReportsMenu, int GroupId)
    {
        DataSet dsMnu = new DataSet();
        try
        {
            dsMnu = db.ExecuteDataSet("Proc_TA_ReportsSubMenu", new object[] { ReportsMenu, GroupId });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return dsMnu;
    }
    public DataSet getReportMenu(string ReportsMenu, int GroupId, string strType)
    {
        DataSet dsMnu = new DataSet();
        try
        {
            dsMnu = db.ExecuteDataSet("Proc_TA_ReportsSubMenuForExpress", new object[] { ReportsMenu, GroupId, strType });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return dsMnu;
    }
    public DataSet getmastersSubMenu(int ReportsMenu)
    {
        DataSet dsMnu = new DataSet();
        try
        {
            dsMnu = db.ExecuteDataSet("Proc_TA_getmastersSubMenu", new object[] { ReportsMenu });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return dsMnu;
    }
    public DataSet CheckUserStatus()
    {
        DataSet ds = new DataSet();
        try
        {
            ds = db.ExecuteDataSet("Proc_TA_CheckUserStatus", new object[] { });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds;
    }
    public void UpdateUserStatus(string UserId, string IpAddress, DateTime LoginTime, bool Status, string SessionId)
    {
        try
        {
            DbCommand cmd_UpdateUserStatus = db.GetStoredProcCommand("Proc_TA_UpdateUserStatus", new object[] { UserId, IpAddress, LoginTime, Status, SessionId });
            cmd_UpdateUserStatus.CommandTimeout = 0;
            db.ExecuteNonQuery(cmd_UpdateUserStatus);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
    public void UpdateExistingUserStatusFalse(string UserId)
    {
        try
        {
            DbCommand cmd_UpdateExistingUserStatusFalse = db.GetStoredProcCommand("Proc_TA_UpdateExistingUserStatusFalse", new object[] { UserId });
            cmd_UpdateExistingUserStatusFalse.CommandTimeout = 0;
            db.ExecuteNonQuery(cmd_UpdateExistingUserStatusFalse);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
    //update user status as false when logout
    public void UpdateExistingUserStatusFalse(string UserId, string Ipaddress, string SessionId)
    {
        try
        {
            DbCommand cmd_UpdateExistingUserStatusFalse = db.GetStoredProcCommand("Proc_TA_UpdateConcurrentUser", new object[] { UserId, Ipaddress, SessionId });
            cmd_UpdateExistingUserStatusFalse.CommandTimeout = 0;
            int i = db.ExecuteNonQuery(cmd_UpdateExistingUserStatusFalse);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
    /// <summary>
    /// Checks the concurrent user count.
    /// </summary>
    public int CheckConcurrentUserCount()
    {
        int concurrentUserCount = 0;
        try
        {
            DbCommand cmd_CheckConcurrentUserCount = db.GetStoredProcCommand("Proc_TA_CheckConcurrentUserCount");
            cmd_CheckConcurrentUserCount.CommandTimeout = 0;
            concurrentUserCount = Convert.ToInt32(db.ExecuteScalar(cmd_CheckConcurrentUserCount));
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return concurrentUserCount;
    }
    /// <summary>
    /// Logouts the user.
    /// </summary>
    public void LogoutUser(string UserId, string Ipaddress, string SessionId)
    {
        try
        {
            DbCommand cmd_LogoutUser = db.GetStoredProcCommand("Proc_TA_LogoutUserOwn", new object[] { UserId, Ipaddress, SessionId });
            cmd_LogoutUser.CommandTimeout = 0;
            db.ExecuteNonQuery(cmd_LogoutUser);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
    public void LogoutAdmin(string UserId)
    {
        try
        {
            DbCommand cmd_LogoutAdmin = db.GetStoredProcCommand("Proc_TA_LogoutAdmin", new object[] { UserId });
            cmd_LogoutAdmin.CommandTimeout = 0;
            db.ExecuteNonQuery(cmd_LogoutAdmin);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
    //Get Email Format From DB based on Script Type
    public DataTable GetEmailScripts(string ScriptType)
    {
        DataSet ds_EmailScripts = new DataSet();
        try
        {
            DbCommand cmd_CheckingLeaveApplication = db.GetStoredProcCommand("Proc_TA_GetEmailScripts", new object[] { ScriptType });
            cmd_CheckingLeaveApplication.CommandTimeout = 0;
            ds_EmailScripts = db.ExecuteDataSet(cmd_CheckingLeaveApplication);
            //ds_EmailScripts = DBCon.ExecuteDataSet("Proc_TA_GetEmailScripts", new object[] { ScriptType });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_EmailScripts.Tables[0];
    }
    /// <summary>
    /// Checking for special rights
    /// </summary>
    /// <param name="GroupID"></param>
    /// <returns></returns>
    public DataSet SelectGroupName(int GroupID)
    {
        DataSet ds = new DataSet();
        try
        {
            ds = db.ExecuteDataSet("Proc_TA_Select_UserGroupName", new object[] { GroupID });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds;
    }
    public cls_Common()
    {
        string strDecryptedString = string.Empty;
        strDecryptedString = Cryptographys.Cryptography.GetDecryptedConnectionString();
        if (strDecryptedString == string.Empty)
        {
        }
        else
        {
            ResetDatabaseConnection(strDecryptedString);
        }
    }
    public void ResetDatabaseConnection(string strDecryptedString)
    {
        DbProviderFactory objData = db.DbProviderFactory;
        db = new Microsoft.Practices.EnterpriseLibrary.Data.Sql.SqlDatabase(strDecryptedString);
    }
    //Converts the Date from any Date Format to MM/DD/YYYY
    public string DateConvertion(string Format, string strDateTime)
    {
        if (strDateTime == "")
        {
            return "";
        }
        // Getting Month
        int indexMonth = -2;
        int intMonthNoOfChars = 0;
        string strMonth = "";
        int indexMMM = Format.IndexOf(@"MMM");
        if (indexMMM == -1)
        {
            int indexMM = Format.IndexOf(@"MM");
            if (indexMM >= 0)
            {
                indexMonth = indexMM;
                intMonthNoOfChars = 2;
            }
        }
        else
        {
            indexMonth = indexMMM;
            intMonthNoOfChars = 3;
        }
        if (indexMonth != -2)
        {
            strMonth = strDateTime.Substring(indexMonth, intMonthNoOfChars);
        }
        // Getting Date
        int indexDate = -2;
        int intDateNoOfChars = 0;
        string strDate = "";
        int indexDD = Format.IndexOf(@"dd");
        if (indexDD >= 0)
        {
            indexDate = indexDD;
            intDateNoOfChars = 2;
        }
        if (indexDate != -2)
        {
            strDate = strDateTime.Substring(indexDate, intDateNoOfChars);
        }
        // Getting Year
        int indexYear = -2;
        int intYearNoOfChars = 0;
        string strYear = "";
        int indexYYYY = Format.IndexOf(@"yyyy");
        if (indexYYYY == -1)
        {
            int indexYY = Format.IndexOf(@"yy");
            if (indexYY >= 0)
            {
                indexYear = indexYY;
                intYearNoOfChars = 2;
            }
        }
        else
        {
            indexYear = indexYYYY;
            intYearNoOfChars = 4;
        }
        if (indexYear != -2)
        {
            strYear = strDateTime.Substring(indexYear, intYearNoOfChars);
        }
        string strFinalDate = "";
        if (indexMMM >= 0)
        {
            strFinalDate = strDate + "/" + strMonth + "/" + strYear;
        }
        else
        {
            // strFinalDate = strMonth + "/" + strDate + "/" + strYear;
            strFinalDate = strYear + "/" + strMonth + "/" + strDate;
        }
        DateTime dtmFinalDate = new DateTime();
        try
        {
            dtmFinalDate = DateTime.Parse(strFinalDate);
        }
        catch (Exception ex)
        {
            throw ex;
        }
        return (strFinalDate);
    }
    public string DateTimeConvertion(string Format, string strDateTime, string FormatType)
    {
        if (strDateTime == "")
        {
            return "";
        }
        // Getting Month
        int indexMonth = -2;
        int intMonthNoOfChars = 0;
        string strMonth = "";
        int indexMMM = Format.IndexOf(@"MMM");
        if (indexMMM == -1)
        {
            int indexMM = Format.IndexOf(@"MM");
            if (indexMM >= 0)
            {
                indexMonth = indexMM;
                intMonthNoOfChars = 2;
            }
        }
        else
        {
            indexMonth = indexMMM;
            intMonthNoOfChars = 3;
        }
        if (indexMonth != -2)
        {
            strMonth = strDateTime.Substring(indexMonth, intMonthNoOfChars);
        }
        // Getting Date
        int indexDate = -2;
        int intDateNoOfChars = 0;
        string strDate = "";
        int indexDD = Format.IndexOf(@"dd");
        if (indexDD >= 0)
        {
            indexDate = indexDD;
            intDateNoOfChars = 2;
        }
        if (indexDate != -2)
        {
            strDate = strDateTime.Substring(indexDate, intDateNoOfChars);
        }
        // Getting Year
        int indexYear = -2;
        int intYearNoOfChars = 0;
        string strYear = "";
        int indexYYYY = Format.IndexOf(@"yyyy");
        if (indexYYYY == -1)
        {
            int indexYY = Format.IndexOf(@"yy");
            if (indexYY >= 0)
            {
                indexYear = indexYY;
                intYearNoOfChars = 2;
            }
        }
        else
        {
            indexYear = indexYYYY;
            intYearNoOfChars = 4;
        }
        if (indexYear != -2)
        {
            strYear = strDateTime.Substring(indexYear, intYearNoOfChars);
        }
        string strFinalDate = "";
        if (indexMMM >= 0)
        {
            strFinalDate = strDate + "/" + strMonth + "/" + strYear;
        }
        else
        {
            strFinalDate = strMonth + "/" + strDate + "/" + strYear;
        }
        DateTime dtmFinalDate = new DateTime();
        try
        {
            dtmFinalDate = DateTime.Parse(strFinalDate);
        }
        catch (Exception ex)
        {
            throw ex;
        }
        // Getting Hours
        int indexHours = -2;
        int inHourstNoOfChars = 0;
        string strHours = "00";
        int indexhh = Format.IndexOf(@"hh");
        if (indexhh >= 0)
        {
            indexHours = indexhh;
            inHourstNoOfChars = 2;
        }
        else
        {
            int indexHH = Format.IndexOf(@"HH");
            if (indexHH >= 0)
            {
                indexHours = indexHH;
                inHourstNoOfChars = 2;
            }
        }
        if (indexHours != -2)
        {
            strHours = strDateTime.Substring(indexHours, inHourstNoOfChars);
        }
        // Getting Minutes
        int indexMins = -2;
        int intMinsNoOfChars = 0;
        string strMins = "00";
        int indexmm = Format.IndexOf(@"mm");
        if (indexmm >= 0)
        {
            indexMins = indexmm;
            intMinsNoOfChars = 2;
        }
        if (indexMins != -2)
        {
            strMins = strDateTime.Substring(indexMins, intMinsNoOfChars);
        }
        // Getting Seconds
        int indexSecs = -2;
        int intSecsNoOfChars = 0;
        string strSeconds = "00";
        int indexss = Format.IndexOf(@"ss");
        if (indexss >= 0)
        {
            indexSecs = indexss;
            intSecsNoOfChars = 2;
        }
        if (indexSecs != -2)
        {
            strSeconds = strDateTime.Substring(indexSecs, intSecsNoOfChars);
        }
        // Getting AM or PM - If 12 Hours Format
        int indexAMPM = -2;
        int intAMPMNoOfChars = 0;
        string strAMPM = "";
        int indextt = Format.IndexOf(@"tt");
        if (indextt >= 0)
        {
            indexAMPM = indextt;
            intAMPMNoOfChars = 2;
        }
        if (indexAMPM != -2)
        {
            strAMPM = strDateTime.Substring(indexAMPM, intAMPMNoOfChars);
        }
        string strTime = "";
        if (indextt >= 0)
        {
            strTime = strHours + ":" + strMins + ":" + strSeconds + " " + strAMPM;
        }
        else
        {
            strTime = strHours + ":" + strMins + ":" + strSeconds;
        }
        DateTime dtmFinalTime = new DateTime();
        try
        {
            dtmFinalTime = DateTime.Parse(strTime);
        }
        catch (Exception ex)
        {
            throw ex;
        }
        if (FormatType == "D")
        {
            return strFinalDate;
        }
        else if (FormatType == "T")
        {
            return strTime;
        }
        else if (FormatType == "B")
        {
            return (strFinalDate + " " + strTime);
        }
        else
        {
            return "";
        }
    }
    //selects the whole text of the control
    public string SelectAll(Control ctrl)
    {
        string selectScript = "<script language='javascript'>" + "document.getElementById('" + ctrl.ClientID + "').select();</script>";
        return selectScript;
    }
    public string KeepAlive()
    {
        int int_MilliSecondsTimeOut = (HttpContext.Current.Session.Timeout * 60000) - 30000;
        StringBuilder sScript = new StringBuilder();
        sScript.Append("<script type='text/javascript'>");
        //Number Of Reconnects   
        sScript.Append("var count=0;");
        //Maximum reconnects Setting   
        sScript.Append("var max = 6;");
        sScript.Append("function Reconnect(){");
        sScript.Append("count++;");
        sScript.Append("var d = new Date();");
        sScript.Append("var curr_hour = d.getHours();");
        sScript.Append("var curr_min = d.getMinutes();");
        sScript.Append("if (count < max){");
        sScript.Append("window.status = 'Refreshed ' + count.toString() + ' time(s) [' + curr_hour + ':' + curr_min + ']';");
        sScript.Append("var img = new Image(1,1);");
        sScript.Append("img.src = 'reconnect.aspx';");
        sScript.Append("}");
        sScript.Append("}");
        sScript.Append("window.setInterval('Reconnect()',");
        sScript.Append(int_MilliSecondsTimeOut.ToString() + ");");
        sScript.Append("</script>");
        return sScript.ToString();
    }
    //-- class for mandatory pages
    public DataSet GetRowsCountAllTables()
    {
        DataSet ds = new DataSet();
        string strScript = "Proc_TA_GetRowsCountAllPage";
        if (HttpContext.Current.Session["Edition"] != null)
        {
            if (HttpContext.Current.Session["Edition"].ToString() == "1")
            {
                strScript = "Proc_TA_GetRowsCountAllPageStandard";
            }
        }
        if (HttpContext.Current.Session["Demo"] != null)
        {
            if (HttpContext.Current.Session["Demo"].ToString() == "Standard" || HttpContext.Current.Session["Demo"].ToString() == "Express")
            {
                strScript = "Proc_TA_GetRowsCountAllPageStandard";
            }
        }
        ds = db.ExecuteDataSet(strScript);
        return ds;
    }
    public void UpdateRowsCountAllTables()
    {
        string strScript = "Proc_TA_UpdateRowsCount";
        if (HttpContext.Current.Session["Edition"] != null)
        {
            if (HttpContext.Current.Session["Edition"].ToString() == "1")
            {
                strScript = "Proc_TA_UpdateRowsCountStandard";
            }
        }
        if (HttpContext.Current.Session["Demo"] != null)
        {
            if (HttpContext.Current.Session["Demo"].ToString() == "Standard" || HttpContext.Current.Session["Demo"].ToString() == "Express")
            {
                strScript = "Proc_TA_UpdateRowsCountStandard";
            }
        }
        db.ExecuteNonQuery(strScript);
    }
    public DataSet GetRowsCountInTable(int PageID)
    {
        DataSet ds = new DataSet();
        string strScript = "Proc_TA_GetRowsCountInPage";
        if (HttpContext.Current.Session["Edition"] != null)
        {
            if (HttpContext.Current.Session["Edition"].ToString() == "1")
            {
                strScript = "Proc_TA_GetRowsCountInPageStandard";
            }
        }
        if (HttpContext.Current.Session["Demo"] != null)
        {
            if (HttpContext.Current.Session["Demo"].ToString() == "Standard" || HttpContext.Current.Session["Demo"].ToString() == "Express")
            {
                strScript = "Proc_TA_GetRowsCountInPageStandard";
            }
        }
        ds = db.ExecuteDataSet(strScript, new object[] { PageID });
        return ds;
    }
    public DataSet GetCheckMandatory()
    {
        DataSet ds = new DataSet();
        string strScript = "Proc_TA_CheckMandatoryPage";
        if (HttpContext.Current.Session["Edition"] != null)
        {
            if (HttpContext.Current.Session["Edition"].ToString() == "1")
            {
                strScript = "Proc_TA_CheckMandatoryPageStandard";
            }
        }
        if (HttpContext.Current.Session["Demo"] != null)
        {
            if (HttpContext.Current.Session["Demo"].ToString() == "Standard" || HttpContext.Current.Session["Demo"].ToString() == "Express")
            {
                strScript = "Proc_TA_CheckMandatoryPageStandard";
            }
        }
        ds = db.ExecuteDataSet(strScript);
        return ds;
    }
    //--end for class for  mandatory pages
    public string CheckDatabaseExists(string conString)
    {
        return objDataAccess.CheckDatabaseExists(conString);
    }
    public int CheckSuperAdminUser(string conString, string UserName, string strPassword)
    {
        SqlConnection sqlCon;
        string connStr = conString;
        //Encrypt the password
        strPassword = PasswordEncryption(strPassword);
        int intSuperAdminUser = 0;
        // Create new connection to database
        sqlCon = new SqlConnection(connStr);
        string strCmd = "Proc_TA_CheckSuperAdminUser";
        try
        {
            //Open Connection
            sqlCon.Open();
            SqlCommand cmd = new SqlCommand();
            SqlParameter pUserName = new SqlParameter("@Username", UserName);
            SqlParameter pPassWord = new SqlParameter("@PassWord", strPassword);
            SqlParameter[] pParams = { pUserName, pPassWord };
            cmd.Connection = sqlCon;
            cmd.CommandType = CommandType.StoredProcedure;
            cmd.CommandText = strCmd;
            cmd.Parameters.AddRange(pParams);
            cmd.CommandTimeout = 0;
            intSuperAdminUser = Convert.ToInt32(cmd.ExecuteScalar());
            cmd.Parameters.Clear();
        }
        catch (Exception ex)
        {
            throw ex;
        }
        finally
        {
            //Close Connection
            sqlCon.Close();
        }
        return intSuperAdminUser;
    }
    // Encoding Password
    public string PasswordEncryption(string EPassword)
    {
        MD5 md5 = MD5.Create();
        byte[] inputBytes, hashBytes;
        inputBytes = Encoding.ASCII.GetBytes(EPassword);
        hashBytes = md5.ComputeHash(inputBytes);
        EPassword = Convert.ToBase64String(hashBytes);
        return EPassword;
    }
    public DataSet getEmployeeAutoId(string EmployeeCodeId)
    {
        DataSet dsEmp = new DataSet();
        try
        {
            dsEmp = db.ExecuteDataSet("Proc_TA_GetEmployeeAutoId", new object[] { EmployeeCodeId });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return dsEmp;
    }
    public int CheckPageExistsInLicense(int pageID)
    {
        int Status = 0;
        try
        {
            Status = (int)db.ExecuteScalar("Proc_TA_CheckPageExistsInLicense", new object[] { pageID });
        }
        catch (Exception ex)
        {
            throw ex;
        }
        return Status;
    }
    public DataTable GetErrorVersionDetails(string PageName, string TrackingPlatform, string ErrorMsg, string ErrorText)
    {
        DataSet dsEmp = new DataSet();
        try
        {
            dsEmp = db.ExecuteDataSet("Proc_TA_GetErrorVersionDetails", new object[] { PageName, TrackingPlatform, ErrorMsg, ErrorText });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return dsEmp.Tables.Count > 0 ? dsEmp.Tables[0] : new DataTable();
    }
    //Get the Current Month Start day in all reports
    public DateTime CurrentMonthStartDate()
    {
        DateTime CurrentDate;
        //int StartDate;
        CurrentDate = (DateTime.Now);
        //StartDate = (DateTime.Now.AddDays(-1).Day);
        CurrentDate = CurrentDate.AddDays(-(CurrentDate.AddDays(-1).Day));
        return CurrentDate;
    }
    public DataTable GetParentLevelIdsForEmailScheduler(int EmailLevelid)
    {
        DataSet ds = new DataSet();
        try
        {
            ds = db.ExecuteDataSet("Proc_Ta_GetParentLevelIdsForEmailScheduler", new object[] { EmailLevelid });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds.Tables[0];
    }
    //select Year setting details
    public DataSet GetYearsettingForLeaveReport()
    {
        DataSet ds_Yearsetting = new DataSet();
        try
        {
            ds_Yearsetting = db.ExecuteDataSet("Proc_TA_SelectYearSettingForLeaveReport", new object[] { });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_Yearsetting;
    }
    //select next Year setting details
    /// <summary>
    /// Added by MAnjula.P on 17-Apr-2014 from ANGLER 
    /// </summary>
    /// <returns></returns>
    public DataSet GetNextYearsetting_Angler()
    {
        DataSet dsNextYearsetting = new DataSet();
        try
        {
            dsNextYearsetting = db.ExecuteDataSet("Proc_TA_SelectNextYearSetting", new object[] { });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return dsNextYearsetting;
    }
    public string[] commaStringToArray(string strComma)
    {
        string[] strArray;
        strArray = strComma.Split(new char[] { ',' });
        string[] intArray = new string[strArray.Length];
        for (int i = 0; i < strArray.Length; i++)
            intArray[i] = Convert.ToString(strArray[i]);
        return intArray;
    }
    // Authenticate UserName Domain
    public DataSet UserAuthenticateDomain(string DomainUserName)
    {
        DataSet ds = new DataSet();
        try
        {
            ds = db.ExecuteDataSet("Proc_TA_DomainLogin", new object[] { DomainUserName });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds;
    }
    private void GetApprovalPersonDetailsForEMailTriggering(int intEmployeeId)
    {
    }
    public bool PrepareEmailContentForMailTriggering
        (
        string app_empId,
        string app_empName,
        string app_levelName,
        string app_LevelID,
        string app_ispayrollConfig,
        string app_remarks,
        string app_reason,
        string app_empMailid,
        string app_Status,
        string PerTotalHours,
        string PermissionDate,
        string Permission_Onduty_FromTime,
        string Permission_Onduty_ToTime,
        string app_ID,
        string LeaveType,
        string app_EntryDate,
        string LeaveFromDate,
        string LeaveToDate,
        string LeaveFromSession,
        string LeaveToSession,
        string LeaveNumberOfDaysApplied,
        string app_empDesignationId,
        string app_IntimationType,
        string app_From,
        int app_empAutoID)
    {
        #region Variable
        MailMessage mailMessage = new MailMessage();
        string mailsubject = string.Empty, mailbody = string.Empty;
        DataTable dtTableScript = new DataTable();
        DataSet dsEmailIdOfReportingTo = new DataSet();
        DataSet dsEmailIdOfSanctionAuthority = new DataSet();
        PermissionEventData objPermissionEventData = new PermissionEventData();
        string strReplaceSubject = string.Empty, ApprovalAuthorityEmailID = string.Empty, ReportingToEmailId = string.Empty;
        string strPerStatus = app_Status;
        ResourceManager rm;
        CultureInfo ci;
        string source_Language;
        source_Language = Convert.ToString(HttpContext.Current.Session["Session_ActiveLanguage"]);
        rm = new ResourceManager(source_Language, System.Reflection.Assembly.Load("App_GlobalResources"));
        ci = Thread.CurrentThread.CurrentCulture;
        string TimeFormatMail = Convert.ToString(HttpContext.Current.Session["ITimeFormat"]);
        #endregion
        try
        {
            dsEmailIdOfReportingTo = objPermissionEventData.SelectMailIdOfReportingTo(app_empAutoID);
            dsEmailIdOfSanctionAuthority = objPermissionEventData.SelectMailIdOfSanctionAuthority(app_empAutoID);
            if (dsEmailIdOfSanctionAuthority != null)
                if (dsEmailIdOfSanctionAuthority.Tables.Count > 0)
                    if (dsEmailIdOfSanctionAuthority.Tables[0].Rows.Count > 0)
                        if (dsEmailIdOfSanctionAuthority.Tables[0].Rows[0]["EmailId"] != DBNull.Value && Convert.ToString(dsEmailIdOfSanctionAuthority.Tables[0].Rows[0]["EmailId"]) != "")
                            ApprovalAuthorityEmailID = Convert.ToString(dsEmailIdOfSanctionAuthority.Tables[0].Rows[0]["EmailId"]);
            if (dsEmailIdOfReportingTo != null)
                if (dsEmailIdOfReportingTo.Tables.Count > 0)
                    if (dsEmailIdOfReportingTo.Tables[0].Rows.Count > 0)
                        if (dsEmailIdOfReportingTo.Tables[0].Rows[0]["EmailId"] != DBNull.Value && Convert.ToString(dsEmailIdOfReportingTo.Tables[0].Rows[0]["EmailId"]) != "")
                            ReportingToEmailId = Convert.ToString(dsEmailIdOfReportingTo.Tables[0].Rows[0]["EmailId"]);
            #region AddingToAndCC
            if (HttpContext.Current.Session["loginEmailId"] != null && Convert.ToString(HttpContext.Current.Session["loginEmailId"]) != string.Empty)
                mailMessage.From = new MailAddress(Convert.ToString(HttpContext.Current.Session["loginEmailId"]));
            else
                mailMessage.From = new MailAddress(ConfigurationManager.AppSettings.Get("FromId"));
            if (app_Status == "Forwarded")
            {
                if (ApprovalAuthorityEmailID != string.Empty && ApprovalAuthorityEmailID != null)
                    mailMessage.To.Add(new MailAddress(ApprovalAuthorityEmailID));
                if (app_empMailid != string.Empty && app_empMailid != null)
                    mailMessage.CC.Add(new MailAddress(app_empMailid));
            }
            else
            {
                if (ReportingToEmailId != string.Empty && ReportingToEmailId != null)
                    mailMessage.To.Add(new MailAddress(ReportingToEmailId));
                if (app_empMailid != string.Empty && app_empMailid != null)
                    mailMessage.CC.Add(new MailAddress(app_empMailid));
            }
            app_Status = GetDataFromResource(app_Status, rm, ci);
            #region PermissionApplication
            if (app_From == "PermissionApplication" && app_ispayrollConfig != "0")
            {
                DataSet dsCCEmailIds = new DataSet();
                CCGroupEventData_Angler objCCGroup = new CCGroupEventData_Angler();
                bool blnMailToSecondLevel = false;
                if (Convert.ToInt16(app_IntimationType) == 1)
                {
                    dsCCEmailIds = objCCGroup.GetCCEmailIds(Convert.ToInt16(app_LevelID), Convert.ToInt16(app_empDesignationId), "U");
                    if (dsCCEmailIds != null)
                        if (dsCCEmailIds.Tables[1].Rows.Count > 0)
                            if (Convert.ToBoolean(dsCCEmailIds.Tables[1].Rows[0]["MailTo_SecondLevel_UnPlanned"]) == true)
                                blnMailToSecondLevel = true;
                }
                else
                {
                    dsCCEmailIds = objCCGroup.GetCCEmailIds(Convert.ToInt16(app_LevelID), Convert.ToInt16(app_empDesignationId), "P");
                    if (dsCCEmailIds != null)
                        if (dsCCEmailIds.Tables[1].Rows.Count > 0)
                            if (Convert.ToBoolean(dsCCEmailIds.Tables[1].Rows[0]["MailTo_SecondLevel_Planned"]) == true)
                                blnMailToSecondLevel = true;
                }
                if (app_Status != "Reply")
                {
                    if (dsCCEmailIds != null)
                    {
                        if (dsCCEmailIds.Tables.Count > 0)
                            if (dsCCEmailIds.Tables[0].Rows.Count > 0)
                                foreach (DataRow drCcEmailId in dsCCEmailIds.Tables[0].Rows)
                                {
                                    MailAddressCollection MailAddrCollectionCC = mailMessage.CC;
                                    // added by Gopinath.k for Mantis Bug no.24059 & 24098
                                    if (Convert.ToString(drCcEmailId["EmailId"]) != string.Empty)
                                    {
                                        MailAddress newCC = new MailAddress(Convert.ToString(drCcEmailId["EmailId"]));
                                        MailAddrCollectionCC.Add(newCC);
                                    }
                                }
                    }
                    if (app_Status == "Pending")
                        if (blnMailToSecondLevel == true)
                            mailMessage.CC.Add(new MailAddress(ApprovalAuthorityEmailID));
                }
                else if (app_Status == "Reply")
                {
                    if (dsCCEmailIds != null)
                        if (dsCCEmailIds.Tables.Count > 0)
                            if (dsCCEmailIds.Tables[0].Rows.Count > 0)
                                foreach (DataRow drCcEmailId in dsCCEmailIds.Tables[0].Rows)
                                {
                                    MailAddressCollection MailAddrCollectionCC = mailMessage.CC;
                                    // added by Gopinath.k for Mantis Bug no.24059 & 24098
                                    if (Convert.ToString(drCcEmailId["EmailId"]) != string.Empty)
                                    {
                                        MailAddress newCC = new MailAddress(Convert.ToString(drCcEmailId["EmailId"]));
                                        MailAddrCollectionCC.Add(newCC);
                                    }
                                }
                }
                Hashtable htToMails = new Hashtable();
                Hashtable htCCMails = new Hashtable();
                int intToMailCount = 0;
                int intCCMailCount = 0;
                foreach (MailAddress ToMail in mailMessage.To)
                {
                    if (htToMails.ContainsValue(ToMail) == false)
                    {
                        htToMails.Add(intToMailCount++, ToMail);
                    }
                }
                foreach (MailAddress CCMail in mailMessage.CC)
                {
                    //check whether the mail alredy exists in CC mails.
                    if (htCCMails.ContainsValue(CCMail) == false)
                    {
                        //check whether the mail alredy exists in TO mails.
                        if (htToMails.ContainsValue(CCMail) == false)
                        {
                            htCCMails.Add(intCCMailCount++, CCMail);
                        }
                    }
                }
                mailMessage.To.Clear();
                mailMessage.CC.Clear();
                //Adds the TO mails from the hastable.
                foreach (DictionaryEntry ToMails in htToMails)
                {
                    mailMessage.To.Add(Convert.ToString(ToMails.Value));
                }
                //Adds the CC mails from the hastable.
                foreach (DictionaryEntry CCMails in htCCMails)
                {
                    mailMessage.CC.Add(Convert.ToString(CCMails.Value));
                }
                if (app_empDesignationId != "0")
                {
                    strPerStatus = app_Status + " - Modified";
                }
            }
            #endregion
            #endregion
            #region ReplaceAndMailSend           
            dtTableScript = GetEmailScripts(GetEmailScriptName(app_From));
            if (dtTableScript.Rows.Count > 0)
            {
                strReplaceSubject = " - " + app_EntryDate + " | " + app_empId + " - " + app_empName + " | " + app_levelName + " - " + app_Status;
                switch (app_From)
                {
                    #region LeaveApplication
                    case "LeaveApplication":
                    case "LeaveSanction":
                        LeaveType = GetDataFromResource(LeaveType, rm, ci);
                        mailsubject = rm.GetString("email_LeaveApplicationForm", ci) + strReplaceSubject;
                        mailbody = ReplaceLeaveBodyContent(app_empId, app_empName, app_LevelID, app_remarks, app_reason, app_Status, LeaveType, app_EntryDate, LeaveFromDate, LeaveToDate, LeaveFromSession, LeaveToSession, LeaveNumberOfDaysApplied, app_ID, app_From, mailMessage, Convert.ToString(dtTableScript.Rows[0]["ScriptText"]), rm, ci);
                        break;
                    #endregion
                    #region PermissionApplication
                    case "PermissionApplication":
                    case "PermissionSanction":
                        mailsubject = rm.GetString("email_PermissionForm", ci) + strReplaceSubject; ;
                        mailbody = ReplacePermissionBodyContent(app_empId, app_empName, app_levelName, app_LevelID, app_ispayrollConfig, app_remarks, app_reason, app_Status, PerTotalHours, PermissionDate, Permission_Onduty_FromTime, Permission_Onduty_ToTime, app_ID, app_From, mailMessage, Convert.ToString(dtTableScript.Rows[0]["ScriptText"]), rm, ci);
                        break;
                    #endregion
                    #region OndutyApplication
                    case "OndutyApplication":
                    case "OndutySanction":
                        if (app_empDesignationId != "0")
                        {
                            strReplaceSubject = strReplaceSubject.Replace(app_Status, app_Status + " - Modified");
                        }
                        if (TimeFormatMail == "HH:mm")
                            TimeFormatMail = "HH:mm";
                        else
                            TimeFormatMail = "hh:mm tt";
                        mailsubject = rm.GetString("email_OndutyApplicationForm", ci) + strReplaceSubject;
                        mailbody = ReplaceOndutyBodyContent(app_empId, app_empName, app_levelName, app_LevelID, app_remarks, app_reason, app_Status, Permission_Onduty_FromTime, Permission_Onduty_ToTime, app_EntryDate, LeaveFromDate, LeaveToDate, app_ID, app_From, mailMessage, Convert.ToString(dtTableScript.Rows[0]["ScriptText"]), strPerStatus, rm, ci, TimeFormatMail);
                        break;
                        #endregion
                }
                mailMessage.Subject = mailsubject;
                mailMessage.Body = mailbody;
                SendMail(mailMessage);
            }
            #endregion
        }
        catch
        {
            return false;
        }
        return true;
    }
    private static string GetEmailScriptName(string isFrom)
    {
        string ScriptType = string.Empty;
        switch (isFrom)
        {
            case "LeaveApplication":
            case "LeaveSanction":
                ScriptType = (isFrom == "LeaveApplication") ? "New Leave Application Form" : "Leave Application Sanction By Reporting to Person";
                break;
            case "PermissionApplication":
            case "PermissionSanction":
                ScriptType = "New Permission Form";
                break;
            case "OndutyApplication":
            case "OndutySanction":
                ScriptType = (isFrom == "OndutyApplication") ? "Onduty Application From" : "Onduty Application Modify";
                break;
        }
        return ScriptType;
    }
    private static string ReplaceOndutyBodyContent(string EmployeeCodeId, string EmployeeName, string levelName, string LevelID, string Remarks, string Reason, string Status, string FromTime, string ToTime, string ApplicationDate, string FromDate, string ToDate, string OnDutyID, string isFrom, MailMessage mailMessage, string scriptText, string strPerStatus, ResourceManager rm, CultureInfo ci, string TimeFormatMail)
    {
        string replacemailBody = string.Empty;
        replacemailBody = scriptText.Replace("<<lblOndutyForm>>", rm.GetString("email_OndutyApplicationForm", ci));
        replacemailBody = replacemailBody.Replace("<<ltr_rtl>>", rm.GetString("Direction", ci));
        replacemailBody = replacemailBody.Replace("<<lblEmployeeID>>", rm.GetString("Field_EmployeeID", ci));
        replacemailBody = replacemailBody.Replace("<<EmployeeID>>", EmployeeCodeId);
        replacemailBody = replacemailBody.Replace("<<lblEmployeeName>>", rm.GetString("Field_EmployeeName", ci));
        replacemailBody = replacemailBody.Replace("<<EmployeeName>>", EmployeeName);
        replacemailBody = replacemailBody.Replace("<<lbldepartment>>", "Department");
        replacemailBody = replacemailBody.Replace("<<department>>", levelName);
        replacemailBody = replacemailBody.Replace("<<lblApplicationDate>>", rm.GetString("ODEntry_ODEntryDate", ci));
        replacemailBody = replacemailBody.Replace("<<ApplicationDate>>", ApplicationDate);
        replacemailBody = replacemailBody.Replace("<<lblODDate>>", rm.GetString("OnDutyDate", ci));
        replacemailBody = replacemailBody.Replace("<<lblFromDate>>", rm.GetString("Field_From", ci));
        replacemailBody = replacemailBody.Replace("<<FromDate>>", FromDate + " " + Convert.ToDateTime(FromTime).ToString(TimeFormatMail));
        replacemailBody = replacemailBody.Replace("<<lblToDate>>", rm.GetString("Field_To", ci));
        replacemailBody = replacemailBody.Replace("<<ToDate>>", ToDate + " " + Convert.ToDateTime(ToTime).ToString(TimeFormatMail));
        replacemailBody = replacemailBody.Replace("<<lblStatus>>", rm.GetString("Field_Status", ci));
        replacemailBody = replacemailBody.Replace("<<Status>>", Status);
        replacemailBody = replacemailBody.Replace("<<lblReason>>", rm.GetString("email_Reason", ci));
        replacemailBody = replacemailBody.Replace("<<Reason>>", Reason);
        if (isFrom == "OndutySanction")
        {
            replacemailBody = replacemailBody.Replace("<<lblRemarks>>", rm.GetString("PermissionSanction_Remarks", ci));
            replacemailBody = replacemailBody.Replace("<<Remarks>>", Remarks);
        }
        if (Status == "Forwarded" || Status == "Pending")
        {
            replacemailBody = replacemailBody.Replace("<<LinkData>>", Convert.ToString(HttpContext.Current.Session["HostServerURL"]) + "?ODID=" + Convert.ToString(OnDutyID) + "&LevelId=" + LevelID + "&Status=" + Status + "&ApprovalType=Onduty&ParentID=" + Convert.ToString(HttpContext.Current.Session["parentLevelId"]) + "");
        }
        else
        {
            replacemailBody = replacemailBody.Replace("<font face=\"Arial\" size=\"2\"><a href=\"<<LinkData>>\">Click here for approval </a></font>", string.Empty);
        }
        return replacemailBody;
    }
    private static string ReplacePermissionBodyContent(string EmployeeCodeId, string EmployeeName, string levelName, string LevelID, string payrollConfig, string Remarks, string Reason, string Status, string PerTotalHours, string PermissionDate, string FromTime, string ToTime, string Permission_Id, string isFrom, MailMessage mailMessage, string scriptText, ResourceManager rm, CultureInfo ci)
    {
        string replacemailBody = string.Empty;
        replacemailBody = scriptText.Replace("<<permissionform>>", rm.GetString("email_PermissionForm", ci));
        replacemailBody = replacemailBody.Replace("<<lblemployeeid>>", rm.GetString("Field_EmployeeID", ci));
        replacemailBody = replacemailBody.Replace("<<employeeid>>", EmployeeCodeId);
        replacemailBody = replacemailBody.Replace("<<lblemployeename>>", rm.GetString("Field_EmployeeName", ci));
        replacemailBody = replacemailBody.Replace("<<employeename>>", EmployeeName);
        replacemailBody = replacemailBody.Replace("<<lblDepartment>>", "Department");
        replacemailBody = replacemailBody.Replace("<<Department>>", levelName);
        replacemailBody = replacemailBody.Replace("<<lblpermissiondate>>", rm.GetString("Permission_PermissionDate", ci));
        replacemailBody = replacemailBody.Replace("<<permissiondate>>", PermissionDate);
        replacemailBody = replacemailBody.Replace("<<lblnumberofhoursapplied>>", rm.GetString("email_NumberOfHoursApplied", ci));
        replacemailBody = replacemailBody.Replace("<<numberofhoursapplied>>", Convert.ToString(PerTotalHours));
        replacemailBody = replacemailBody.Replace("<<lblpermission>>", rm.GetString("Dash_Permission", ci));
        replacemailBody = replacemailBody.Replace("<<lblfromtime>>", rm.GetString("Field_From", ci));
        replacemailBody = replacemailBody.Replace("<<fromtime>>", FromTime);
        replacemailBody = replacemailBody.Replace("<<lbltotime>>", rm.GetString("Field_To", ci));
        replacemailBody = replacemailBody.Replace("<<totime>>", ToTime);
        replacemailBody = replacemailBody.Replace("<<lblstatus>>", rm.GetString("Field_Status", ci));
        replacemailBody = replacemailBody.Replace("<<status>>", Status);
        replacemailBody = replacemailBody.Replace("<<lblreason>>", rm.GetString("email_Reason", ci));
        replacemailBody = replacemailBody.Replace("<<reason>>", Reason);
        if (isFrom == "PermissionSanction")
        {
            replacemailBody = replacemailBody.Replace("<<lblRemarks>>", rm.GetString("PermissionSanction_Remarks", ci));
            replacemailBody = replacemailBody.Replace("<<Remarks>>", Remarks);
        }
        if (Status == "Forwarded" || Status == "Pending")
        {
            if (payrollConfig == "1")
            {
                replacemailBody = replacemailBody.Replace("<<LinkData>>", Convert.ToString(HttpContext.Current.Session["HostServerURL"]) + "?Permission_Id=" + Permission_Id + "&LevelId=" + LevelID + "&ApprovalType=Permission&Status=" + Status + "&From_Date=&To_Date=strSwipeCardNo=&strEmployeeName=&strEmployeeCodeId=&Angler=1");
            }
            else
            {
                replacemailBody = replacemailBody.Replace("<<LinkData>>", Convert.ToString(HttpContext.Current.Session["HostServerURL"]) + "?Permission_Id=" + Permission_Id + "&LevelId=" + LevelID + "&ApprovalType=Permission&Status=" + Status + "&From_Date=&To_Date=strSwipeCardNo=&strEmployeeName=&strEmployeeCodeId=");
            }
        }
        else
            replacemailBody = replacemailBody.Replace("<a href=<<LinkData>>><font face=\"Arial\" size=\"2\">Click here for approval</font>", string.Empty);
        return replacemailBody;
    }
    private static string ReplaceLeaveBodyContent(string EmployeeCodeId, string EmployeeName, string LevelID, string Remarks, string Reason, string Status, string LeaveType, string ApplicationDate, string FromDate, string ToDate, string LeaveFromSession, string LeaveToSession, string LeaveNumberOfDaysApplied, string LeaveApplicationID, string isFrom, MailMessage mailMessage, string scriptText, ResourceManager rm, CultureInfo ci)
    {
        string replacemailBody = string.Empty;
        replacemailBody = scriptText.Replace("<<lblleaveapplicationform>>", rm.GetString("email_LeaveApplicationForm", ci));
        replacemailBody = replacemailBody.Replace("<<ltr_rtl>>", rm.GetString("Direction", ci));
        replacemailBody = replacemailBody.Replace("<<lblemployeeid>>", rm.GetString("Field_EmployeeID", ci));
        replacemailBody = replacemailBody.Replace("<<employeeid>>", EmployeeCodeId);
        replacemailBody = replacemailBody.Replace("<<lblemployeename>>", rm.GetString("Field_EmployeeName", ci));
        replacemailBody = replacemailBody.Replace("<<employeename>>", EmployeeName);
        replacemailBody = replacemailBody.Replace("<<lblapplicationdate>>", rm.GetString("email_LeaveApplicationDate", ci));
        replacemailBody = replacemailBody.Replace("<<applicationdate>>", ApplicationDate);
        replacemailBody = replacemailBody.Replace("<<lblleavetype>>", rm.GetString("Menu_LeaveType", ci));
        replacemailBody = replacemailBody.Replace("<<leavetype>>", LeaveType);
        replacemailBody = replacemailBody.Replace("<<numberdaysapplied>>", Convert.ToString(LeaveNumberOfDaysApplied));
        replacemailBody = replacemailBody.Replace("<<lblnumberdaysapplied>>", rm.GetString("email_NumberOfDaysApplied", ci));
        replacemailBody = replacemailBody.Replace("<<lblleavedate>>", rm.GetString("email_LeaveDate", ci));
        replacemailBody = replacemailBody.Replace("<<fromdate>>", FromDate);
        replacemailBody = replacemailBody.Replace("<<lblfromdate>>", rm.GetString("Field_From", ci));
        replacemailBody = replacemailBody.Replace("<<todate>>", ToDate);
        replacemailBody = replacemailBody.Replace("<<lbltodate>>", rm.GetString("Field_To", ci));
        replacemailBody = replacemailBody.Replace("<<lblsession>>", rm.GetString("email_Session", ci));
        replacemailBody = replacemailBody.Replace("<<fromsession>>", LeaveFromSession);
        replacemailBody = replacemailBody.Replace("<<lblfromsession>>", rm.GetString("lbl_FromSession", ci));
        replacemailBody = replacemailBody.Replace("<<tosession>>", LeaveToSession);
        replacemailBody = replacemailBody.Replace("<<lbltosession>>", rm.GetString("lbl_ToSession", ci));
        replacemailBody = replacemailBody.Replace("<<reason>>", Reason);
        replacemailBody = replacemailBody.Replace("<<lblreason>>", rm.GetString("email_Reason", ci));
        replacemailBody = replacemailBody.Replace("<<lblstatus>>", rm.GetString("Field_Status", ci));
        replacemailBody = replacemailBody.Replace("<<status>>", Status);
        if (isFrom == "LeaveSanction")
        {
            replacemailBody = replacemailBody.Replace("<<lblRemarks>>", rm.GetString("email_Remarks", ci));
            replacemailBody = replacemailBody.Replace("<<Remarks>>", Remarks);
        }
        if (Status == "Forwarded" || Status == "Pending")
            replacemailBody = replacemailBody.Replace("<<LinkData>>", Convert.ToString(HttpContext.Current.Session["HostServerURL"]) + "?LeaveApplication_Id=" + Convert.ToString(LeaveApplicationID) + "&LevelId=" + LevelID + "&Status=" + Status + "&ApprovalType=Leave");
        else
        {
            replacemailBody = replacemailBody.Replace("<a href=<<LinkData>>><font face=\"Arial\" size=\"2\">Click here for approval</font>", string.Empty);
            replacemailBody = replacemailBody.Replace("<a href=<<LinkData>>>", "<a href='#'>");
            replacemailBody = replacemailBody.Replace("Click here for approval", string.Empty);
        }
        return replacemailBody;
    }
    private static string GetDataFromResource(string requestString, ResourceManager rm, CultureInfo ci)
    {
        if (requestString == "Pending")
            requestString = rm.GetString("btn_Pending", ci);
        else if (requestString == "Forwarded")
            requestString = rm.GetString("btn_Forwarded", ci);
        else if (requestString == "Approved")
            requestString = rm.GetString("btn_Approved", ci);
        else if (requestString == "Rejected")
            requestString = rm.GetString("btn_Reject", ci);
        else if (requestString == "Deleted")
            requestString = rm.GetString("DeleteStatus", ci);
        if (requestString == "Restricted Holiday")
            requestString = rm.GetString("Holiday_RestrictedHoliday", ci);
        else if (requestString == "Comp Off")
            requestString = rm.GetString("Caption_CompOff", ci);
        else if (requestString.Contains("LOP"))
            requestString = requestString.Replace("LOP", rm.GetString("LeavePolicy_LOP", ci));
        else if (requestString == "ESI")
            requestString = rm.GetString("Caption_ESI", ci);
        else if (requestString.Contains("Leave"))
            requestString = requestString.Replace("Leave", rm.GetString("LeaveApplication_Leave", ci));
        return requestString;
    }
    public bool SendMailAll(string EmployeeCodeId, string EmployeeName, string levelName, string LevelID, string payrollConfig, string Remarks, string Reason, string EmployeeEamilId, string EmailIdReportingTo, string EmailIdSanctionAuthority, string Status, string PerTotalHours, string PermissionDate, string FromTime, string ToTime, string Permission_Id, string LeaveType, string ApplicationDate, string FromDate, string ToDate, string LeaveFromSession, string LeaveToSession, string LeaveNumberOfDaysApplied, string LeaveApplicationID, string DesignationId, string IntimationType, string OnDutyID, string isFrom)
    {
        #region Variable
        MailMessage mailMessage = new MailMessage();
        string scriptText = string.Empty;
        DataTable dtTableScript = new DataTable();
        string strFromEmailId = string.Empty;
        string ScriptType = string.Empty;
        string strReplaceText = string.Empty;
        string strPerStatus = Status;
        ResourceManager rm;
        CultureInfo ci;
        string source_Language;
        source_Language = Convert.ToString(HttpContext.Current.Session["Session_ActiveLanguage"]);
        rm = new ResourceManager(source_Language, System.Reflection.Assembly.Load("App_GlobalResources"));
        ci = Thread.CurrentThread.CurrentCulture;
        string TimeFormatMail = HttpContext.Current.Session["ITimeFormat"].ToString();
        #endregion
        try
        {
            #region AddedMaillToCC
            if (HttpContext.Current.Session["loginEmailId"] != null && Convert.ToString(HttpContext.Current.Session["loginEmailId"]) != string.Empty)
            {
                mailMessage.From = new MailAddress(HttpContext.Current.Session["loginEmailId"].ToString());
                strFromEmailId = Convert.ToString(HttpContext.Current.Session["loginEmailId"]);
            }
            else
            {
                mailMessage.From = new MailAddress(ConfigurationManager.AppSettings.Get("FromId"));
                strFromEmailId = Convert.ToString(ConfigurationManager.AppSettings.Get("FromId"));
            }

            if (Status == "Forwarded")
            {
                if (EmailIdSanctionAuthority != string.Empty)
                {
                    mailMessage.To.Add(new MailAddress(EmailIdSanctionAuthority));
                }
                if (EmployeeEamilId != string.Empty)
                {
                    mailMessage.CC.Add(new MailAddress(EmployeeEamilId));
                }
            }
            else if (Status == "Approved" || Status == "Rejected" || Status == "Resend" || Status == "Deleted")
            {
                if (EmployeeEamilId != string.Empty)
                {
                    mailMessage.To.Add(new MailAddress(EmployeeEamilId));
                }
                if (EmailIdReportingTo != string.Empty)
                {
                    mailMessage.CC.Add(new MailAddress(EmailIdReportingTo));
                }
            }
            else if (Status == "Pending")
            {
                if (EmailIdReportingTo != string.Empty)
                {
                    mailMessage.To.Add(new MailAddress(EmailIdReportingTo));
                }
                if (EmployeeEamilId != string.Empty)
                {
                    mailMessage.CC.Add(new MailAddress(EmployeeEamilId));
                }
            }
            #region PermissionApplication
            if (isFrom == "PermissionApplication")
            {
                DataSet dsCCEmailIds = new DataSet();
                CCGroupEventData_Angler objCCGroup = new CCGroupEventData_Angler();
                bool blnMailToSecondLevel = false;
                if (Convert.ToInt16(IntimationType) == 1)
                {
                    dsCCEmailIds = objCCGroup.GetCCEmailIds(Convert.ToInt16(LevelID), Convert.ToInt16(DesignationId), "U");
                    if (dsCCEmailIds != null)
                    {
                        if (dsCCEmailIds.Tables[1].Rows.Count > 0)
                        {
                            if (Convert.ToBoolean(dsCCEmailIds.Tables[1].Rows[0]["MailTo_SecondLevel_UnPlanned"]) == true)
                            {
                                blnMailToSecondLevel = true;
                            }
                        }
                    }
                }
                else
                {
                    dsCCEmailIds = objCCGroup.GetCCEmailIds(Convert.ToInt16(LevelID), Convert.ToInt16(DesignationId), "P");
                    if (dsCCEmailIds != null)
                    {
                        if (dsCCEmailIds.Tables[1].Rows.Count > 0)
                        {
                            if (Convert.ToBoolean(dsCCEmailIds.Tables[1].Rows[0]["MailTo_SecondLevel_Planned"]) == true)
                            {
                                blnMailToSecondLevel = true;
                            }
                        }
                    }
                }
                if (Status != "Reply")
                {
                    if (dsCCEmailIds != null)
                    {
                        if (dsCCEmailIds.Tables.Count > 0)
                        {
                            if (dsCCEmailIds.Tables[0].Rows.Count > 0)
                            {
                                foreach (DataRow drCcEmailId in dsCCEmailIds.Tables[0].Rows)
                                {
                                    MailAddressCollection MailAddrCollectionCC = mailMessage.CC;
                                    // added by Gopinath.k for Mantis Bug no.24059 & 24098
                                    if (Convert.ToString(drCcEmailId["EmailId"]) != string.Empty)
                                    {
                                        MailAddress newCC = new MailAddress(Convert.ToString(drCcEmailId["EmailId"]));
                                        MailAddrCollectionCC.Add(newCC);
                                    }
                                }
                            }
                        }
                    }
                    if (Status == "Pending")
                    {
                        if (blnMailToSecondLevel == true)
                        {
                            mailMessage.CC.Add(new MailAddress(EmailIdSanctionAuthority));
                        }
                    }
                }
                else if (Status == "Reply")
                {
                    if (dsCCEmailIds != null)
                    {
                        if (dsCCEmailIds.Tables.Count > 0)
                        {
                            if (dsCCEmailIds.Tables[0].Rows.Count > 0)
                            {
                                foreach (DataRow drCcEmailId in dsCCEmailIds.Tables[0].Rows)
                                {
                                    MailAddressCollection MailAddrCollectionCC = mailMessage.CC;
                                    // added by Gopinath.k for Mantis Bug no.24059 & 24098
                                    if (Convert.ToString(drCcEmailId["EmailId"]) != string.Empty)
                                    {
                                        MailAddress newCC = new MailAddress(Convert.ToString(drCcEmailId["EmailId"]));
                                        MailAddrCollectionCC.Add(newCC);
                                    }
                                }
                            }
                        }
                    }
                }
                //check for duplicate mail Ids
                //included by sashma on 20-Oct-2010
                Hashtable htToMails = new Hashtable();
                Hashtable htCCMails = new Hashtable();
                int intToMailCount = 0;
                int intCCMailCount = 0;
                //inserts the TO mailIds in the hashtable
                foreach (MailAddress ToMail in mailMessage.To)
                {
                    if (htToMails.ContainsValue(ToMail) == false)
                    {
                        htToMails.Add(intToMailCount++, ToMail);
                    }
                }
                //inserts the CC mailIds in the hashtable
                foreach (MailAddress CCMail in mailMessage.CC)
                {
                    //check whether the mail alredy exists in CC mails.
                    if (htCCMails.ContainsValue(CCMail) == false)
                    {
                        //check whether the mail alredy exists in TO mails.
                        if (htToMails.ContainsValue(CCMail) == false)
                        {
                            htCCMails.Add(intCCMailCount++, CCMail);
                        }
                    }
                }
                mailMessage.To.Clear();
                mailMessage.CC.Clear();
                //Adds the TO mails from the hastable.
                foreach (DictionaryEntry ToMails in htToMails)
                {
                    mailMessage.To.Add(Convert.ToString(ToMails.Value));
                }
                //Adds the CC mails from the hastable.
                foreach (DictionaryEntry CCMails in htCCMails)
                {
                    mailMessage.CC.Add(Convert.ToString(CCMails.Value));
                }
                if (DesignationId != "0")
                {
                    strPerStatus = Status + " - Modified";
                }
            }
            #endregion
            #endregion
            #region Status
            if (Status == "Approved")
            {
                Status = rm.GetString("Sanction_Approved", ci);
            }
            else if (Status == "Forwarded")
            {
                Status = rm.GetString("Sanction_Forwarded", ci);
            }
            else if (Status == "Pending")
            {
                Status = rm.GetString("Sanction_Pending", ci);
            }
            else if (Status == "Rejected")
            {
                Status = rm.GetString("Sanction_Rejected", ci);
            }
            #endregion
            #region Replace
            switch (isFrom)
            {
                #region LeaveApplication
                case "LeaveApplication":
                    ScriptType = "New Leave Application Form";
                    dtTableScript = GetEmailScripts(ScriptType);
                    scriptText = dtTableScript.Rows[0]["ScriptText"].ToString();
                    if (LeaveType == "Restricted Holiday")
                    {
                        LeaveType = rm.GetString("Holiday_RestrictedHoliday", ci);
                    }
                    else if (LeaveType == "Comp Off")
                    {
                        LeaveType = rm.GetString("Caption_CompOff", ci);
                    }
                    else if (LeaveType.Contains("LOP"))
                    {
                        LeaveType = LeaveType.Replace("LOP", rm.GetString("LeavePolicy_LOP", ci));
                    }
                    else if (LeaveType == "ESI")
                    {
                        LeaveType = rm.GetString("Caption_ESI", ci);
                    }
                    else if (LeaveType.Contains("Leave"))
                    {
                        LeaveType = LeaveType.Replace("Leave", rm.GetString("LeaveApplication_Leave", ci));
                    }
                    mailMessage.Subject = rm.GetString("email_LeaveApplicationForm", ci) + " - " + ApplicationDate + " | " + EmployeeCodeId + " - " + EmployeeName + " | " + levelName + " - " + Status;
                    mailMessage.Body = scriptText.Replace("<<lblleaveapplicationform>>", rm.GetString("email_LeaveApplicationForm", ci));
                    mailMessage.Body = mailMessage.Body.Replace("<<ltr_rtl>>", rm.GetString("Direction", ci));
                    mailMessage.Body = mailMessage.Body.Replace("<<lblemployeeid>>", rm.GetString("Field_EmployeeID", ci));
                    mailMessage.Body = mailMessage.Body.Replace("<<employeeid>>", EmployeeCodeId);
                    mailMessage.Body = mailMessage.Body.Replace("<<employeename>>", EmployeeName);
                    mailMessage.Body = mailMessage.Body.Replace("<<lblemployeename>>", rm.GetString("Field_EmployeeName", ci));
                    mailMessage.Body = mailMessage.Body.Replace("<<applicationdate>>", ApplicationDate);
                    mailMessage.Body = mailMessage.Body.Replace("<<lblapplicationdate>>", rm.GetString("email_LeaveApplicationDate", ci));
                    mailMessage.Body = mailMessage.Body.Replace("<<leavetype>>", LeaveType);
                    mailMessage.Body = mailMessage.Body.Replace("<<lblleavetype>>", rm.GetString("email_LeaveType", ci));
                    mailMessage.Body = mailMessage.Body.Replace("<<numberdaysapplied>>", Convert.ToString(LeaveNumberOfDaysApplied));
                    mailMessage.Body = mailMessage.Body.Replace("<<lblnumberdaysapplied>>", rm.GetString("email_NumberOfDaysApplied", ci));
                    mailMessage.Body = mailMessage.Body.Replace("<<lblleavedate>>", rm.GetString("email_LeaveDate", ci));
                    mailMessage.Body = mailMessage.Body.Replace("<<fromdate>>", FromDate);
                    mailMessage.Body = mailMessage.Body.Replace("<<lblfromdate>>", rm.GetString("Field_From", ci));
                    mailMessage.Body = mailMessage.Body.Replace("<<todate>>", ToDate);
                    mailMessage.Body = mailMessage.Body.Replace("<<lbltodate>>", rm.GetString("Field_To", ci));
                    mailMessage.Body = mailMessage.Body.Replace("<<lblsession>>", rm.GetString("email_Session", ci));
                    mailMessage.Body = mailMessage.Body.Replace("<<fromsession>>", LeaveFromSession);
                    mailMessage.Body = mailMessage.Body.Replace("<<lblfromsession>>", rm.GetString("lbl_FromSession", ci));
                    mailMessage.Body = mailMessage.Body.Replace("<<tosession>>", LeaveToSession);
                    mailMessage.Body = mailMessage.Body.Replace("<<lbltosession>>", rm.GetString("lbl_ToSession", ci));
                    mailMessage.Body = mailMessage.Body.Replace("<<reason>>", Reason);
                    mailMessage.Body = mailMessage.Body.Replace("<<lblreason>>", rm.GetString("email_Reason", ci));
                    if (Status == "Forwarded" || Status == "Pending")
                    {
                        mailMessage.Body = mailMessage.Body.Replace("<<LinkData>>", Convert.ToString(HttpContext.Current.Session["HostServerURL"]) + "?LeaveApplication_Id=" + Convert.ToString(LeaveApplicationID) + "&LevelId=" + LevelID + "&Status=" + Status + "&ApprovalType=Leave");
                    }
                    else
                    {
                        strReplaceText = "<a href=<<LinkData>>><font face=\"Arial\" size=\"2\">Click here for approval</font>";
                        mailMessage.Body = mailMessage.Body.Replace(strReplaceText, string.Empty);
                    }
                    SendMail(mailMessage);
                    return true;
                #endregion
                #region PermissionApplication
                case "PermissionApplication":
                    ScriptType = "New Permission Form";
                    dtTableScript = GetEmailScripts(ScriptType);
                    scriptText = dtTableScript.Rows[0]["ScriptText"].ToString();
                    mailMessage.Subject = "TimeCheck : " + levelName + " | " + EmployeeName + " " + EmployeeCodeId + " | Permission  | " + strPerStatus;
                    mailMessage.Body = scriptText.Replace("<<PermissionForm>>", rm.GetString("email_PermissionForm", ci));
                    mailMessage.Body = mailMessage.Body.Replace("<<EmployeeId>>", EmployeeCodeId);
                    mailMessage.Body = mailMessage.Body.Replace("<<lblEmployeeId>>", rm.GetString("Field_EmployeeID", ci));
                    mailMessage.Body = mailMessage.Body.Replace("<<lblEmployeeName>>", rm.GetString("Field_EmployeeName", ci));
                    mailMessage.Body = mailMessage.Body.Replace("<<EmployeeName>>", EmployeeName);
                    mailMessage.Body = mailMessage.Body.Replace("<<lblDepartment>>", "Department");
                    mailMessage.Body = mailMessage.Body.Replace("<<Department>>", levelName);
                    mailMessage.Body = mailMessage.Body.Replace("<<lblApplicationDate>>", "Application Date");
                    mailMessage.Body = mailMessage.Body.Replace("<<ApplicationDate>>", ApplicationDate);
                    mailMessage.Body = mailMessage.Body.Replace("<<lblPermissionDate>>", rm.GetString("PermissionSanction_PermissionDate", ci));
                    mailMessage.Body = mailMessage.Body.Replace("<<PermissionDate>>", PermissionDate);
                    mailMessage.Body = mailMessage.Body.Replace("<<lblNumberOfHoursApplied>>", rm.GetString("email_NumberOfHoursApplied", ci));
                    mailMessage.Body = mailMessage.Body.Replace("<<NumberOfHoursApplied>>", Convert.ToString(PerTotalHours));
                    mailMessage.Body = mailMessage.Body.Replace("<<lblPermission>>", rm.GetString("email_Permission", ci));
                    mailMessage.Body = mailMessage.Body.Replace("<<lblFromTime>>", rm.GetString("email_PermissionFromTime", ci));
                    mailMessage.Body = mailMessage.Body.Replace("<<FromTime>>", FromTime);
                    mailMessage.Body = mailMessage.Body.Replace("<<lblToTime>>", rm.GetString("email_PermissionToTime", ci));
                    mailMessage.Body = mailMessage.Body.Replace("<<ToTime>>", ToTime);
                    mailMessage.Body = mailMessage.Body.Replace("<<lblStatus>>", rm.GetString("Field_Status", ci));
                    mailMessage.Body = mailMessage.Body.Replace("<<Status>>", Status);
                    mailMessage.Body = mailMessage.Body.Replace("<<lblReason>>", rm.GetString("PermissionSanction_Reason", ci));
                    mailMessage.Body = mailMessage.Body.Replace("<<Reason>>", Reason);
                    if (Status == "Forwarded" || Status == "Pending")
                    {
                        if (payrollConfig == "1")
                        {
                            mailMessage.Body = mailMessage.Body.Replace("<<LinkData>>", Convert.ToString(HttpContext.Current.Session["HostServerURL"]) + "?Permission_Id=" + Permission_Id + "&LevelId=" + LevelID + "&ApprovalType=Permission&Status=" + Status + "&From_Date=&To_Date=strSwipeCardNo=&strEmployeeName=&strEmployeeCodeId=&Angler=1");
                        }
                        else
                        {
                            mailMessage.Body = mailMessage.Body.Replace("<<LinkData>>", Convert.ToString(HttpContext.Current.Session["HostServerURL"]) + "?Permission_Id=" + Permission_Id + "&LevelId=" + LevelID + "&ApprovalType=Permission&Status=" + Status + "&From_Date=&To_Date=strSwipeCardNo=&strEmployeeName=&strEmployeeCodeId=");
                        }
                    }
                    else
                    {
                        strReplaceText = "<a href=<<LinkData>>><font face=\"Arial\" size=\"2\">Click here for approval</font>";
                        mailMessage.Body = mailMessage.Body.Replace(strReplaceText, string.Empty);
                    }
                    SendMail(mailMessage);
                    return true;
                #endregion
                #region OndutyApplication
                case "OndutyApplication":
                    ScriptType = "Onduty Application From";
                    if (DesignationId != "0")
                    {
                        strPerStatus = Status + " - Modified";
                    }
                    dtTableScript = GetEmailScripts(ScriptType);
                    scriptText = dtTableScript.Rows[0]["ScriptText"].ToString();

                    if (TimeFormatMail == "HH:mm")
                    {
                        TimeFormatMail = "HH:mm";
                    }
                    else
                    {
                        TimeFormatMail = "hh:mm tt";
                    }
                    mailMessage.Subject = rm.GetString("email_OndutyApplicationForm", ci) + " - " + ApplicationDate + " | " + EmployeeCodeId + " - " + EmployeeName + " | " + levelName + " - " + strPerStatus;
                    mailMessage.Body = scriptText.Replace("<<lblOndutyForm>>", rm.GetString("email_OndutyApplicationForm", ci));
                    mailMessage.Body = mailMessage.Body.Replace("<<ltr_rtl>>", rm.GetString("Direction", ci));
                    mailMessage.Body = mailMessage.Body.Replace("<<lblEmployeeID>>", rm.GetString("Field_EmployeeID", ci));
                    mailMessage.Body = mailMessage.Body.Replace("<<EmployeeID>>", EmployeeCodeId);
                    mailMessage.Body = mailMessage.Body.Replace("<<lblEmployeeName>>", rm.GetString("Field_EmployeeName", ci));
                    mailMessage.Body = mailMessage.Body.Replace("<<EmployeeName>>", EmployeeName);
                    mailMessage.Body = mailMessage.Body.Replace("<<lbldepartment>>", "Department");
                    mailMessage.Body = mailMessage.Body.Replace("<<department>>", levelName);
                    mailMessage.Body = mailMessage.Body.Replace("<<lblApplicationDate>>", rm.GetString("ODEntry_ODEntryDate", ci));
                    mailMessage.Body = mailMessage.Body.Replace("<<ApplicationDate>>", ApplicationDate);
                    mailMessage.Body = mailMessage.Body.Replace("<<lblODDate>>", rm.GetString("OnDutyDate", ci));
                    mailMessage.Body = mailMessage.Body.Replace("<<lblFromDate>>", rm.GetString("Field_From", ci));
                    mailMessage.Body = mailMessage.Body.Replace("<<FromDate>>", FromDate + " " + Convert.ToDateTime(FromTime).ToString(TimeFormatMail));
                    mailMessage.Body = mailMessage.Body.Replace("<<lblToDate>>", rm.GetString("Field_To", ci));
                    mailMessage.Body = mailMessage.Body.Replace("<<ToDate>>", ToDate + " " + Convert.ToDateTime(ToTime).ToString(TimeFormatMail));
                    mailMessage.Body = mailMessage.Body.Replace("<<lblStatus>>", rm.GetString("Field_Status", ci));
                    mailMessage.Body = mailMessage.Body.Replace("<<Status>>", Status);
                    mailMessage.Body = mailMessage.Body.Replace("<<lblReason>>", rm.GetString("email_Reason", ci));
                    mailMessage.Body = mailMessage.Body.Replace("<<Reason>>", Reason);
                    if (Status == "Forwarded" || Status == "Pending")
                    {
                        mailMessage.Body = mailMessage.Body.Replace("<<LinkData>>", Convert.ToString(HttpContext.Current.Session["HostServerURL"]) + "?ODID=" + Convert.ToString(OnDutyID) + "&LevelId=" + LevelID + "&Status=" + Status + "&ApprovalType=Onduty&ParentID=" + Convert.ToString(HttpContext.Current.Session["parentLevelId"]) + "");
                    }
                    else
                    {
                        strReplaceText = "<font face=\"Arial\" size=\"2\"><a href=\"<<LinkData>>\">Click here for approval </a></font>";
                        mailMessage.Body = mailMessage.Body.Replace(strReplaceText, string.Empty);
                    }
                    SendMail(mailMessage);
                    return true;
                #endregion
                #region DeletePermission
                case "DeletePermission":
                    ScriptType = "Permission Delete Form";
                    dtTableScript = GetEmailScripts(ScriptType);
                    scriptText = dtTableScript.Rows[0]["ScriptText"].ToString();
                    mailMessage.Subject = rm.GetString("email_PermissionForm", ci) + " - " + PermissionDate + " | " + EmployeeCodeId + " - " + EmployeeName + " | " + levelName + " - " + Status;
                    mailMessage.Body = scriptText.Replace("<<PermissionForm>>", rm.GetString("email_PermissionForm", ci));
                    mailMessage.Body = mailMessage.Body.Replace("<<lblEmployeeId>>", rm.GetString("Field_EmployeeID", ci));
                    mailMessage.Body = mailMessage.Body.Replace("<<EmployeeId>>", EmployeeCodeId);
                    mailMessage.Body = mailMessage.Body.Replace("<<lblEmployeeName>>", rm.GetString("Field_EmployeeName", ci));
                    mailMessage.Body = mailMessage.Body.Replace("<<EmployeeName>>", EmployeeName);
                    mailMessage.Body = mailMessage.Body.Replace("<<lblPermissionDate>>", rm.GetString("PermissionSanction_PermissionDate", ci));
                    mailMessage.Body = mailMessage.Body.Replace("<<PermissionDate>>", PermissionDate);
                    mailMessage.Body = mailMessage.Body.Replace("<<lblNumberOfHoursApplied>>", rm.GetString("email_NumberOfHoursApplied", ci));
                    mailMessage.Body = mailMessage.Body.Replace("<<NumberOfHoursApplied>>", Convert.ToString(PerTotalHours));
                    mailMessage.Body = mailMessage.Body.Replace("<<lblPermission>>", rm.GetString("email_Permission", ci));
                    mailMessage.Body = mailMessage.Body.Replace("<<lblFromTime>>", rm.GetString("email_PermissionFromTime", ci));
                    mailMessage.Body = mailMessage.Body.Replace("<<FromTime>>", FromTime);
                    mailMessage.Body = mailMessage.Body.Replace("<<lblToTime>>", rm.GetString("email_PermissionToTime", ci));
                    mailMessage.Body = mailMessage.Body.Replace("<<ToTime>>", ToTime);
                    mailMessage.Body = mailMessage.Body.Replace("<<lblReason>>", rm.GetString("PermissionSanction_Reason", ci));
                    mailMessage.Body = mailMessage.Body.Replace("<<Reason>>", Reason);
                    strReplaceText = "<a href=<<LinkData>>>      <font face=\"Arial\" size=\"2\">Click here for approval</font></a>";
                    mailMessage.Body = mailMessage.Body.Replace(strReplaceText, string.Empty);
                    SendMail(mailMessage);
                    return true;
                #endregion
                #region LeaveSanction
                case "LeaveSanction":
                    ScriptType = "Leave Application Sanction By Reporting to Person";
                    dtTableScript = GetEmailScripts(ScriptType);
                    scriptText = dtTableScript.Rows[0]["ScriptText"].ToString();
                    mailMessage.Subject = rm.GetString("email_YourLeaveApplicationFor", ci) + " - " + FromDate + " | " + EmployeeCodeId + " - " + EmployeeName + " | " + Status;
                    mailMessage.Body = scriptText.Replace("<<lblLeaveApplicationForm>>", rm.GetString("email_LeaveApplicationForm", ci));
                    mailMessage.Body = mailMessage.Body.Replace("<<lblEmployeeId>>", rm.GetString("Field_EmployeeID", ci));
                    mailMessage.Body = mailMessage.Body.Replace("<<EmployeeId>>", EmployeeCodeId);
                    mailMessage.Body = mailMessage.Body.Replace("<<lblEmployeeName>>", rm.GetString("Field_EmployeeName", ci));
                    mailMessage.Body = mailMessage.Body.Replace("<<EmployeeName>>", EmployeeName);
                    mailMessage.Body = mailMessage.Body.Replace("<<lblApplicationDate>>", rm.GetString("email_LeaveApplicationDate", ci));
                    mailMessage.Body = mailMessage.Body.Replace("<<ApplicationDate>>", ApplicationDate);
                    mailMessage.Body = mailMessage.Body.Replace("<<lblLeaveType>>", rm.GetString("email_LeaveType", ci));
                    mailMessage.Body = mailMessage.Body.Replace("<<LeaveType>>", LeaveType);
                    mailMessage.Body = mailMessage.Body.Replace("<<lblLeaveDate>>", rm.GetString("email_LeaveDate", ci));
                    mailMessage.Body = mailMessage.Body.Replace("<<lblFromDate>>", rm.GetString("Field_From", ci));
                    mailMessage.Body = mailMessage.Body.Replace("<<FromDate>>", FromDate);
                    mailMessage.Body = mailMessage.Body.Replace("<<lblToDate>>", rm.GetString("Field_To", ci));
                    mailMessage.Body = mailMessage.Body.Replace("<<ToDate>>", ToDate);
                    mailMessage.Body = mailMessage.Body.Replace("<<lblSession>>", rm.GetString("email_Session", ci));
                    mailMessage.Body = mailMessage.Body.Replace("<<FromSession>>", LeaveFromSession);
                    mailMessage.Body = mailMessage.Body.Replace("<<lblFromSession>>", rm.GetString("email_FromSession", ci));
                    mailMessage.Body = mailMessage.Body.Replace("<<ToSession>>", LeaveToSession);
                    mailMessage.Body = mailMessage.Body.Replace("<<lblToSession>>", rm.GetString("email_ToSession", ci));
                    mailMessage.Body = mailMessage.Body.Replace("<<lblNumberDaysApplied>>", rm.GetString("email_NumberOfDaysApplied", ci));
                    mailMessage.Body = mailMessage.Body.Replace("<<NumberDaysApplied>>", LeaveNumberOfDaysApplied);
                    mailMessage.Body = mailMessage.Body.Replace("<<lblStatus>>", rm.GetString("Field_Status", ci));
                    mailMessage.Body = mailMessage.Body.Replace("<<Status>>", Status);
                    mailMessage.Body = mailMessage.Body.Replace("<<lblreason>>", rm.GetString("email_Reason", ci));
                    mailMessage.Body = mailMessage.Body.Replace("<<reason>>", Reason);
                    mailMessage.Body = mailMessage.Body.Replace("<<lblRemarks>>", rm.GetString("email_Remarks", ci));
                    mailMessage.Body = mailMessage.Body.Replace("<<Remarks>>", Remarks);
                    if (Status == "Forwarded")
                    {
                        mailMessage.Body = mailMessage.Body.Replace("<<LinkData>>", Convert.ToString(HttpContext.Current.Session["HostServerURL"]) + "?LeaveApplication_Id=" + Convert.ToString(LeaveApplicationID) + "&LevelId=" + LevelID + "&Status=" + Status + "&ApprovalType=Leave");
                    }
                    else
                    {
                        strReplaceText = "<font face=\"Arial\" size=\"2\"><a href=\"<<LinkData>>\">Click here for approval</a></font>";
                        mailMessage.Body = mailMessage.Body.Replace(strReplaceText, string.Empty);
                    }
                    SendMail(mailMessage);
                    return true;
                #endregion
                #region PermissionSanction
                case "PermissionSanction":
                    ScriptType = "Permission Application Sanction By Reporting to Person";
                    dtTableScript = GetEmailScripts(ScriptType);
                    scriptText = dtTableScript.Rows[0]["ScriptText"].ToString();
                    mailMessage.Subject = rm.GetString("email_YourPermissionApplicationFor", ci) + " - " + PermissionDate + " | " + EmployeeCodeId + " - " + EmployeeName + " | " + levelName + " - " + Status;
                    mailMessage.Body = scriptText.Replace("<<lblPermissionSanction>>", rm.GetString("email_PermissionForm", ci));
                    mailMessage.Body = mailMessage.Body.Replace("<<lblEmployeeId>>", rm.GetString("Field_EmployeeID", ci));
                    mailMessage.Body = mailMessage.Body.Replace("<<EmployeeId>>", EmployeeCodeId);
                    mailMessage.Body = mailMessage.Body.Replace("<<lblEmployeeName>>", rm.GetString("Field_EmployeeName", ci));
                    mailMessage.Body = mailMessage.Body.Replace("<<EmployeeName>>", EmployeeName);
                    mailMessage.Body = mailMessage.Body.Replace("<<lblPermissionDate>>", rm.GetString("PermissionSanction_PermissionDate", ci));
                    mailMessage.Body = mailMessage.Body.Replace("<<PermissionDate>>", PermissionDate);
                    mailMessage.Body = mailMessage.Body.Replace("<<lblNumberOfHoursApplied>>", rm.GetString("email_NumberOfHoursApplied", ci));
                    mailMessage.Body = mailMessage.Body.Replace("<<NumberOfHoursApplied>>", PerTotalHours);
                    mailMessage.Body = mailMessage.Body.Replace("<<lblPermission>>", rm.GetString("email_Permission", ci));
                    mailMessage.Body = mailMessage.Body.Replace("<<lblFromTime>>", rm.GetString("email_PermissionFromTime", ci));
                    mailMessage.Body = mailMessage.Body.Replace("<<FromTime>>", FromTime);
                    mailMessage.Body = mailMessage.Body.Replace("<<lblToTime>>", rm.GetString("email_PermissionToTime", ci));
                    mailMessage.Body = mailMessage.Body.Replace("<<ToTime>>", ToTime);
                    mailMessage.Body = mailMessage.Body.Replace("<<lblStatus>>", rm.GetString("Field_Status", ci));
                    mailMessage.Body = mailMessage.Body.Replace("<<Status>>", Status);
                    mailMessage.Body = mailMessage.Body.Replace("<<lblReason>>", rm.GetString("PermissionSanction_Reason", ci));
                    mailMessage.Body = mailMessage.Body.Replace("<<Reason>>", Reason);
                    mailMessage.Body = mailMessage.Body.Replace("<<lblRemarks>>", rm.GetString("PermissionSanction_Remarks", ci));
                    mailMessage.Body = mailMessage.Body.Replace("<<Remarks>>", Remarks);
                    if (Status == "Forwarded" || Status == "Pending")
                    {
                        mailMessage.Body = mailMessage.Body.Replace("<<LinkData>>", Convert.ToString(HttpContext.Current.Session["HostServerURL"]) + "?Permission_Id=" + Convert.ToString(Permission_Id) + "&LevelId=" + HttpContext.Current.Session["LevelId"] + "&Status=" + Status + "&ApprovalType=Permission");
                    }
                    else
                    {
                        strReplaceText = "<a href=<<LinkData>>><font face=\"Arial\" size=\"2\">Click here for approval</font>";
                        mailMessage.Body = mailMessage.Body.Replace(strReplaceText, string.Empty);
                    }
                    SendMail(mailMessage);
                    return true;
                #endregion
                #region OndutySanction
                case "OndutySanction":
                    ScriptType = "Onduty Application Modify";
                    dtTableScript = GetEmailScripts(ScriptType);
                    scriptText = dtTableScript.Rows[0]["ScriptText"].ToString();
                    if (TimeFormatMail == "HH:mm")
                    {
                        TimeFormatMail = "HH:mm";
                    }
                    else
                    {
                        TimeFormatMail = "hh:mm tt";
                    }
                    mailMessage.Subject = rm.GetString("email_YourOndutyApplicationFor", ci) + " - " + ApplicationDate + " | " + EmployeeCodeId + " - " + EmployeeName + " | " + levelName + " - " + Status;
                    mailMessage.Body = scriptText.Replace("<<lblOndutyForm>>", rm.GetString("email_OndutyApplicationForm", ci));
                    mailMessage.Body = mailMessage.Body.Replace("<<ltr_rtl>>", rm.GetString("Direction", ci));
                    mailMessage.Body = mailMessage.Body.Replace("<<lblEmployeeID>>", rm.GetString("Field_EmployeeID", ci));
                    mailMessage.Body = mailMessage.Body.Replace("<<EmployeeID>>", EmployeeCodeId);
                    mailMessage.Body = mailMessage.Body.Replace("<<lblEmployeeName>>", rm.GetString("Field_EmployeeName", ci));
                    mailMessage.Body = mailMessage.Body.Replace("<<EmployeeName>>", EmployeeName);
                    mailMessage.Body = mailMessage.Body.Replace("<<lblApplicationDate>>", rm.GetString("ManualTimeEntry_OnDutyEntryDate", ci));
                    mailMessage.Body = mailMessage.Body.Replace("<<ApplicationDate>>", ApplicationDate);
                    mailMessage.Body = mailMessage.Body.Replace("<<lblODDate>>", rm.GetString("OnDutyDate", ci));
                    mailMessage.Body = mailMessage.Body.Replace("<<lblFromDate>>", rm.GetString("email_PermissionFromTime", ci));
                    mailMessage.Body = mailMessage.Body.Replace("<<FromDate>>", FromDate + " " + Convert.ToDateTime(FromTime).ToString(TimeFormatMail));
                    mailMessage.Body = mailMessage.Body.Replace("<<lblToDate>>", rm.GetString("email_PermissionToTime", ci));
                    mailMessage.Body = mailMessage.Body.Replace("<<ToDate>>", ToDate + " " + Convert.ToDateTime(ToTime).ToString(TimeFormatMail));
                    mailMessage.Body = mailMessage.Body.Replace("<<lblStatus>>", rm.GetString("Field_Status", ci));
                    mailMessage.Body = mailMessage.Body.Replace("<<Status>>", Status);
                    mailMessage.Body = mailMessage.Body.Replace("<<lblReason>>", rm.GetString("PermissionSanction_Reason", ci));
                    mailMessage.Body = mailMessage.Body.Replace("<<Reason>>", Reason);
                    mailMessage.Body = mailMessage.Body.Replace("<<lblRemarks>>", rm.GetString("PermissionSanction_Remarks", ci));
                    mailMessage.Body = mailMessage.Body.Replace("<<Remarks>>", Remarks);
                    if (Status == "Forwarded" || Status == "Pending")
                    {
                        mailMessage.Body = mailMessage.Body.Replace("<<LinkData>>", Convert.ToString(HttpContext.Current.Session["HostServerURL"]) + "?ODID=" + Convert.ToString(OnDutyID) + "&LevelId=" + LevelID + "&Status=" + Status + "&ApprovalType=Onduty&ParentID=" + Convert.ToString(HttpContext.Current.Session["parentLevelId"]) + "");
                    }
                    else
                    {
                        strReplaceText = "<font face=\"Arial\" size=\"2\"><a href=\"<<LinkData>>\">Click here for approval </a></font>";
                        mailMessage.Body = mailMessage.Body.Replace(strReplaceText, string.Empty);
                    }
                    SendMail(mailMessage);
                    return true;
                    #endregion
            }
            #endregion
        }
        catch (Exception ex)
        {
            return false;
            throw;
        }
        return true;
    }
    public void SendMail(MailMessage mailMessage)
    {
        try
        {
            string strSMTPPort = ConfigurationManager.AppSettings.Get("SMTPPort");
            SmtpClient loSMTPServer = new SmtpClient(strSMTPPort, Convert.ToInt32(strSMTPPort));
            loSMTPServer.Host = ConfigurationManager.AppSettings.Get("SMTPClientHost");
            string strHost = ConfigurationManager.AppSettings.Get("SMTPClientHost");
            string strSSLEnable = ConfigurationManager.AppSettings.Get("SSLEnable");
            string strMailAuthentication = ConfigurationManager.AppSettings.Get("MailAuthentication");
            string strMailAuthenticateUser = ConfigurationManager.AppSettings.Get("MailAuthenticateUser");
            string strMailAuthenticatePassword = ConfigurationManager.AppSettings.Get("MailAuthenticatePassword");
            if (strMailAuthentication == "1")
                strMailAuthenticatePassword = Cryptographys.Cryptography.Decrypt(strMailAuthenticatePassword, "TimecheckPhaseI");
            loSMTPServer.Port = Convert.ToInt32(strSMTPPort);
            if (strSSLEnable == "1")
                loSMTPServer.EnableSsl = true;
            else
                loSMTPServer.EnableSsl = false;
            if (strMailAuthentication == "0")
                loSMTPServer.UseDefaultCredentials = true;
            else
                loSMTPServer.UseDefaultCredentials = false;
            mailMessage.IsBodyHtml = true;
            if (strMailAuthentication == "1")
            {
                System.Net.ServicePointManager.ServerCertificateValidationCallback = delegate (object s,
             System.Security.Cryptography.X509Certificates.X509Certificate certificate,
             System.Security.Cryptography.X509Certificates.X509Chain chain,
             System.Net.Security.SslPolicyErrors sslPolicyErrors)
                {
                    return true;
                };
                loSMTPServer.Credentials = new System.Net.NetworkCredential(strMailAuthenticateUser, strMailAuthenticatePassword);
                loSMTPServer.Send(mailMessage);
            }
            else
            {
                loSMTPServer.DeliveryMethod = SmtpDeliveryMethod.Network;
                loSMTPServer.Send(mailMessage);
            }
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
    public string VerifylicenseDetails(string path, string searchPattern)
    {
        string decryptedLicFileInfo = string.Empty;
        try
        {
            string[] fileArr = Directory.GetFiles(path, searchPattern);
            if (fileArr.Length > 0)
            {
                string licenseFileName = fileArr[fileArr.Length - 1].ToString();
                FileStream licenseFileStream = new FileStream(licenseFileName, FileMode.Open);
                StreamReader licenseFileStreamReader = new StreamReader(licenseFileStream);
                string encryptedLicFileInfo = licenseFileStreamReader.ReadToEnd();
                licenseFileStreamReader.Close();
                licenseFileStream.Close();
                decryptedLicFileInfo = Encryption.Decrypt(encryptedLicFileInfo, "");
            }
        }
        catch
        {
            decryptedLicFileInfo = "Error";
        }
        return decryptedLicFileInfo;
    }
    public bool VerifyDevMachine(string macaddress)
    {
        if (Convert.ToString(macaddress) == "00224DB1924C" ||
            Convert.ToString(macaddress) == "00090FFE0001" ||
            Convert.ToString(macaddress) == "1A1534E775C4" ||
            Convert.ToString(macaddress) == "00155DDF4239")
            return true;
        else
            return false;
    }

    public void PrepareMailContentAndSendEmailForForgotPassword(string ToEmailId, string Password, string strEmployeename, string StrEmployeecode, string dateFormat)
    {
        string frommailID = string.Empty;
        if (Convert.ToString(ConfigurationManager.AppSettings.Get("FromId")) != null)
            if (Convert.ToString(ConfigurationManager.AppSettings.Get("FromId")) != "")
                frommailID = Convert.ToString(ConfigurationManager.AppSettings.Get("FromId"));
        if (frommailID != "" && ToEmailId != "")
        {
            string CurrentDate = string.Empty;
            string EmailContent;
            MailMessage mailMessage = new MailMessage();
            CurrentDate = DateTime.Now.ToString(dateFormat);
            mailMessage.To.Add(new MailAddress(ToEmailId));
            mailMessage.From = new MailAddress(ConfigurationManager.AppSettings.Get("FromId"));
            mailMessage.Subject = "Temporary Password for Timecheck Application - " + CurrentDate + " | " + StrEmployeecode + " - " + strEmployeename;
            EmailContent = "<b> Dear " + strEmployeename + ",</b> <br /><br />Your Temporary Password is : " + Password + "<br /><br /><b>Regards</b><br /> TimeCheck Administrator <br /> ";
            mailMessage.Body = EmailContent;
            SendMail(mailMessage);
        }
    }
}
