using System;
using System.Collections;
using System.Data;
using Microsoft.Practices.EnterpriseLibrary.Data;
using DataAccessLayer;
public class FlexiEventData
{
    DataAccess objDataAccess = new DataAccess();
    Hashtable htable = new Hashtable();
    public DataSet SelectEmployees(string FromDate, string ToDate, string EmpId, string EmpName, string Level, int EmpCategory, int EmpType, int iFlexi, string UserGroupName, int ParentId, int isFlexible,int EmpAutoID)
    {
        DataSet ds = new DataSet();
        try
        {
            htable.Clear();
            htable.Add("@fromDat", FromDate);
            htable.Add("@ToDat", ToDate);
            htable.Add("@EmployeeId", EmpId);
            htable.Add("@EmployeeName", EmpName);
            htable.Add("@LevelID", Level);
            htable.Add("@EmployeeCategory", EmpCategory);
            htable.Add("@EmployeeType", EmpType);
            htable.Add("@Flexi", iFlexi);
            htable.Add("@UserGroupName", UserGroupName);
            htable.Add("@ParentId", ParentId);
            htable.Add("@isFlexible", isFlexible);
            htable.Add("@EmpAutoID", EmpAutoID);
            ds = objDataAccess.GetStoredProcCommand("Proc_Ta_SelectEmployeeFlexi", htable);
        }
        catch (Exception ex)
        {
            throw ex;
        }
        return ds;
    }
    public void UpdateFlexi(int iEmployeeID, int iFlexi)
    {
        try
        {
            htable.Clear();
            htable.Add("@EmployeeID", iEmployeeID);
            htable.Add("@Flexi", iFlexi);
            objDataAccess.GetStoredProcCommand(htable, "Proc_TA_UpdateEmployeeFlexi");
        }
        catch (Exception ex)
        {
            throw ex;
        }
    }
    public void UpdateFlexi_All(int iFlexi, string EmployeeData)
    {
        try
        {
            htable.Clear();
            htable.Add("@Flexi", iFlexi);
            htable.Add("@xml", EmployeeData);
            objDataAccess.GetStoredProcCommand(htable, "Proc_TA_UpdateEmployeeFlexi_All");
        }
        catch (Exception ex)
        {
            throw ex;
        }
    }
}
