using System;
using System.Collections;
using System.Data;
using Microsoft.Practices.EnterpriseLibrary.Data;
using DataAccessLayer;
public class ResetPwd
{
    DataAccess objDataAccess = new DataAccess();
    Hashtable htable = new Hashtable();
    public void Delete_EmployeeDetails()
    {
        try
        {
            objDataAccess.ExecuteNonQuery("Proc_TA_DeleteTempShiftAllocation");
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
    public string GetEmployeeCode()
    {
        DataSet ds_EmpCode = new DataSet();
        string EmployeeCode = string.Empty;
        try
        {
            ds_EmpCode = objDataAccess.ExecuteDataSet("Proc_Ta_GetEmployeeDetailFromTempShiftAllocation");
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        if (ds_EmpCode.Tables[0].Rows.Count > 0)
        {
            EmployeeCode = Convert.ToString(ds_EmpCode.Tables[0].Rows[0][0]);
        }
        return EmployeeCode;
    }
    public int ResetPassword(string EmpId, string Password)
    {
        int Count = 0;
        try
        {
            htable.Clear();
            htable.Add("@EmpId", EmpId);
            htable.Add("@Password", Password);
            Count = (int)objDataAccess.ExecuteScaler("Proc_TA_ResetPassword", htable);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return Count;
    }
    public DataSet DatabaseInformation()
    {
        DataSet ds_ResetPassword = new DataSet();
        try
        {
            ds_ResetPassword = objDataAccess.ExecuteDataSet("Proc_TA_SelectVersion");
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_ResetPassword;
    }
}