using System;
using System.ComponentModel;
using System.Data;
using System.Data.Common;
using Microsoft.Practices.EnterpriseLibrary.Data;
/// <summary>
/// Summary description for NonProcessed
/// </summary>
public class NonProcessed
{
    Database DBCon = DatabaseFactory.CreateDatabase("DBConnection");
    DataSet ds_NonProcessed = new DataSet();
    public NonProcessed()
    {
        string strDecryptedString = string.Empty;
        strDecryptedString = Cryptographys.Cryptography.GetDecryptedConnectionString();
        if (strDecryptedString == string.Empty)
        {
        }
        else
        {
            ResetDatabaseConnection(strDecryptedString);
        }
    }
    public void ResetDatabaseConnection(string strDecryptedString)
    {
        DbProviderFactory objData = DBCon.DbProviderFactory;
        DBCon = new Microsoft.Practices.EnterpriseLibrary.Data.Sql.SqlDatabase(strDecryptedString);
    }
    [DataObjectMethod(DataObjectMethodType.Select, true)]
    public DataSet SelectNonProcessedData(string FromDate)
    {
        try
        {
            ds_NonProcessed = DBCon.ExecuteDataSet("Proc_Ta_NonProcessedDataDetails", new object[] { FromDate });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_NonProcessed;
    }
}
