namespace Cryptographys
{
    using System;
    using System.Configuration;
    using System.IO;
    using System.Security.Cryptography;
    using System.Text;
    public class Cryptography
    {
        /// <summary>
        /// Decrypting the particular string with a specific Key
        /// </summary>
        /// <returns></returns>
        public static string GetDecryptedConnectionString()
        {
            string strEncryptedString = ConfigurationManager.ConnectionStrings["DBConnection"].ToString();
            string strDecryptedString = Cryptographys.Cryptography.Decrypt(strEncryptedString, "TimecheckPhaseI");
            // strDecryptedString = @"Data Source=ANGLER97;Initial Catalog=TimeCheckV2.7;User ID=sa;Pwd=angler123;";
            strDecryptedString = @"Data Source=ANGLER97\SQL2019;Initial Catalog=Timecheck_OHI;User ID=sa;Pwd=angler123;";
            return strDecryptedString;
        }
        /// <summary>
        ///    Decrypts  a particular string with a specific Key
        /// </summary>
        public static string Decrypt(string stringToDecrypt, string sEncryptionKey)
        {

            byte[] key = { };
            byte[] IV = { 10, 20, 30, 40, 50, 60, 70, 80 };
            byte[] inputByteArray = new byte[stringToDecrypt.Length];
            try
            {
                key = Encoding.UTF8.GetBytes(sEncryptionKey.Substring(0, 8));
                DESCryptoServiceProvider des = new DESCryptoServiceProvider();
                // + Symbol should be treated as empty string while encrypting.Due to this, we are getting some issues while decrypting the string.
                //To avoid the issue, we replaced the empty string + sign before decrypting.
                stringToDecrypt = stringToDecrypt.Replace(" ", "+");
                inputByteArray = Convert.FromBase64String(stringToDecrypt);
                MemoryStream ms = new MemoryStream();
                CryptoStream cs = new CryptoStream(ms, des.CreateDecryptor(key, IV), CryptoStreamMode.Write);
                cs.Write(inputByteArray, 0, inputByteArray.Length);
                cs.FlushFinalBlock();
                Encoding encoding = Encoding.UTF8;
                return encoding.GetString(ms.ToArray());
            }
            catch (System.Exception ex)
            {
                return (string.Empty);
            }
        }
        /// <summary>
        ///   Encrypts  a particular string with a specific Key
        /// </summary>
        /// <param name="stringToEncrypt"></param>
        /// <param name="sEncryptionKey"></param>
        /// <returns></returns>
        public static string Encrypt(string stringToEncrypt, string sEncryptionKey)
        {
            byte[] key = { };
            byte[] IV = { 10, 20, 30, 40, 50, 60, 70, 80 };
            byte[] inputByteArray; //Convert.ToByte(stringToEncrypt.Length) 
            try
            {
                key = Encoding.UTF8.GetBytes(sEncryptionKey.Substring(0, 8));
                DESCryptoServiceProvider des = new DESCryptoServiceProvider();
                inputByteArray = Encoding.UTF8.GetBytes(stringToEncrypt);
                MemoryStream ms = new MemoryStream();
                CryptoStream cs = new CryptoStream(ms, des.CreateEncryptor(key, IV), CryptoStreamMode.Write);
                cs.Write(inputByteArray, 0, inputByteArray.Length);
                cs.FlushFinalBlock();
                return Convert.ToBase64String(ms.ToArray());
            }
            catch (System.Exception ex)
            {
                return (string.Empty);
            }
        }
    }
}
