﻿<%@ Page Title="" Language="C#" MasterPageFile="~/MasterFile/TimeCheck.master" AutoEventWireup="true" CodeFile="TA_UI_Master_DashboardRights.aspx.cs" Inherits="Masters_TA_UI_Master_DashboardRights" %>

<%@ Register TagPrefix="dxGridview" Namespace="DevExpress.Web" Assembly="DevExpress.Web.v14.2" %>
<asp:Content ID="Content1" ContentPlaceHolderID="BodyContentPH" runat="Server">
    <!--[if gt IE 5.5]>
	<link rel="stylesheet" type="text/css" href="../css/anytimeIE.css" />
	<link rel="stylesheet" type="text/css" href="../css/ProgressforIE.css" />
 <![endif]-->
    <div class="content-header">
        <h1>
            <asp:Label ID="lbl_HeaderUserGroups" runat="server"></asp:Label>
        </h1>
        <asp:SiteMapPath ID="site" runat="server" CssClass="breadcrumb">
            <NodeStyle CssClass="active" />
        </asp:SiteMapPath>
    </div>
    <div class="content">
        <div class="inr-ftr">
            <div class="row">
                <div class="col-sm-12" style="height: 33px; padding: 7px 36px 0 36px; font-size: 15px">
                    <span>
                        <asp:Label ID="lblDashboardRights" runat="server"></asp:Label></span>
                </div>
            </div>
        </div>
        <div class="emp-filter">
            <div class="row">
                <div class="form-horizontal">
                    <div class="col-md-12">
                        <div class="row form-group">
                            <div class="col-sm-2">
                                <asp:Label ID="lbl_UserGroup" runat="server"></asp:Label>
                            </div>
                            <div class="col-sm-3">
                                <asp:Label ID="lblGroupName" runat="server"></asp:Label>
                            </div>
                            <div class="clearfix">
                            </div>
                        </div>
                    </div>
                    <div id="divDash" runat="server" visible="false">
                        <div class="col-md-12">
                            <div class="row form-group">
                                <div class="col-md-2">
                                    <asp:Label ID="lblAttendanceBoard" runat="server"></asp:Label>
                                </div>
                                <div class="col-md-3">
                                    <div style="border: 1px solid #C9E1FC; padding: 10px 10px 0 10px; overflow: auto; height: 180px">
                                        <asp:CheckBox ID="cbAttendanceAll" runat="server" onclick="CheckAll('chklstAttendance','cbAttendanceAll');" Font-Size="12px"
                                            Font-Bold="true" Font-Names="tahoma" CssClass="checkbox checkbox-primary" />
                                        <asp:CheckBoxList ID="chklstAttendance" runat="server" RepeatDirection="vertical" CssClass="checkbox checkbox-primary"
                                            onclick="UnCheckAll('chklstAttendance','cbAttendanceAll');" Font-Names="tahoma" Font-Size="12px">
                                        </asp:CheckBoxList>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="col-md-12">
                            <div class="row form-group">
                                <div class="col-md-2">
                                    <asp:Label ID="lblApprovalBoard" runat="server"></asp:Label>
                                </div>
                                <div class="col-md-3">
                                    <div style="border: 1px solid #C9E1FC; padding: 10px 10px 0 10px; overflow: auto; height: 112px">
                                        <asp:CheckBox ID="cbApprovalAll" runat="server" onclick="CheckAll('chklstApproval','cbApprovalAll');" Font-Size="12px"
                                            Font-Bold="true" Font-Names="tahoma" CssClass="checkbox checkbox-primary" />
                                        <asp:CheckBoxList ID="chklstApproval" runat="server" RepeatDirection="vertical"
                                            onclick="UnCheckAll('chklstApproval','cbApprovalAll');" CssClass="checkbox checkbox-primary"
                                            Font-Names="tahoma" Font-Size="12px">
                                        </asp:CheckBoxList>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="col-md-12">
                            <div class="row form-group">
                                <div class="col-md-2">
                                    <asp:Label ID="lblExceptionData" runat="server"></asp:Label>
                                </div>
                                <div class="col-md-3">
                                    <div style="border: 1px solid #C9E1FC; padding: 10px 10px 0 10px; overflow: auto; height: 180px">
                                        <asp:CheckBox ID="cbExcepAll" runat="server" onclick="CheckAll('chklstException','cbExcepAll');" Font-Size="12px"
                                            Font-Bold="true" Font-Names="tahoma" CssClass="checkbox checkbox-primary" />
                                        <asp:CheckBoxList ID="chklstException" runat="server" RepeatDirection="vertical" CssClass="checkbox checkbox-primary"
                                            onclick="UnCheckAll('chklstException','cbExcepAll');" Font-Names="tahoma" Font-Size="12px">
                                        </asp:CheckBoxList>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="col-md-12">
                            <div class="row form-group">
                                <div class="col-md-2">
                                    <asp:Label ID="lblDisplay" runat="server"></asp:Label>
                                </div>
                                <div class="col-md-10 pad-left-0px">
                                    <div class="col-md-2">
                                        <asp:CheckBox ID="chkbxDash" runat="server" CssClass="checkbox checkbox-primary" />
                                    </div>
                                    <div class="col-md-2">
                                        <asp:CheckBox ID="chkbxGrid" runat="server" CssClass="checkbox checkbox-primary" />
                                    </div>
                                    <div class="col-md-2">
                                        <asp:CheckBox ID="chkbxChart" runat="server" CssClass="checkbox checkbox-primary" />
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="row">
                            <div class="col-md-5">
                                <div class="pull-right-button">
                                    <asp:LinkButton ID="btn_save" CssClass="btn save-btn fa-floppy-o" runat="server" OnClick="btn_save_Click"
                                        OnClientClick="javascript:if(Validation()) return true; else return false;" />
                                    <asp:LinkButton ID="btn_cancel" CssClass="btn save-btn fa-angle-left" runat="server"
                                        CausesValidation="False" OnClick="btn_cancel_Click" Style="margin-left: 0px" />
                                </div>
                            </div>
                        </div>
                    </div>
                    <div id="divAssign" runat="server" visible="false">
                        <div class="row form-group">
                            <div class="col-md-12">
                                <span style="color: red">
                                    <asp:Label runat="server" ID="lblNote" Style="color: red"></asp:Label>
                                </span>
                                <br />
                            </div>
                            <div class="col-md-12">
                                <asp:HiddenField ID="hdnSelectRow" runat="server" />
                                <asp:HiddenField ID="hdnGetAllid" runat="server" />
                                <dxGridview:ASPxGridView ID="grv_EmpDetails" EnableCallBacks="false" runat="server"
                                    ClientInstanceName="grv_EmpDetails"
                                    AutoGenerateColumns="false" Width="100%" KeyFieldName="Employee_Id">
                                    <Columns>
                                        <dxGridview:GridViewDataColumn VisibleIndex="0" HeaderStyle-VerticalAlign="Middle"
                                            Width="30px" HeaderStyle-HorizontalAlign="Center" CellStyle-VerticalAlign="Middle"
                                            CellStyle-HorizontalAlign="Center">
                                            <Settings AllowAutoFilter="false" />
                                            <HeaderTemplate>
                                                <input id="chkSelectAll" runat="server" type="checkbox" onclick="SelectAllOnThisPage(this)" />
                                            </HeaderTemplate>
                                            <DataItemTemplate>
                                                <input id="chkSelect" runat="server" type="checkbox" onclick="SelectOnRow(this)"
                                                    accesskey='<%# Eval("Employee_Id") %>' />
                                            </DataItemTemplate>
                                            <HeaderStyle HorizontalAlign="center" Wrap="true" />
                                        </dxGridview:GridViewDataColumn>
                                        <dxGridview:GridViewDataTextColumn FieldName="Employee_Code_Id" VisibleIndex="1"
                                            Width="50px">
                                            <Settings AllowGroup="false" />
                                            <DataItemTemplate>
                                                <asp:Label ID="lblEmpCode" Text='<%# Eval("Employee_Code_Id") %>' runat="server"
                                                    Style="overflow-y: auto; overflow-x: auto; word-break: break-all; word-wrap: break-word; display: inline-block;"></asp:Label>
                                            </DataItemTemplate>
                                            <HeaderStyle HorizontalAlign="center" Wrap="true" />
                                        </dxGridview:GridViewDataTextColumn>
                                        <dxGridview:GridViewDataTextColumn Caption="Employee Name" FieldName="Name"
                                            VisibleIndex="2" Width="200px">
                                            <Settings AllowDragDrop="false" />
                                            <DataItemTemplate>
                                                <asp:Label ID="lblEname" Text='<%# Eval("Name") %>' runat="server"
                                                    Style="overflow-y: auto; overflow-x: auto; word-break: break-all; word-wrap: break-word; display: inline-block;"></asp:Label>
                                            </DataItemTemplate>
                                            <HeaderStyle HorizontalAlign="center" Wrap="true" />
                                        </dxGridview:GridViewDataTextColumn>
                                        <%--<dxGridview:GridViewDataTextColumn Caption="Designation" FieldName="designation"
                                            VisibleIndex="2" Width="200px">
                                            <Settings AllowDragDrop="false" />
                                            <DataItemTemplate>
                                                <asp:Label ID="lblEname" Text='<%# Eval("designation") %>' runat="server"
                                                    Style="overflow-y: auto; overflow-x: auto; word-break: break-all; word-wrap: break-word; display: inline-block;"></asp:Label>
                                            </DataItemTemplate>
                                            <HeaderStyle HorizontalAlign="center" Wrap="true" />
                                        </dxGridview:GridViewDataTextColumn>--%>
                                        <dxGridview:GridViewDataTextColumn FieldName="Status" VisibleIndex="2" Width="100px">
                                            <DataItemTemplate>
                                                <asp:Label ID="lblStatus" runat="server" Text='<%# Bind("Status") %>'></asp:Label>
                                            </DataItemTemplate>
                                            <HeaderStyle HorizontalAlign="center" Wrap="true" />
                                        </dxGridview:GridViewDataTextColumn>
                                    </Columns>
                                    <SettingsText EmptyDataRow="No Records Found" />
                                    <SettingsPager PageSize="10">
                                    </SettingsPager>
                                    <Settings GridLines="Both" />
                                    <Settings ShowFilterRow="true" />
                                    <SettingsBehavior SortMode="Value" AllowSort="true" AllowDragDrop="false" />
                                    <Styles AlternatingRow-CssClass="table-bg">
                                    </Styles>
                                </dxGridview:ASPxGridView>
                            </div>
                        </div>
                        <div class="row form-group">
                            <div class="col-md-12">
                                <div class="pull-right-button">
                                    <asp:LinkButton ID="lnkbtnRemove" CssClass="btn del-btn fa-trash-o" runat="server"
                                        CausesValidation="False" OnClick="lnkbtnRemove_Click" Style="margin-left: 0px" />
                                    <asp:LinkButton ID="lnkbtnback" CssClass="btn save-btn fa-angle-left" runat="server"
                                        CausesValidation="False" OnClick="btn_cancel_Click" Style="margin-left: 0px" />
                                </div>
                            </div>
                        </div>
                    </div>
                    <div id="divUnAssign" runat="server" visible="false">
                        <div class="row form-group">
                            <div class="col-md-12">
                                <asp:Label runat="server" ID="lblNotes1" Style="color: red"></asp:Label>
                            </div>
                            <div class="col-md-12">
                                <asp:HiddenField ID="hdnSelectRowAdd" runat="server" />
                                <asp:HiddenField ID="hdnGetAllidAdd" runat="server" />
                                <dxGridview:ASPxGridView ID="grdviewAllEmployees" EnableCallBacks="false" runat="server"
                                    ClientInstanceName="grdviewAllEmployees"
                                    AutoGenerateColumns="false" Width="100%" KeyFieldName="Employee_Id">
                                    <Columns>
                                        <dxGridview:GridViewDataColumn VisibleIndex="0" HeaderStyle-VerticalAlign="Middle"
                                            Width="30px" HeaderStyle-HorizontalAlign="Center" CellStyle-VerticalAlign="Middle"
                                            CellStyle-HorizontalAlign="Center">
                                            <Settings AllowAutoFilter="false" />
                                            <HeaderTemplate>
                                                <input id="chkSelectAll" runat="server" type="checkbox" onclick="SelectAll(this)" />
                                            </HeaderTemplate>
                                            <DataItemTemplate>
                                                <input id="chkSelect" runat="server" type="checkbox" onclick="SelectParticular(this)"
                                                    accesskey='<%# Eval("Employee_Id") %>' />
                                            </DataItemTemplate>
                                            <HeaderStyle HorizontalAlign="center" Wrap="true" />
                                        </dxGridview:GridViewDataColumn>
                                        <dxGridview:GridViewDataTextColumn FieldName="Employee_Code_Id" VisibleIndex="1"
                                            Width="50px">
                                            <Settings AllowGroup="false" />
                                            <DataItemTemplate>
                                                <asp:Label ID="lblEmpCode" Text='<%# Eval("Employee_Code_Id") %>' runat="server"
                                                    Style="overflow-y: auto; overflow-x: auto; word-break: break-all; word-wrap: break-word; display: inline-block;"></asp:Label>
                                            </DataItemTemplate>
                                            <HeaderStyle HorizontalAlign="center" Wrap="true" />
                                        </dxGridview:GridViewDataTextColumn>
                                        <dxGridview:GridViewDataTextColumn Caption="Employee Name" FieldName="Name"
                                            VisibleIndex="2" Width="200px">
                                            <Settings AllowDragDrop="false" />
                                            <DataItemTemplate>
                                                <asp:Label ID="lblEname" Text='<%# Eval("Name") %>' runat="server"
                                                    Style="overflow-y: auto; overflow-x: auto; word-break: break-all; word-wrap: break-word; display: inline-block;"></asp:Label>
                                            </DataItemTemplate>
                                            <HeaderStyle HorizontalAlign="center" Wrap="true" />
                                        </dxGridview:GridViewDataTextColumn>
                                        <dxGridview:GridViewDataTextColumn FieldName="groupname" VisibleIndex="2" Width="100px">
                                            <DataItemTemplate>
                                                <asp:Label ID="lblgroupname" runat="server" Text='<%# Bind("groupname") %>'></asp:Label>
                                            </DataItemTemplate>
                                            <HeaderStyle HorizontalAlign="center" Wrap="true" />
                                        </dxGridview:GridViewDataTextColumn>
                                        <dxGridview:GridViewDataTextColumn FieldName="Status" VisibleIndex="3" Width="100px">
                                            <DataItemTemplate>
                                                <asp:Label ID="lblStatus" runat="server" Text='<%# Bind("Status") %>'></asp:Label>
                                            </DataItemTemplate>
                                            <HeaderStyle HorizontalAlign="center" Wrap="true" />
                                        </dxGridview:GridViewDataTextColumn>
                                    </Columns>
                                    <SettingsText EmptyDataRow="No Records Found" />
                                    <SettingsPager PageSize="10">
                                    </SettingsPager>
                                    <Settings GridLines="Both" />
                                    <Settings ShowFilterRow="true" />
                                    <SettingsBehavior SortMode="Value" AllowSort="true" AllowDragDrop="false" />
                                    <Styles AlternatingRow-CssClass="table-bg">
                                    </Styles>
                                </dxGridview:ASPxGridView>
                            </div>
                        </div>
                        <div class="row form-group">
                            <div class="col-md-12">
                                <div class="pull-right-button">
                                    <asp:LinkButton ID="lnkbtnAdd" CssClass="btn add-btn fa-plus" runat="server"
                                        CausesValidation="False" OnClick="lnkbtnAdd_Click" Style="margin-left: 0px" />
                                    <asp:LinkButton ID="lnkbtnBack1" CssClass="btn save-btn fa-angle-left" runat="server"
                                        CausesValidation="False" OnClick="btn_cancel_Click" Style="margin-left: 0px" />
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
    <script type="text/javascript">
        var Alert_Save = "Are you sure to save";
        var Selectanyonedisplayoption = "Select any one display option,Data item(s) and then click save button";
        function SetAlertMessages(alert_save, selectanyonedisplayoption) {
            Alert_Save = Alert_save;
            Selectanyonedisplayoption = selectanyonedisplayoption;
        }
        function Validation() {

            if (document.getElementById("ctl00_BodyContentPH_chkbxDash").checked == false && document.getElementById("ctl00_BodyContentPH_chkbxGrid").checked == false && document.getElementById("ctl00_BodyContentPH_chkbxChart").checked == false) {
                alert(Selectanyonedisplayoption);
                return false;
            }
            return confirm(Alert_Save);
        }


        // Handle tree view click
        function HandleCheckbox(event) {
            var element = event.srcElement || event.target;
            if (element.tagName == "INPUT" && element.type == "checkbox") {
                var checkedState = element.checked;
                while (element.tagName != "TABLE") // Get wrapping table
                {
                    //element = element.parentElement;
                    element = element.parentNode;
                }

                UnCheckParents(element); // Uncheck all parents

                element = element.nextSibling;

                if (element == null) // If no childrens than exit
                    return;

                var childTables = element.getElementsByTagName("TABLE");

                for (var tableIndex = 0; tableIndex < childTables.length; tableIndex++) {
                    CheckTable(childTables[tableIndex], checkedState);
                }
            }
        }
        function postBackByObject() {
            var o = window.event.srcElement;
            if (o.tagName == "INPUT" && o.type == "checkbox") {
                __doPostBack("", "");
            }
        }
        function UnCheckParents(table) {
            if (table == null || table.rows[0].cells.length == 2) // This is the root
            {
                return;
            }
            var parentTable = table.parentNode.previousSibling;
            UnCheckParents(parentTable);
        }
        function CheckTable(table, checked) {
            var checkboxIndex = table.rows[0].cells.length - 1;
            var cell = table.rows[0].cells[checkboxIndex];
            var checkboxes = cell.getElementsByTagName("INPUT");
            if (checkboxes.length == 1) {
                checkboxes[0].checked = checked;
            }
        }
        function CheckAll(controlID, cbAttendanceAll) {
            var intIndex = 0;
            var rowCount = document.getElementById('ctl00_BodyContentPH_' + controlID).getElementsByTagName("input").length;
            for (i = 0; i < rowCount; i++) {
                if (document.getElementById('ctl00_BodyContentPH_' + cbAttendanceAll).checked == true) {
                    if (document.getElementById('ctl00_BodyContentPH_' + controlID + "_" + i)) {
                        if (document.getElementById('ctl00_BodyContentPH_' + controlID + "_" + i).disabled != true)
                            document.getElementById('ctl00_BodyContentPH_' + controlID + "_" + i).checked = true;
                    }
                }
                else {
                    if (document.getElementById('ctl00_BodyContentPH_' + controlID + "_" + i)) {

                        if (document.getElementById('ctl00_BodyContentPH_' + controlID + "_" + i).disabled != true)
                            document.getElementById('ctl00_BodyContentPH_' + controlID + "_" + i).checked = false;
                    }
                }
            }
        }
        function UnCheckAll(controlID, cbAttendanceAll) {
            var intIndex = 0;
            var flag = 0;
            var rowCount = document.getElementById('ctl00_BodyContentPH_' + controlID).getElementsByTagName("input").length;
            for (i = 0; i < rowCount; i++) {
                if (document.getElementById('ctl00_BodyContentPH_' + controlID + "_" + i)) {
                    if (document.getElementById('ctl00_BodyContentPH_' + controlID + "_" + i).checked == true) {
                        flag = 1;
                    }
                    else {
                        flag = 0;
                        break;
                    }
                }
            }
            if (flag == 0)
                document.getElementById('ctl00_BodyContentPH_' + cbAttendanceAll).checked = false;
            else
                document.getElementById('ctl00_BodyContentPH_' + cbAttendanceAll).checked = true;
        }
        function SelectAllOnThisPage(chkSelectAll) {
            var hdnSelectRow = document.getElementById('<%= hdnSelectRow.ClientID %>');
            var hdnSelectAll = document.getElementById('<%= hdnGetAllid.ClientID %>');
            if (chkSelectAll.checked == true) {
                for (var i = 0; i < grv_EmpDetails.pageRowCount; i++) {
                    if (document.getElementById('ctl00_BodyContentPH_grv_EmpDetails_cell' + (i + grv_EmpDetails.visibleStartIndex) + '_0_chkSelect').disabled == false) {
                        document.getElementById('ctl00_BodyContentPH_grv_EmpDetails_cell' + (i + grv_EmpDetails.visibleStartIndex) + '_0_chkSelect').checked = true;
                        var hdnUserId = document.getElementById('ctl00_BodyContentPH_grv_EmpDetails_cell' + (i + grv_EmpDetails.visibleStartIndex) + '_0_chkSelect').accessKey;
                        var hdnSelectRow = document.getElementById('<%= hdnSelectRow.ClientID %>');
                        var removeId = hdnSelectRow.value.split(",");
                        if (hdnUserId != "" && !Array.contains(removeId, hdnUserId)) {
                            if (hdnSelectRow.value != "")
                                hdnSelectRow.value += ",";
                            hdnSelectRow.value += hdnUserId;
                        }
                    }
                }
            }
            else {
                for (var i = 0; i < grv_EmpDetails.pageRowCount; i++) {
                    document.getElementById('ctl00_BodyContentPH_grv_EmpDetails_cell' + (i + grv_EmpDetails.visibleStartIndex) + '_0_chkSelect').checked = false;
                }
                hdnSelectRow.value = '';
            }
        }
        function SelectOnRow(chkOnSelect) {
            var hdnUserId = chkOnSelect.accessKey;
            var hdnSelectRow = document.getElementById('<%= hdnSelectRow.ClientID %>');
            var removeId = hdnSelectRow.value.split(",");
            if (chkOnSelect.checked) {
                if (hdnUserId != "" && !Array.contains(removeId, hdnUserId)) {
                    if (hdnSelectRow.value != "")
                        hdnSelectRow.value += ",";
                    hdnSelectRow.value += hdnUserId;
                }
                var varTotalCheckedCount = 0;
                var varTotalEnabled = 0;
                for (var i = 0; i < grv_EmpDetails.pageRowCount; i++) {
                    if (document.getElementById('ctl00_BodyContentPH_grv_EmpDetails_cell' + (i + grv_EmpDetails.visibleStartIndex) + '_0_chkSelect').disabled == false) {
                        varTotalEnabled = varTotalEnabled + 1;
                    }
                    if (document.getElementById('ctl00_BodyContentPH_grv_EmpDetails_cell' + (i + grv_EmpDetails.visibleStartIndex) + '_0_chkSelect').checked)
                        varTotalCheckedCount = varTotalCheckedCount + 1;
                }
                if (varTotalCheckedCount == varTotalEnabled)
                    document.getElementById('ctl00_BodyContentPH_grv_EmpDetails_header0_chkSelectAll').checked = true;
                else
                    document.getElementById('ctl00_BodyContentPH_grv_EmpDetails_header0_chkSelectAll').checked = false;
            }
            else {
                if (Array.contains(removeId, hdnUserId)) {
                    Array.remove(removeId, hdnUserId);
                }
                hdnSelectRow.value = removeId;
                document.getElementById('ctl00_BodyContentPH_grv_EmpDetails_header0_chkSelectAll').checked = false;
            }
        }

        function SelectAll(chkSelectAll) {
            debugger;
            var hdnSelectRowAdd = document.getElementById('<%= hdnSelectRowAdd.ClientID %>');
            var hdnGetAllidAdd = document.getElementById('<%= hdnGetAllidAdd.ClientID %>');
            if (chkSelectAll.checked == true) {
                for (var i = 0; i < grdviewAllEmployees.pageRowCount; i++) {
                    if (document.getElementById('ctl00_BodyContentPH_grdviewAllEmployees_cell' + (i + grdviewAllEmployees.visibleStartIndex) + '_0_chkSelect').disabled == false) {
                        document.getElementById('ctl00_BodyContentPH_grdviewAllEmployees_cell' + (i + grdviewAllEmployees.visibleStartIndex) + '_0_chkSelect').checked = true;
                        var hdnUserId = document.getElementById('ctl00_BodyContentPH_grdviewAllEmployees_cell' + (i + grdviewAllEmployees.visibleStartIndex) + '_0_chkSelect').accessKey;
                        var hdnSelectRowAdd = document.getElementById('<%= hdnSelectRowAdd.ClientID %>');
                        var removeId = hdnSelectRowAdd.value.split(",");
                        if (hdnUserId != "" && !Array.contains(removeId, hdnUserId)) {
                            if (hdnSelectRowAdd.value != "")
                                hdnSelectRowAdd.value += ",";
                            hdnSelectRowAdd.value += hdnUserId;
                        }
                    }
                }
            }
            else {
                for (var i = 0; i < grdviewAllEmployees.pageRowCount; i++) {
                    document.getElementById('ctl00_BodyContentPH_grdviewAllEmployees_cell' + (i + grdviewAllEmployees.visibleStartIndex) + '_0_chkSelect').checked = false;
                }
                hdnSelectRowAdd.value = '';
            }
        }
        function SelectParticular(chkOnSelect) {
            var hdnUserId = chkOnSelect.accessKey;
            var hdnSelectRowAdd = document.getElementById('<%= hdnSelectRowAdd.ClientID %>');
            var removeId = hdnSelectRowAdd.value.split(",");
            if (chkOnSelect.checked) {
                if (hdnUserId != "" && !Array.contains(removeId, hdnUserId)) {
                    if (hdnSelectRowAdd.value != "")
                        hdnSelectRowAdd.value += ",";
                    hdnSelectRowAdd.value += hdnUserId;
                }
                var varTotalCheckedCount = 0;
                var varTotalEnabled = 0;
                for (var i = 0; i < grdviewAllEmployees.pageRowCount; i++) {
                    if (document.getElementById('ctl00_BodyContentPH_grdviewAllEmployees_cell' + (i + grdviewAllEmployees.visibleStartIndex) + '_0_chkSelect').disabled == false) {
                        varTotalEnabled = varTotalEnabled + 1;
                    }
                    if (document.getElementById('ctl00_BodyContentPH_grdviewAllEmployees_cell' + (i + grdviewAllEmployees.visibleStartIndex) + '_0_chkSelect').checked)
                        varTotalCheckedCount = varTotalCheckedCount + 1;
                }
                if (varTotalCheckedCount == varTotalEnabled)
                    document.getElementById('ctl00_BodyContentPH_grdviewAllEmployees_header0_chkSelectAll').checked = true;
                else
                    document.getElementById('ctl00_BodyContentPH_grdviewAllEmployees_header0_chkSelectAll').checked = false;
            }
            else {
                if (Array.contains(removeId, hdnUserId)) {
                    Array.remove(removeId, hdnUserId);
                }
                hdnSelectRowAdd.value = removeId;
                document.getElementById('ctl00_BodyContentPH_grdviewAllEmployees_header0_chkSelectAll').checked = false;
            }
        }


    </script>
</asp:Content>


