using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Net.Mail;
using System.Data.SqlClient;
using System.Globalization;
using System.Threading;
using System.Reflection;
using System.Resources;
using System.Net;
/****************************************************************************************************************************
* Project Name    : TimeCheck                    Started Date  : 12-Aug-2007
* Module          : Leave Application            Last Modified : 14-Aug-2007
* Programmer      : Prabakaran.P
* Current Storage : \\Angler56\Projects\Inprogress\SCREEN1206\code\Time_AttendanceApp
* BackUp          :
****************************************************************************************************************************/
public partial class Transactions_TA_UI_Transactions_LeaveApplication : Base.BasePage
{
    #region "Variable Declaration"
    ResourceManager rm;
    CultureInfo ci;
    Cls_CheckUser objCheckUser = new Cls_CheckUser();
    DataSet ds_Checkuser = new DataSet();
    LeaveApplicationEventData objLeaveHolidays = new LeaveApplicationEventData();
    cls_Common objClassCommon = new cls_Common();
    DataSet dsLeaveHolidays = new DataSet();
    DataSet ds_Year = new DataSet();
    LeaveApplicationEventData objLeaveApplicationEventData = new LeaveApplicationEventData();
    PermissionEventData objPermissionEventData = new PermissionEventData();
    DataSet dsEmailIdOfSanctionAuthority = new DataSet();
    DataSet ds_EmailIdOfReportingTo = new DataSet();
    DataSet ds_EmployeeDetails = new DataSet();
    int StartYear, EndYear; string source_Language;
    int iLeaveApplication_Id, iEmployeeID, YearSettingID;
    string strReason = string.Empty, strEmailIdReportingTo, gstrDateFormat, gstrTimeFormat, strlevelName, strStatusType;
    Boolean blnCheckEmail;
    DataSet dsEmployeeGroup = new DataSet();
    int payrollConfig = 0;
    #endregion
    #region Page Load Events
    protected override void Page_Load(object sender, EventArgs e)
    {
        base.Page_Load(sender, e);
        grv_LeaveApplication.Styles.CssFilePath = Convert.ToString(Session["GridCSS"]);
        if (!Page.IsPostBack)
        {
            base.CheckPages(0);
            objClassCommon.menu("LeaveTransaction", "22");
            btn_Add.Focus();
        }
        source_Language = Convert.ToString(Session["Session_ActiveLanguage"]);
        rm = new ResourceManager(source_Language, System.Reflection.Assembly.Load("App_GlobalResources"));
        ci = Thread.CurrentThread.CurrentCulture;
        site.SiteMapProvider = Convert.ToString(Session["SiteMapProvider"]);
        LoadStrings(ci);
        string strSetAlert = "";
        strSetAlert = strSetAlert + "<script language='javascript'>";
        strSetAlert = strSetAlert + "MaxLengthh('" + rm.GetString("Alert_MaximumLengthis", ci) + "');";
        strSetAlert = strSetAlert + "SetAlertMessages('" + rm.GetString("Alert_FillDetails", ci) + "','" + rm.GetString("Alert_FillFromToDate", ci) + "');";
        strSetAlert = strSetAlert + "SetAlertCheckDate('" + rm.GetString("Alert_Validmonthdatefourdigit", ci) + "','" + rm.GetString("Alert_Validdatemonthfourdigit", ci) + "','" + rm.GetString("Alert_Invalidyearentry", ci) + "','" + rm.GetString("Alert_Invalidmonthentry", ci) + "','" + rm.GetString("Alert_Invaliddateentry", ci) + "','" + rm.GetString("Alert_IncorrectdateformatDDMONYYYY", ci) + "','" + rm.GetString("Alert_Entertime", ci) + "','" + rm.GetString("Alert_Invalidvalueforhours", ci) + "','" + rm.GetString("Alert_Invalidvalueforminites", ci) + "','" + rm.GetString("Alert_Invalidtimeformat1", ci) + "','" + rm.GetString("Alert_PleaseentervalidDateandTime", ci) + "','" + rm.GetString("Alert_ValiddatemonthMMDDYYHHMM", ci) + "','" + rm.GetString("Alert_ValiddatemonthMMDDYYHHMMTT", ci) + "','" + rm.GetString("Alert_PleaseentervalidDateandTime", ci) + "','" + rm.GetString("Alert_Invalidvalueforhours", ci) + "','" + rm.GetString("Alert_Invalidvalueforminites", ci) + "');";
        strSetAlert = strSetAlert + "</script>";
        Page.RegisterStartupScript("SetAlertMessages", strSetAlert);
        UserRights();
        Hidden1.Value = Convert.ToString(Session["IDateFormat"]);
        Hidden2.Value = Convert.ToString(Session["ITimeFormat"]);
        ds_Year = objClassCommon.GetYearsetting();
        if (ds_Year.Tables[0].Rows.Count <= 0)
        {
            string strScript = string.Empty;
            strScript = strScript + "<script language='javascript'>";
            strScript = strScript + "alert('" + rm.GetString("Msg_DefineYearSettinginOrganizationSettings", ci) + "');location.replace('../Organization Settings/Organization_YearSetting.aspx')";
            strScript = strScript + "</script>";
            Page.RegisterStartupScript("AlertLeavePolicyYear", strScript);
        }
        else
        {
            StartYear = Convert.ToInt32(ds_Year.Tables[0].Rows[0]["StartYear"]);
            EndYear = Convert.ToInt32(ds_Year.Tables[0].Rows[0]["EndYear"]);
            ViewState["YearSettings_Id"] = Convert.ToString(ds_Year.Tables[0].Rows[0]["YearSettings_Id"]);
            ds_Year.Dispose();
        }
        dsEmployeeGroup = objLeaveApplicationEventData.GetEmployeeGroupName(Convert.ToInt32(Session["EmpAutoId"]));
        if (dsEmployeeGroup.Tables[0].Rows.Count > 0)
        {
            if (Convert.ToString(dsEmployeeGroup.Tables[0].Rows[0]["GroupName"]) == "SuperAdmin" || Convert.ToString(Session["HasSpecialRights"]) == "True")
            {
                grv_LeaveApplication.DataSourceID = "";
                grv_LeaveApplication.DataSourceID = ObjectDataSource2.ID;
                ViewState["GroupName"] = "SuperAdmin";
            }
            else
            {
                grv_LeaveApplication.DataSourceID = ObjectDataSource1.ID;
                grv_LeaveApplication.Columns[2].Visible = false;
                grv_LeaveApplication.Columns[3].Visible = false;
                grv_LeaveApplication.Columns[4].Visible = false;
                ViewState["GroupName"] = "Normal";
            }
        }
        else
        {
            grv_LeaveApplication.DataSourceID = ObjectDataSource1.ID;
            grv_LeaveApplication.Columns[2].Visible = false;
            grv_LeaveApplication.Columns[3].Visible = false;
            grv_LeaveApplication.Columns[4].Visible = false;
            ViewState["GroupName"] = "Normal";
        }
        if (Convert.ToString(ViewState["GroupName"]) == "Normal")
        {
            trSwipeCardNo.Visible = false;
            trEmployeeDetails.Visible = false;
        }
        payrollConfig = objClassCommon.CheckPageExistsInLicense(185);
        if (payrollConfig == 1)
        {
            grv_LeaveApplication.Columns[10].Visible = false;
            grv_LeaveApplication.Columns[11].Visible = true;
            grv_LeaveApplication.Columns[12].Visible = false;
        }
    }
    #endregion
    #region ButtonEvents
    protected void btn_Add_Click(object sender, EventArgs e)
    {
        int payrollConfig = 0;
        payrollConfig = objClassCommon.CheckPageExistsInLicense(185);
        /*Below parameter is used for Angler 1 ! 0*/
        if (payrollConfig == 1)
            Response.Redirect("TA_UI_Transactions_MultipleLeaveApplicationAdd.aspx");
        else
            Response.Redirect("TA_UI_Transactions_LeaveApplicationAdd.aspx");
    }
    protected void btn_Clear_Click(object sender, EventArgs e)
    {
        grid_RestoreDefault();
        lbl_Error.Text = string.Empty;
    }
    protected void btn_Search_Click(object sender, EventArgs e)
    {
        FillGrid_Search();
        Thread.Sleep(1000);
    }
    #endregion
    #region UserDefinedFunctions
    private void LoadStrings(CultureInfo ci)
    {
        lbl_Header.Text = rm.GetString("Transactions_LeaveApplication", ci);
        lbl_EmployeeName.Text = rm.GetString("Field_EmployeeName", ci);
        lbl_EmployeeId.Text = rm.GetString("Field_EmployeeID", ci);
        lblTimePeriod.Text = rm.GetString("ShiftExchange_DateRange", ci);
        lblLeaveStartDate.Text = rm.GetString("Field_From", ci);
        lblLeaveEndDate.Text = rm.GetString("Field_To", ci);
        lblTimePeriod.Text = rm.GetString("ShiftExchange_DateRange", ci);
        btn_Search.Text = "&nbsp;&nbsp;" + rm.GetString("btn_Search", ci);
        btn_Clear.Text = "&nbsp;&nbsp;" + rm.GetString("btn_Clear", ci);
        btn_Add.Text = "&nbsp;&nbsp;" + rm.GetString("btn_Add", ci);
        grv_LeaveApplication.Columns[1].Caption = rm.GetString("LeaveApplication_LeaveApplicationDate", ci);
        grv_LeaveApplication.Columns[2].Caption = rm.GetString("Field_EmployeeID", ci);
        grv_LeaveApplication.Columns[3].Caption = rm.GetString("Field_EmployeeName", ci);
        grv_LeaveApplication.Columns[4].Caption = rm.GetString("LevelDetails_LevelName", ci);
        grv_LeaveApplication.Columns[5].Caption = rm.GetString("Report_Duration", ci);
        grv_LeaveApplication.Columns[6].Caption = rm.GetString("Type_Of_Leave", ci);
        grv_LeaveApplication.Columns[7].Caption = rm.GetString("Field_Status", ci);
        grv_LeaveApplication.Columns[8].Caption = rm.GetString("Field_Reason", ci);
        grv_LeaveApplication.Columns[9].Caption = rm.GetString("email_Remarks", ci);
        lblEmpSwipe.Text = rm.GetString("TerminalDataType_Card_No", ci);
        lblFilter.Text = rm.GetString("lblFilter", ci);
        lblDataView.Text = rm.GetString("lblDataView", ci);
    }
    public void GetEmptyText(object sender, EventArgs e)
    {
        Label lblNoRecords = (Label)sender;
        lblNoRecords.Text = rm.GetString("Alert_Norecordsfound", ci);
    }
    private void UserRights()
    {
        ds_Checkuser = objCheckUser.checkRights(22, Convert.ToInt32(Session["userGroup_Id"]), "");
        if (ds_Checkuser.Tables[0].Rows.Count > 0)
        {
            if (ds_Checkuser.Tables[0].Rows[0]["addPrv"] != DBNull.Value && Convert.ToInt32(ds_Checkuser.Tables[0].Rows[0]["addPrv"]) == 1)
            {
                this.btn_Add.Visible = true;
            }
            else
            {
                this.btn_Add.Visible = false;
            }
            if (ds_Checkuser.Tables[0].Rows[0]["viewPrv"] != DBNull.Value && Convert.ToInt32(ds_Checkuser.Tables[0].Rows[0]["viewPrv"]) == 1)
            {
                if (payrollConfig == 1)
                {
                    this.grv_LeaveApplication.Columns[11].Visible = true;
                    this.grv_LeaveApplication.Columns[10].Visible = false;
                }
                else
                {
                    this.grv_LeaveApplication.Columns[11].Visible = false;
                    this.grv_LeaveApplication.Columns[10].Visible = true;
                }
            }
            else
            {
                if (payrollConfig == 1)
                {
                    this.grv_LeaveApplication.Columns[11].Visible = false;
                    this.grv_LeaveApplication.Columns[10].Visible = false;
                }
                else
                {
                    this.grv_LeaveApplication.Columns[11].Visible = false;
                    this.grv_LeaveApplication.Columns[10].Visible = false;
                }
            }
            if (ds_Checkuser.Tables[0].Rows[0]["deletePrv"] != DBNull.Value && Convert.ToInt32(ds_Checkuser.Tables[0].Rows[0]["deletePrv"]) == 1)
            {
                this.grv_LeaveApplication.Columns[12].Visible = true;
            }
            else
            {
                this.grv_LeaveApplication.Columns[12].Visible = false;
            }
        }
        else
        {
            Response.Redirect("TransactionLandingPage.aspx");
        }
    }
    private void grid_RestoreDefault()
    {
        txt_EmpName.Text = string.Empty;
        txtEmployeeId.Text = string.Empty;
        txtLeaveStartDate.Text = string.Empty;
        txtLeaveEndDate.Text = string.Empty;
        txtSwipeCard.Text = string.Empty;
        grv_LeaveApplication.PageIndex = 0;
        if (Convert.ToString(ViewState["GroupName"]) == "SuperAdmin")
            grv_LeaveApplication.DataSourceID = ObjectDataSource2.ID;
        else
            grv_LeaveApplication.DataSourceID = ObjectDataSource1.ID;
    }
    private void FillGrid_Search()
    {
        string empName = txt_EmpName.Text.Trim();
        txt_EmpName.Text = empName;
        string empId = txtEmployeeId.Text.Trim();
        txtEmployeeId.Text = empId;
        string strLeaveStartDate;
        string strLeaveEndDate;
        bool boolErrorStatus = true;
        string gstrDateFormat = Convert.ToString(Session["MDateFormat"]);
        strLeaveStartDate = objClassCommon.DateConvertion(gstrDateFormat, Convert.ToString(txtLeaveStartDate.Text));
        strLeaveEndDate = objClassCommon.DateConvertion(gstrDateFormat, Convert.ToString(txtLeaveEndDate.Text));
        string strSwipeCard = "";
        strSwipeCard = Convert.ToString(txtSwipeCard.Text).Trim().Replace("'", "''");
        if (strLeaveStartDate == string.Empty && strLeaveEndDate == string.Empty)
        {
            boolErrorStatus = false;
        }
        else if (strLeaveStartDate != string.Empty && strLeaveEndDate != string.Empty)
        {
            if (Convert.ToDateTime(strLeaveEndDate).Date < Convert.ToDateTime(strLeaveStartDate).Date)
            {
                base.Message(rm.GetString("Alert_FromDateLessThanToDate"));
                grv_LeaveApplication.DataSourceID = "";
                return;
                boolErrorStatus = true;
            }
            else
            {
                boolErrorStatus = false;
            }
        }
        if (boolErrorStatus == true)
        {
            grid_RestoreDefault();
        }
        else
        {
            lbl_Error.Text = string.Empty;
            grv_LeaveApplication.PageIndex = 0;
            if (Convert.ToString(ViewState["GroupName"]) == "SuperAdmin")
                grv_LeaveApplication.DataSourceID = ObjectDataSource2.ID;
            else
                grv_LeaveApplication.DataSourceID = ObjectDataSource1.ID;
        }
    }
    #endregion
    #region GridveiwEvents
    protected void grv_LeaveApplication_HtmlRowCreated(object sender, DevExpress.Web.ASPxGridViewTableRowEventArgs e)
    {
        base.Page_Load(sender, e);
        if (e.RowType == DevExpress.Web.GridViewRowType.Data)
        {
            source_Language = Convert.ToString(Session["Session_ActiveLanguage"]);
            rm = new ResourceManager(source_Language, System.Reflection.Assembly.Load("App_GlobalResources"));
            ci = Thread.CurrentThread.CurrentCulture;
            string appdate = Convert.ToString(e.GetValue("Leave_ApplicationDate"));
            Label lbl_Status = (Label)grv_LeaveApplication.FindRowCellTemplateControl(e.VisibleIndex, null, "lbl_Status");
            if (lbl_Status.Text == "Approved")
            {
                lbl_Status.Text = rm.GetString("btn_Approved", ci);
            }
            else if (lbl_Status.Text == "Forwarded")
            {
                lbl_Status.Text = rm.GetString("btn_Forwarded", ci);
            }
            else if (lbl_Status.Text == "Pending")
            {
                lbl_Status.Text = rm.GetString("btn_Pending", ci);
            }
            else if (lbl_Status.Text == "Rejected")
            {
                lbl_Status.Text = rm.GetString("btn_Reject", ci);
            }
            Label lbl_LeaveType = (Label)grv_LeaveApplication.FindRowCellTemplateControl(e.VisibleIndex, null, "lbl_LeaveType");
            if (lbl_LeaveType.Text == "Restricted Holiday")
            {
                lbl_LeaveType.Text = rm.GetString("Holiday_RestrictedHoliday", ci);
            }
            else if (lbl_LeaveType.Text == "Comp Off")
            {
                lbl_LeaveType.Text = rm.GetString("Caption_CompOff", ci);
            }
            else if (lbl_LeaveType.Text.Contains("LOP"))
            {
                lbl_LeaveType.Text = lbl_LeaveType.Text.Replace("LOP", rm.GetString("lbl_LOP", ci));
            }
            else if (lbl_LeaveType.Text == "ESI")
            {
                lbl_LeaveType.Text = rm.GetString("Caption_ESI", ci);
            }
            else if (lbl_LeaveType.Text.Contains("Leave"))
            {
                lbl_LeaveType.Text = lbl_LeaveType.Text.Replace("Leave", rm.GetString("LeaveApplication_Leave", ci));
            }
        }
    }
    #endregion
    protected void btn_delete_Click_1(object sender, EventArgs e)
    {
        LinkButton btn = sender as LinkButton;
        iLeaveApplication_Id = Convert.ToInt32(btn.CommandName);
        ViewDetails();
        ViewState["EmpID"] = btn.ValidationGroup.ToString();
        ViewState["EmpName"] = btn.CommandArgument;
        string strLeaveStatus = string.Empty;
        int approvalSettingsPageExists = 0;
        if (payrollConfig == 1)
            approvalSettingsPageExists = objClassCommon.CheckPageExistsInLicense(110);
        else
            approvalSettingsPageExists = objClassCommon.CheckPageExistsInLicense(228);
        if (approvalSettingsPageExists == 1)
        {
            //Get Compnay Id of the Employeee
            int intCompanyId = base.GetCompanyId(Convert.ToInt32(ViewState["iEmployeeID"]));
            //Get Approval Settings Based on Company Id
            DataSet dsApprovalSettings = new DataSet();
            ShiftEvenData objShift = new ShiftEvenData();
            dsApprovalSettings = objShift.SelectApprovalSettings(intCompanyId);
            if (dsApprovalSettings != null)
            {
                if (dsApprovalSettings.Tables.Count > 0)
                {
                    if (dsApprovalSettings.Tables[0].Rows.Count > 0)
                    {
                        if (payrollConfig == 1)
                        {
                            if (Convert.ToBoolean(dsApprovalSettings.Tables[0].Rows[0]["LeaveSanction"]) == false)
                                strLeaveStatus = "ApprovalNotRequired";
                        }
                        else
                        {
                            if (Convert.ToBoolean(dsApprovalSettings.Tables[0].Rows[0]["Approval"]) == false)
                                strLeaveStatus = "ApprovalNotRequired";
                        }
                    }
                    else
                    {
                        base.Message(rm.GetString("Msg_ApprovalSettings", ci));
                        return;
                    }
                }
            }
        }
        else
        {
            strLeaveStatus = "ApprovalNotRequired";
        }
        if (ViewState["StatusOfApplication"].ToString() == "Rejected")
        {
            if (Convert.ToString(Session["UserGroupName"]) == "SuperAdmin" || Convert.ToString(Session["HasSpecialRights"]) == "True")
            {
                if (payrollConfig == 1)
                {
                    objLeaveApplicationEventData.Delete_LeaveApplication(iLeaveApplication_Id, Convert.ToInt32(Session["EmpAutoId"]));
                    //Update Year Closure
                    RedirectToLandingPage();
                }
                else
                {
                    if (Convert.ToString(Session["IndividualUsers"]) == "True")
                    {
                        Page.RegisterStartupScript("statusalert", "<script language='javascript'>alert('Rejected Leave Application Cannot be Deleted');</script>");
                    }
                    else
                    {
                        objLeaveApplicationEventData.Delete_LeaveApplication(iLeaveApplication_Id, Convert.ToInt32(Session["EmpAutoId"]));
                        RedirectToLandingPage();
                    }
                }
            }
            else
            {
                Page.RegisterStartupScript("statusalert", "<script language='javascript'>alert('Rejected Leave Application Cannot be Deleted');</script>");
            }
        }
        else if (ViewState["StatusOfApplication"].ToString() == "Pending" || strLeaveStatus == "ApprovalNotRequired")
        {
            //Check Borrow Leave Exists after normal leaves
            int intBorrowCount = objLeaveApplicationEventData.CheckBorrowLeaveExists(ViewState["LeaveFromDate"].ToString(), ViewState["LeaveToDate"].ToString(), Convert.ToInt32(ViewState["LeaveTypeId"]), Convert.ToInt32(ViewState["iEmployeeID"]));
            if (intBorrowCount > 0)
            {
                base.Message(rm.GetString("Msg_BorrowLeavesareavailabletodelete", ci));
                return;
            }
            //Delete Leave Application
            objLeaveApplicationEventData.Delete_LeaveApplication(iLeaveApplication_Id, Convert.ToInt32(Session["EmpAutoId"]));
            //Update Year Closure
            YearClosureUpdate(strLeaveStatus);
            if (ConfigurationManager.AppSettings.Get("MailNotificationRequired") != null)
                if (Convert.ToInt16(ConfigurationManager.AppSettings.Get("MailNotificationRequired")) == 1)
                {
                    //Added Newly by Manikandan.RR on 10-06-2015 11.38 AM
                    MailToReportingTo();
                }
            RedirectToLandingPage();
        }
        else
        {
            if (Convert.ToString(Session["UserGroupName"]) == "SuperAdmin" || Convert.ToString(Session["HasSpecialRights"]) == "True")
            {
                if (payrollConfig == 1)
                {
                    //Check Borrow Leave Exists after normal leaves
                    int intBorrowCount = objLeaveApplicationEventData.CheckBorrowLeaveExists(ViewState["LeaveFromDate"].ToString(), ViewState["LeaveToDate"].ToString(), Convert.ToInt32(ViewState["LeaveTypeId"]), Convert.ToInt32(ViewState["iEmployeeID"]));
                    if (intBorrowCount > 0)
                    {
                        base.Message(rm.GetString("Msg_BorrowLeavesareavailabletodelete", ci));
                        return;
                    }
                    //Delete Leave Application
                    objLeaveApplicationEventData.Delete_LeaveApplication(iLeaveApplication_Id, Convert.ToInt32(Session["EmpAutoId"]));
                    //Update Year Closure
                    YearClosureUpdate(strLeaveStatus);
                    if (ConfigurationManager.AppSettings.Get("MailNotificationRequired") != null)
                        if (Convert.ToInt16(ConfigurationManager.AppSettings.Get("MailNotificationRequired")) == 1)
                        {
                            MailToReportingTo();
                        }
                    RedirectToLandingPage();
                }
                else
                {
                    if (Convert.ToString(Session["IndividualUsers"]) == "True")
                    {
                        Page.RegisterStartupScript("statusalert", "<script language='javascript'>alert('" + rm.GetString("Alert_Cannotdeletethisrecordd", ci) + "');</script>");
                    }
                    else
                    {
                        //Check Borrow Leave Exists after normal leaves
                        int intBorrowCount = objLeaveApplicationEventData.CheckBorrowLeaveExists(ViewState["LeaveFromDate"].ToString(), ViewState["LeaveToDate"].ToString(), Convert.ToInt32(ViewState["LeaveTypeId"]), Convert.ToInt32(ViewState["iEmployeeID"]));
                        if (intBorrowCount > 0)
                        {
                            base.Message(rm.GetString("Msg_BorrowLeavesareavailabletodelete", ci));
                            return;
                        }
                        //Delete Leave Application
                        objLeaveApplicationEventData.Delete_LeaveApplication(iLeaveApplication_Id, Convert.ToInt32(Session["EmpAutoId"]));
                        //Update Year Closure
                        YearClosureUpdate(strLeaveStatus);
                        if (ConfigurationManager.AppSettings.Get("MailNotificationRequired") != null)
                            if (Convert.ToInt16(ConfigurationManager.AppSettings.Get("MailNotificationRequired")) == 1)
                            {
                                MailToReportingTo();
                            }
                        RedirectToLandingPage();
                    }
                }
            }
            else
            {
                Page.RegisterStartupScript("statusalert", "<script language='javascript'>alert('" + rm.GetString("Alert_Cannotdeletethisrecordd", ci) + "');</script>");
            }
        }
    }
    private void RedirectToLandingPage()
    {
        string strScript = "";
        strScript = strScript + "<script language='javascript'>";
        strScript = strScript + "alert('" + rm.GetString("Alert_LeaveApplicationDeleted", ci) + "');";
        strScript = strScript + "location.replace('TA_UI_Transactions_LeaveApplication.aspx');";
        strScript = strScript + "</script>";
        //Dispaly alert messsage.
        Page.RegisterStartupScript("AlertLDel65507866", strScript);
    }
    public void ViewDetails()
    {
        DataSet ds_LeaveApplication = new DataSet();
        ds_LeaveApplication = objLeaveApplicationEventData.SelectLeaveApplication(iLeaveApplication_Id);
        iEmployeeID = Convert.ToInt32(ds_LeaveApplication.Tables[0].Rows[0]["Employee_Id"]);
        YearSettingID = Convert.ToInt32(ds_LeaveApplication.Tables[0].Rows[0]["YearSettings_Id"]);
        ViewState["iEmployeeID"] = iEmployeeID.ToString();
        ViewState["StatusOfApplication"] = ds_LeaveApplication.Tables[0].Rows[0]["Status"].ToString();
        ViewState["lblType"] = ds_LeaveApplication.Tables[0].Rows[0]["Type"].ToString();
        ViewState["LeaveTypeId"] = ds_LeaveApplication.Tables[0].Rows[0]["LeaveType_Id"].ToString();
        ViewState["LeaveFromDate"] = ds_LeaveApplication.Tables[0].Rows[0]["Leave_FromDate"].ToString();
        ViewState["LeaveToDate"] = ds_LeaveApplication.Tables[0].Rows[0]["Leave_ToDate"].ToString();
        ViewState["IsBorrow"] = ds_LeaveApplication.Tables[0].Rows[0]["IsBorrow"].ToString();
        ViewState["NumberOfDays"] = ds_LeaveApplication.Tables[0].Rows[0]["NumberOfDays"].ToString();
        ViewState["Application_Date"] = ds_LeaveApplication.Tables[0].Rows[0]["Leave_ApplicationDate"].ToString();
        ViewState["Leave_Reason"] = ds_LeaveApplication.Tables[0].Rows[0]["Reason"].ToString();
        ViewState["Leave_Type"] = ds_LeaveApplication.Tables[0].Rows[0]["LeaveType"].ToString();
        ViewState["From_session"] = ds_LeaveApplication.Tables[0].Rows[0]["Leave_SessionFrom"].ToString();
        ViewState["To_session"] = ds_LeaveApplication.Tables[0].Rows[0]["Leave_SessionTo"].ToString();
    }
    public void YearClosureUpdate(string strLeaveStatus)
    {
        if (strLeaveStatus == "ApprovalNotRequired")
        {
            int Employee_Id = Convert.ToInt32(ViewState["iEmployeeID"]);
            string strTypeOfLeave = ViewState["lblType"].ToString();
            if (strTypeOfLeave == "Leave")
            {
                double NumberOfDays = Convert.ToDouble(ViewState["NumberOfDays"]);
                int LeaveTypeId = Convert.ToInt32(ViewState["LeaveTypeId"]);
                if (Convert.ToBoolean(ViewState["IsBorrow"]) == false)
                {
                    objLeaveApplicationEventData.UpdateYearClosureByLeaveSanction(NumberOfDays, LeaveTypeId, Employee_Id, "R", Convert.ToInt32(Session["EmpAutoId"]), YearSettingID);
                }
                else
                {
                    objLeaveApplicationEventData.UpdateYearClosureByLeaveSanction(NumberOfDays, LeaveTypeId, Employee_Id, "RB", Convert.ToInt32(Session["EmpAutoId"]), YearSettingID);
                }
            }
            // Update Processed Data Flag for Re-Processing
            objLeaveApplicationEventData.UpdateProcessedDataFlag(Employee_Id, ViewState["LeaveFromDate"].ToString(), ViewState["LeaveToDate"].ToString(), 0);
        }
    }
    private void MailToReportingTo()
    {
        string strEmployeeEmailId = string.Empty;
        ds_EmployeeDetails = objLeaveApplicationEventData.GetEmployeeDetails(Convert.ToInt32(ViewState["iEmployeeID"]));
        if (ds_EmployeeDetails.Tables[0].Rows.Count > 0)
        {
            ViewState["EmpID"] = Convert.ToString(ds_EmployeeDetails.Tables[0].Rows[0]["Employee_Code_Id"]);
            ViewState["EmpName"] = Convert.ToString(ds_EmployeeDetails.Tables[0].Rows[0]["Employee_FirstName"]) + " " + Convert.ToString(ds_EmployeeDetails.Tables[0].Rows[0]["Employee_LastName"]);
            strlevelName = Convert.ToString(ds_EmployeeDetails.Tables[0].Rows[0]["levelName"]);
            strEmployeeEmailId = Convert.ToString(ds_EmployeeDetails.Tables[0].Rows[0]["emailId"]);
            objClassCommon.PrepareEmailContentForMailTriggering
            (
                Convert.ToString(ViewState["EmpID"]),
                Convert.ToString(ViewState["EmpName"]),
                strlevelName,
                "",
                "",
                "",
                Convert.ToString(ViewState["Leave_Reason"]),
                strEmployeeEmailId,
                "Deleted",
                "",
                "",
                "",
                "",
                "",
                Convert.ToString(ViewState["Leave_Type"]),
                (DateTime.Parse(Convert.ToString(ViewState["Application_Date"]))).ToString(Session["MDateFormat"].ToString()),
                (DateTime.Parse(Convert.ToString(ViewState["LeaveFromDate"]))).ToString(Session["MDateFormat"].ToString()),
                (DateTime.Parse(Convert.ToString(ViewState["LeaveToDate"]))).ToString(Session["MDateFormat"].ToString()),
                Convert.ToString(ViewState["From_session"]),
                Convert.ToString(ViewState["To_session"]),
                Convert.ToString(ViewState["NumberOfDays"]),
                "",
                "",
                "LeaveApplication",
                Convert.ToInt32(ViewState["iEmployeeID"])
            );
        }
    }
}
